/*
 * Description: UCM6100 WebGUI
 *
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 */
var $P = top.$;

var upload_Filename = ""; // will be updated by upload_form.html
var starteduploading = 0;
var upload_Path; // path for 'uploads' as defined in http.conf - this variable will be automatically updated from http.conf

var onUploadForm_load = function ()
{
    var upload_action_path = (top.sessionData.httpConf.prefix) ? '/' + top.sessionData.httpConf.prefix + '/backups' : '/backups';  
    _$('uploadiframe').contentWindow.document.getElementById('form22').action = upload_action_path;
};

var file_exist = function(fname)
{
    var res = true;
    if (parent.mWindow.fileArray != undefined) {
        parent.mWindow.fileArray.each(function(file){
            if ( fname == file.filename )
            { 
                res = false;
                return res;
            }
        });
    }
    return res;
}

var onUploadForm_beforeUploading = function ()
{
    var tmp_fname = upload_Filename;
    if (tmp_fname.endsWith('.tar') && /^[-a-zA-Z0-9_]+$/.test(tmp_fname.rChop('.tar')) == true)
    {

        var res = file_exist(tmp_fname.rChop('.tar'));
                
        if (res)
        {
            top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG866")});
        }
        else
        {
            top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG2146") });
        }
        
        return res;
    } 
    else
    {
        top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG850") });
        return false;
    }
};

window.onload = function()
{
    $P.lang(document, true);
    return false;
};
