/*
 * Description: UCM6100 WebGUI
 *
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 */
$P = top.$;

var set_time = function(){
    top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG904") });
    setTimeout(function(){
        var time2set = $('#setsystime').val();
    
        $.ajax({
            type : 'GET',
            url : '../webcgi?action=systemcmdwithoutput&sh /usr/bin/ntpd_service.sh setsystime "' + time2set +'"',
            async: false,
            success : function(response) {
                var result = eval("(" + response + ")").body;
                // reset systime timer
                top.sessionData.systime.stoptimer = true;
                top.dialog.clearDialog();
                top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG945") });
            }
        });
    }, 100);
};

window.onload = function ()
{
    $P.lang(document, true);
    top.document.title = $P.lang("LANG584").format(top.model_info.model_name, $P.lang("LANG2502"));
    $("title").attr("locale", "LANG2502");

    if ($("#form").tooltip) {
        $("#form").tooltip();
    }
    $P("#form", document).validate({
        rules: {
            "setsystime" : {
                required: true,
                customCallback: [$P.lang("LANG2503"), function(val, ele){
                    // 2008-05-23 01:01:01
                    return val.match(/^\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}$/);
                }],
                customCallback1: [$P.lang("LANG2504") , function(val, ele){
                    var arr = val.split(' ');
                    var yymmdd = arr[0].split('-');
                    var hhmiss = arr[1].split(':');
                    do{
                        if(parseInt(yymmdd[1], 10) > 12 || parseInt(yymmdd[1], 10) < 1){
                            break;
                        }

                        if(parseInt(yymmdd[2], 10) > 31 || parseInt(yymmdd[2], 10) < 1){
                            break;
                        }

                        if(parseInt(hhmiss[0], 10) > 23 || parseInt(hhmiss[0], 10) < 0){
                            break;
                        }

                        if(parseInt(hhmiss[1], 10) > 59 || parseInt(hhmiss[1], 10) < 0){
                            break;
                        }

                        if(parseInt(hhmiss[2], 10) > 59 || parseInt(hhmiss[2], 10) < 0){
                            break;
                        }

                        return true;

                    }while(0);
                                
                    return false;
                }]
            }
        },
        submitHandler: function() {
            set_time(); 
        }
    });
}

