/*
 * Description: UCM6100 WebGUI
 *
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 */
$P = top.$;
var mWindow = window;
var edit_context;

var additional_opts = [
    { 
        context: ASTGUI.contexts.ExtFax,
        idname: 'chk_additional_fax'
    },
    { 
        context: ASTGUI.contexts.VoiceMailGroups,
        idname: 'chk_additional_vmgroups'
    },
    { 
        context: ASTGUI.contexts.VoiceMenuExtensions,
        idname: 'chk_additional_ivr'
    },
    { 
        context: ASTGUI.contexts.CONFERENCES,
        idname: 'chk_additional_conf'
    },
    { 
        context: ASTGUI.contexts.QUEUES,
        idname: 'chk_additional_queue'
    },
    { 
        context: ASTGUI.contexts.ExtGroup,
        idname: 'chk_additional_ringgroup'
    },
    { 
        context: ASTGUI.contexts.ExtPaging,
        idname: 'chk_additional_paging'
    }
];

window.onload = function ()
{
    $P.lang(document, true);
    //top.document.title = $P.lang("LANG584").format(top.model_info.model_name, $P.lang("LANG753"));
    loadDOMelements();
    initForm();
    return false;
};


var loadDOMelements = function ()
{

};

var initForm = function ()
{
    var resetFields = []; 
    //append additional options to reset fields
    for ( var i = 0, len = additional_opts; i < len; i++)
    {
        resetFields.push(additional_opts[i].idname);
    }
    ASTGUI.resetTheseFields(resetFields);

    mWindow = top.window.frames["mainscreen"]; // this will be the main window 
    edit_context = mWindow.selectedContext;  
    var context_conf = context2json({
        filename: 'extensions.conf',
        context: edit_context,
        usf: 0
    });

    // update checked
    context_conf.each( function( item ) {
        for (var i = 0, len = additional_opts.length; i < len; i++)
        {
            if (item.contains(additional_opts[i].context))
            {
                $('#' + additional_opts[i].idname).attr('checked', 'checked');
                break;
            }
            else if (item.contains('outbound-allroutes'))
            {
                $('#edit_itrl_dial_trunk').attr('checked', 'checked');
            }
        }
        
    });
    top.Custom.init(document);
};


var saveForm = function ()
{
    var actions = new listOfSynActions('extensions.conf');
    actions.new_action('delcat', edit_context, '', '');
    actions.new_action('newcat', edit_context, '', '');
    actions.new_action('append', edit_context, 'include', 'ext-local');   // always include ext-local

    for ( var i = 0, len = additional_opts.length; i < len; i++)
    {
        if ( $('#' + additional_opts[i].idname + ':checked').length )
        {
            actions.new_action('append', edit_context, 'include', additional_opts[i].context);
        }
    }
    if ($('#edit_itrl_dial_trunk:checked').length)
    {
        actions.new_action('append', edit_context, 'include', 'outbound-allroutes');
    }
    var resp = actions.callActions();
    if (!resp.contains('Response: Success'))
    {
        top.dialog.clearDialog();
        top.dialog.dialogMessage({ type: 'error', content: $P.lang("LANG861") });
    }
    top.dialog.clearDialog();
    top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG815") });

};

