/*
* Asterisk-GUI  - an Asterisk configuration interface
*
* Login functions and other misc functions for index.html
*
* Copyright (C) 2006-2011, Digium, Inc.
*
* Pari Nannapaneni <pari@digium.com>
* Erin Spiceland <espiceland@digium.com>
*
* See http://www.asterisk.org for more information about
* the Asterisk project. Please do not directly contact
* any of the maintainers of this project for assistance;
* the project provides a web site, mailing lists and IRC
* channels for your use.
*
* This program is free software, distributed under the terms of
* the GNU General Public License Version 2. See the LICENSE file
* at the top of the source tree.
*
*/
/*
 * Description: UCM6100 WebGUI
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 * Modifications:
 * modify some function       
 *        
 */
$P = top.$;
var mWindow = parent.window.frames["mainscreen"];
// Object to store all sequence of functions that should execute on login
var DOM_accordion_div_flag = 0;
var zeroconfigErr = {
    "1": "LANG918",
    "2": "LANG919",
    "3": "LANG920",
    "4": "LANG2538"

};
var timeOut;
var monthArr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
function getSysTime(){
    $.ajax({ 
        type: 'GET',
        url: '../webcgi',
        data: "action=getSystemStatus&system-time=", 
        success: function(res){
            if (res.response == "success") {
                var sysTime = res.body["system-time"];
                showSysTime(sysTime);
            }
            // else {
            //     getHeaderTime();
            // }
        }
    });
}
function getHeaderTime() {
    var xmlHttp = false;
    //Get server time
    try {
        xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
    } 
    catch (e) {
        try {
            xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
        } 
        catch (e2) {
            xmlHttp = false;
        }
    }
    if (!xmlHttp && typeof XMLHttpRequest != 'undefined') {
        xmlHttp = new XMLHttpRequest();
    }
    xmlHttp.open("GET", "", false);
    xmlHttp.setRequestHeader("Range", "bytes=-1");
    xmlHttp.send(null);
    var sysTime = xmlHttp.getResponseHeader('Date');
    var sysTimeArr = sysTime.split(" ");
    sysTimeStr = sysTimeArr[3] + "-" + sysTimeArr[2] + "-" + sysTimeArr[1] + " " + sysTimeArr[4] + " " + sysTimeArr[5];
    showSysTime(sysTimeStr); 
}
function addZero(num) {
    num=Math.floor(num);
    return ((num <= 9) ? ("0" + num) : num);
}
function showSysTime(sysTime) {
    //Get client time
    var date = new Date();
    var dateArr = date.toString().split(" ");
    $(".sysTime").text(sysTime);
    var sysTimeArr = sysTime.split(" ");

    var yearMonthDay = sysTimeArr[0].split("-");
    var hourMinSecond = sysTimeArr[1];
    var dateUtc = sysTimeArr[2];
    if ($.browser.msie) {
        dateArr[5] = yearMonthDay[0];
        dateArr[2] = yearMonthDay[2];
        dateArr[3] = hourMinSecond;
    }
    else {
        dateArr[3] = yearMonthDay[0];
        dateArr[2] = yearMonthDay[2];
        dateArr[4] = hourMinSecond;
    }
    if ($.browser.msie || $.browser.safari) {
        dateArr[1] = monthArr[parseInt(yearMonthDay[1], 10) - 1];
    }
    else {
        dateArr[1] = yearMonthDay[1];
    }
    dateArr = dateArr.join(" ");
    //Get server time
    severtime = new Date(dateArr);
    var year = severtime.getFullYear();
    var month = severtime.getMonth()+1;
    var day = severtime.getDate();
    var hour = severtime.getHours();
    var minu = severtime.getMinutes();
    var seco = severtime.getSeconds();
    //Obtain time difference 
    var jtime = Math.abs(date.getTime() - severtime.getTime());
    var jdate = jtime/(24*60*60*1000);
    var jhour = jtime%(24*60*60*1000)/(60*60*1000);
    var jminu = jtime%(24*60*60*1000)%(60*60*1000)/(60*1000);
    var jsecond = jtime%(24*60*60*1000)%(60*60*1000)%(60*1000)/1000;
    //Formatted output server time 
    var getSeverTime = function () {
        seco++;
        if(seco == 60){
            minu+=1;
            seco=0;
        }
        if(minu == 60){
           hour += 1;
           minu = 0;
        }
        if(hour == 24){
            day += 1;
            hour = 0;
        }
        //Date processing
        if(month == 1 || month == 3 || month == 5 || month == 7 || month == 8 || month == 10 || month == 12) {
            if(day == 32)
            {
                day = 1;
                month += 1;
            }
        }
        if(month == 4 || month == 6 || month == 9 || month == 11){
            if(day == 31){
                day = 1;
                month += 1;
            }
        }
        else if(month == 2){
            if((year%4 == 0) && (year%100 != 0) || (year%400 == 0)){//Leap year deal
                if(day == 30){
                    day = 1;
                    month += 1;
                }
            }
            else{
                if(day == 29){
                    day = 1;
                    month += 1;
                }
            }
        }
        if(month == 13){
            year += 1;
            month = 1;
        }
        sseco = addZero(seco);
        sminu = addZero(minu);
        shour = addZero(hour);
        sdate = addZero(day);
        smonth = addZero(month);
        syear = year;

        top.$(".sysTime").text(syear + "-" + smonth + "-" + sdate + " " + shour + ":" + sminu + ":" + sseco + " " + dateUtc);
        if(typeof top.sessionData.systime === "undefined"){
           top.sessionData.systime = {};
           top.sessionData.systime.stoptimer = false;
        }
        if(top.sessionData.systime.stoptimer){
           top.sessionData.systime.stoptimer = false;
           getSysTime();
        }
        else{
            timeOut = setTimeout(function () {
                getSeverTime();    
            },1000);
        }
    } 
    getSeverTime();
}
var onLogInFunctions = {
    makePings: {
        noServer: function ()
        {
            try
            {
                //top.log.debug("PING Request: REQUEST FAILED ");
                if (onLogInFunctions.makePings.isRetryPing)
                {
                    top.dialog.dialogMessage({ type: 'error', content: $P.lang("LANG987") });
                } 
                else
                {
                    onLogInFunctions.makePings.stop();
                    _$('noResponseFromServer').style.height = document.body.scrollHeight;
                    $('#noResponseFromServer').show();
                    $('#mainscreen').hide();
                }
            }
            catch (err)
            {
                top.dialog.dialogMessage({ type: 'error', content: $P.lang("LANG986") });
            }
            finally
            {
                dialog.clearDialog();
            }
        },
        makeRetryPing: function ()
        {
            onLogInFunctions.makePings.isRetryPing = true;
            $.ajax({
                type: 'GET',
                url: '../../infocgi',
                data: 'action=ping',
                success: function (t)
                {
                    if (t.toLowerCase().contains('pong'))
                    { // if session still alive resume making pings
                        onLogInFunctions.makePings.start();
                        $('#noResponseFromServer').hide();
                        //dialog.clearDialog();
                        $('#mainscreen').show();
                    } else
                    {
                        //top.log.debug('PING Request: INVALID SESSION');
                        if (sessionData.DEBUG_MODE)
                        {
                            alert('PING Request: INVALID SESSION' + '\n' + 'Click OK to reload');
                        }
                        top.window.location.replace(top.window.location.href);
                        return true;
                    }
                },
                error: onLogInFunctions.makePings.noServer
            });
        },
        start: function ()
        {
            this.isRetryPing = false;
            var makePingRequest = function ()
            {
                var verifyPingResult = function (t)
                {
                    if (!t.toLowerCase().contains('pong'))
                    {
                        //top.log.debug('PING Request: INVALID SESSION');
                        if (sessionData.DEBUG_MODE)
                        {
                            alert('PING Request: INVALID SESSION' + '\n' + 'Click OK to reload');
                        }
                        onLogInFunctions.makePings.stop();
                        top.window.location.replace(top.window.location.href); return true;
                    } else
                    {
                        // top.log.ajax('PING Request: Success');
                    }
                };
                $.ajax({
                    type: 'GET',
                    url: '../../infocgi',
                    data: 'action=ping',
                    success: verifyPingResult,
                    error: onLogInFunctions.makePings.noServer
                });
            };
            this.keepPinging = setInterval(makePingRequest, ASTGUI.globals.pingInterval);
        },
        stop: function ()
        {
            clearInterval(this.keepPinging);
        }
    },

    detectPlatform: function (resp)
    {
        sessionData.AsteriskVersionString = resp;
        onLogInFunctions.parseVersion(resp);

        // logic for platform detection, 
        var resp_lower = resp.toLowerCase();
        if (ASTGUI.version.gteq("1.6.0"))
        {
            //ASTGUI.globals.sbcid_1 = 's,1,ExecIf($[ "${CALLERID(num)}"="" ]?SetCallerPres(unavailable))';
            ASTGUI.globals.sbcid_1 = 's,1,NoOp()'; // added by dcwei 2012-09-10
            ASTGUI.globals.sbcid_2 = 's,n,ExecIf($[ "${CALLERID(num)}"="" ]?Set(CALLERID(all)=unknown <0000000>))';
            ASTGUI.globals.sbcid_3 = 's,n,Set(__FROM_TRUNK=YES)';
            sessionData.listOfCodecs = { // sessionData.listOfCodecs
                'ulaw': 'PCMU',
                'alaw': 'PCMA',
                'gsm': 'GSM',
                'ilbc': 'ILBC',
                //'speex': 'SPEEX',  //Removed by vanevan
                'g722': 'G.722',
                'g726': 'G.726',
                'g726aal2': 'AAL2-G.726-32',
                'adpcm': 'ADPCM',
                //'lpc10': 'LPC10', //remove by yjwu
                'g729': 'G.729',
                'g723': 'G.723',
                'h263': 'H.263',
                'h263p': 'H.263p',
                'h264': 'H.264'
            };

            /* add video codecs for 1.6 platforms */
        }
    },

    parseVersion: function (ver)
    {
        sessionData.AsteriskVersion = '';
        sessionData.AsteriskBranch = '';
        sessionData.AsteriskSVNRevision = 0;
        if (ver.match(/SVN-(.*)-r(\d+)/i))
        {
            sessionData.AsteriskBranch = RegExp.$1;
            sessionData.AsteriskSVNRevision = RegExp.$2;
        }
        if (ver.match(/SVN-trunk/i))
        {
            sessionData.AsteriskVersion = '1.8';
        }
        if (ver.match(/SVN-.*-([\d\.]+)-/i) || (ver.match(/\./) && ver.match(/([\d\.]+)/i)))
        {
            sessionData.AsteriskVersion = RegExp.$1;
        }
        if (!sessionData.AsteriskBranch && sessionData.AsteriskVersion)
        {
            var p = sessionData.AsteriskVersion.split('.');
            sessionData.AsteriskBranch = p[0];
            if (p.length > 1)
            {
                sessionData.AsteriskBranch += '.' + p[1];
                if (p[0] == 1 && p[1] == 6)
                {
                    if (p.length > 2)
                    {
                        sessionData.AsteriskBranch += '.' + p[2];
                    }
                }
            }
        }
    },
    setGUI_Paths: function ()
    {
        // onLogInFunctions.setGUI_Paths()
        var ASTERISK_CONF = context2json({ filename: 'asterisk.conf', context: 'directories', usf: 1 });
        if (ASTERISK_CONF === null) { ASTERISK_CONF = new ASTGUI.customObject; } // if context 'directories' not found in asterisk.conf
        sessionData.directories.asteriskConfig = ASTERISK_CONF.getProperty('astetcdir') || '/etc/asterisk/';
        sessionData.directories.astvarlibdir = ASTERISK_CONF.getProperty('astvarlibdir') || '/var/lib/asterisk/';
        sessionData.directories.AGIBIN = ASTERISK_CONF.getProperty('astagidir') || '/var/lib/asterisk/agi-bin/';
        sessionData.directories.astspooldir = ASTERISK_CONF.getProperty('astspooldir') || '/var/spool/asterisk/';

        if (!sessionData.directories.asteriskConfig.endsWith('/')) { sessionData.directories.asteriskConfig = sessionData.directories.asteriskConfig + '/'; }
        if (!sessionData.directories.astvarlibdir.endsWith('/')) { sessionData.directories.astvarlibdir = sessionData.directories.astvarlibdir + '/'; }
        if (!sessionData.directories.AGIBIN.endsWith('/')) { sessionData.directories.AGIBIN = sessionData.directories.AGIBIN + '/'; }
        if (!sessionData.directories.astspooldir.endsWith('/')) { sessionData.directories.astspooldir = sessionData.directories.astspooldir + '/'; }

        sessionData.directories.guiInstall = sessionData.directories.astvarlibdir + 'static-http/config/';
        sessionData.directories.ConfigBkp = sessionData.directories.astvarlibdir + 'gui_backups/';
        sessionData.directories.ConfigBkp_dldPath = sessionData.directories.guiInstall + 'private/bkps/'; // path for keeping the bkp files for download
        sessionData.directories.Sounds = sessionData.directories.astvarlibdir + 'sounds/';
        sessionData.directories.MOH = sessionData.directories.astvarlibdir + 'moh/'; // path for music on hold files
        sessionData.directories.menusRecord = sessionData.directories.Sounds + 'record/';

        sessionData.directories.scripts = sessionData.directories.astvarlibdir + 'scripts/'; /* Directory for gui scripts (listfiles, for example) */
        sessionData.directories.output_SysInfo = './sysinfo_output.html';
        sessionData.directories.voicemails_dir = sessionData.directories.astspooldir + 'voicemail/default/';
        sessionData.directories.script_takeBackup = 'sh ' + sessionData.directories.scripts + 'takebackup';
        sessionData.directories.script_restoreBackup = 'sh ' + sessionData.directories.scripts + 'restorebackup';
        sessionData.directories.script_ListFiles = 'sh ' + sessionData.directories.scripts + 'listfiles';
        sessionData.directories.script_NetworkSettings = 'sh ' + sessionData.directories.scripts + 'networking.sh';
        sessionData.directories.script_generateZaptel = 'sh ' + sessionData.directories.scripts + 'editzap.sh';
        sessionData.directories.script_generatemISDN_init = 'sh ' + sessionData.directories.scripts + 'editmisdn.sh';
        sessionData.directories.script_dldsoundpack = 'sh ' + sessionData.directories.scripts + 'dldsoundpack';
        sessionData.directories.script_mastercsvexists = 'sh ' + sessionData.directories.scripts + 'mastercsvexists';
        sessionData.directories.script_Registerg729 = 'sh ' + sessionData.directories.scripts + 'registerg729.sh';
        sessionData.directories.script_detectdahdi = 'sh ' + sessionData.directories.scripts + 'detectdahdi.sh';
        sessionData.directories.script_cpsysconf = 'sh ' + sessionData.directories.scripts + 'cpsysconf.sh';

        //sessionData.directories.app_DahdiScan = 'dahdi_scan > ' + sessionData.directories.asteriskConfig + ASTGUI.globals.dahdiScanOutput;
        sessionData.directories.app_dahdi_genconf = 'dahdi_genconf'; // generates new /etc/dahdi/system.conf
        sessionData.directories.app_mISDNscan = 'misdn-init scan';
        sessionData.directories.app_flashupdate = 'flashupdate';
    },

    checkifLoggedIn: function (lang, isLogin)
    {
        var s = $.ajax({ url: '../../infocgi' + '?action=ping', async: false });
        var resp = s.getResponseHeader("Server");
        if (resp) {
            onLogInFunctions.setGUI_Paths();
            onLogInFunctions.detectPlatform(resp); // <-- PLATFORM Detection
        }
        var stlc = s.responseText.toLowerCase();
        if (stlc.match('pong'))
        {
            $.cookie('locale', lang, { expires: 365 });
            var language = $.cookie('locale');
            $P.langSwitch(language);
            sessionData.isLoggedIn = true;
            onLogInFunctions.parseConfigFiles(isLogin);
        }
        else
        {
            sessionData.isLoggedIn = false;
            dialog.clearDialog();
            onLogInFunctions.switchToLoginPanel();
        }
    },
    switchToLoginPanel: function (status, isLogin)
    {
        var src = $.cookie("jumpMenu");
        if (status){
            $("#frameLogin").hide();
            $("#main-container").show();
            if (src && isLogin != true) {
                top.module.jumpMenu(src);
            }
            else {
                top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG950") });
                $("#mainscreen").attr("src", "welcome.html?" + version);
            }
            getSysTime();
            setTimeout(miscFunctions.resizeMainIframe, 2000);
        }
        else{
            $("#main-container").hide();
            $("#frameLogin").show();
            $.removeCookie("jumpMenu");
            $("#frameLogin").attr("src", "home.html?" + version);
        }
    },
    parseConfigFiles: function (isLogin)
    {
        sessionData.pbxinfo = {}; //reset any previous stored information
		sessionData.pbxinfo.analog_trunk_flags = '';
        sessionData.continueParsing = true;
        try
        {
            try
            {
                readcfg.checkEssentials();
                // check extensions.conf (macro trunkdial, guitools , other required contexts etc), check [general] in users.conf etc
                if (sessionData.continueParsing == false) return;
            } catch (er)
            {
                top.log.error('Error in readcfg.checkEssentials()' + '<BR>error msg: ' + er.description);
            }

            try
            {
                readcfg.ExtensionsConf();
                if (sessionData.continueParsing == false) return;
            } catch (er)
            {
                top.log.error('Error in readcfg.ExtensionsConf()');
            }

            try
            {
                readcfg.guiPreferencesConf();
                if (sessionData.continueParsing == false) return;
            } catch (er)
            {
                top.log.error('Error in readcfg.guiPreferencesConf()');
            }

            try
            {
                readcfg.httpConf();
            } catch (er)
            {
                top.log.error('Error in readcfg.httpConf()');
            }

            try
            {
                readcfg.UsersConf();
            } catch (er)
            {
                top.log.error('Error in readcfg.UsersConf()');
            }
			try
			{
				readcfg.FirewallConf();
			} catch (er)
			{
                top.log.error('Error in readcfg.FirewallConf()');
			}

			try
			{
				readcfg.Dynamic_Defense();
			} catch (er)
			{
                top.log.error('Error in readcfg.Dynamic_Defense()');
			}

            try
            {
                readcfg.MisdnConf();
            } catch (er)
            {
                top.log.error('Error in readcfg.MisdnConf()');
            }
            //ybiaozhou add park extensions begin
            try
            {
                //XXX here's an exception: parkext can not be always in localextension!!! for readcfg.extensionUser will reset localextensions
                var feature_conf_general = context2json({
                    filename: 'features.conf',
                    context: 'general',
                    usf: 1
                });

                if (feature_conf_general.hasOwnProperty('parkext'))
                {
                    sessionData.pbxinfo.localextensions['parkext'] = feature_conf_general['parkext'];
                }

            } catch (er)
            {
                top.log.error('Error in read features.conf');
            }
            //ybiaozhou add park extensions end

            /*  Added iptables security config by dcwei_grandstream 2012-12-10  */
            try
            {
                var security_config_general = context2json ({
                    filename: 'iptables_security.conf',
                    context: 'general',
                    usf: 1
                });
                
                if ( security_config_general.hasOwnProperty('tcp_ports') )
                {
                    sessionData.pbxinfo.security = security_config_general;
                }
            } catch (err)
            {
                top.log.error('Error in read iptables_security.conf');
            }
            /*  Ended */


        } catch (err)
        {
            top.log.error('Error in onLogInFunctions.parseConfigFiles()');
        } finally
        {
            if (sessionData.continueParsing == false)
            {
                return;
            }
            sessionData.finishedParsing = true;
            /* jcli : don't need to check write permission. */
            //onLogInFunctions.check_WritePermissionsFor_GUI_Folder();
            onLogInFunctions.run_detectdahdi(isLogin);
            /* jcli chgEnd */
        }
    },

    checkForCompactFlash: function ()
    { // onLogInFunctions.checkForCompactFlash()
        //check for compact flash
        //top.dialog.dialogMessage({ type: 'loading', content: 'Checking for CompactFlash ..' });
        var lookfor_CF = function (op)
        {
            var output = eval('('+ op +')').body;
            sessionData.hasCompactFlash = (output.contains('/dev/hda1')) ? true : false;
        };


        var action = "action=systemcmdwithoutput";
        var cmd = 'df -k';

        $.ajax({type:"GET", url:"/webcgi", data: action+'&'+cmd, success: lookfor_CF });
    },

    run_detectdahdi: function (isLogin)
    { // onLogInFunctions.run_detectdahdi()
        sessionData.DahdiChannelString = 'dahdichan';
        sessionData.DahdiDeviceString = 'DAHDI';

        onLogInFunctions.updatePanels4Platform(isLogin);
    },

    updatePanels4Platform: function (isLogin)
    {
        var tmp_continue = astgui_updateConfigFromOldGui(); // update configuration form 1.x gui if needed
        if (!tmp_continue) return;
        if (top.cookies) {
            if ($.cookie('configFilesChanged') == 'yes')
            {
                $('#applyChanges_Button').css("visibility", "visible");
				$('#line_Button').css("visibility", "visible");
                $('#applyChanges_Button').effect("shake", {
                    direction: "up", distance: 2, times:10000
                }, 400);
                $(".ui-effects-wrapper").css({
                    width: "auto",
                    height: "auto"    
                });
            } 
            else
            {
                $('#applyChanges_Button').css("visibility", "hidden");
				$('#line_Button').css("visibility", "hidden");
				$(".ui-effects-wrapper").css("width", "auto");
            }
        }
        dialog.clearDialog();
        /* CUSTOM ACTIONS BASED ON GET PARAMS */
        // GUI will be reloaded after each Custom Command
        var this_mainURL = window.location.href;
        var tmp_enableOverLay = ASTGUI.parseGETparam(this_mainURL, 'overlay');
        if (tmp_enableOverLay.isAstTrue())
        {
            top.window.location.href = this_mainURL.withOut('overlay=');
            return;
        }
        onLogInFunctions.switchToLoginPanel(true, isLogin);
        readcfg.dahdiScanConf();
        onLogInFunctions.getCountryTone();
        miscFunctions.show_advancedMode();
    },
    getCountryTone: function () {
        var c = config2json({ filename: 'indications.conf', usf: 0 });
        var countryToneObj = {};
        var countryItem;
        top.sessionData.countryTone = {};
        var regexBusy = /^busy=([\d+*]+)\/(\d+),[\d+]+\/(\d+)(,[\d+*]+\/(\d+),[\d+]+\/(\d+))?(,[\d+*]+\/(\d+),[\d+]+\/(\d+))?$/; 
        var regexCongestion = /^congestion=([\d+*]+)\/(\d+),[\d+]+\/(\d+)(,[\d+*]+\/(\d+),[\d+]+\/(\d+))?(,[\d+*]+\/(\d+),[\d+]+\/(\d+))?$/; 
        var match ;
        for (var d in c)
        {
            if (c.hasOwnProperty(d) && d !== 'general')
            {
                countryItem = {};
                c[d].each(function (item)
                {

                    if (item.beginsWith('busy='))
                    { 
                        match = item.match(regexBusy);
                        if (match)
                        {
                            countryItem.busyfreq = match[1];
                            countryItem.busypattern = match[2] + ',' + match[3]
                            + ( (match[5]) ? ( '-' + match[5] + ',' + match[6]) : '')
                            + ( (match[8]) ? ( '-' + match[8] + ',' + match[9]) : '');

                        }
                    }
                    else if (item.beginsWith('congestion='))
                    { 
                        match = item.match(regexCongestion);
                        if (match)
                        {
                            countryItem.congestionfreq = match[1];
                            countryItem.congestionpattern = match[2] + ',' + match[3] + ( (match[5]) ? ( '-' + match[5] + ',' + match[6]) : '') + ( (match[8]) ? ( '-' + match[8] + ',' + match[9]) : '');
                        }
                    }
                    else if (item.beginsWith('description='))
                    {
                        countryItem.desc = item.afterStr('description=');
                    }
                });
                countryItem.val = d;
                countryToneObj[d] = countryItem;
            }
        }
        sessionData.countryTone = countryToneObj;
    }
};


var miscFunctions = {
    toDigiumStore: function (a)
    { // parent.miscFunctions.toDigiumStore('G729CODEC')
        if (!a) return;
        var win = window.open('', 'myWin');
        win.location.href = 'http://store.digium.com/productview.php?product_code=' + a;
    },

    listOfChannels: function ()
    { // miscFunctions.listOfChannels() -- returns an array of current active channels
        var raw_chan_status = makeSyncRequest({ action: 'status' });
        var to_return = [];
        try
        {
            var chunks = ASTGUI.miscFunctions.getChunksFromManagerOutput(raw_chan_status.trim().replace(/Event: StatusComplete/, ""), true);
            while (chunks.length)
            {
                if (chunks[0].hasOwnProperty('Channel'))
                {
                    to_return.push(chunks[0]);
                }
                chunks.removeFirst();
            }

        } catch (e)
        {
            top.log.debug("Error listOfChannels: " + e);
            return to_return;
        }
        return to_return;
    },

    getTimeIntervals: function ()
    { // miscFunctions.getTimeIntervals();
        var TI_LIST = new ASTGUI.customObject;
        var tmp_globals = context2json({ filename: 'extensions.conf', context: 'globals', usf: 0 });
        for (var t = 0; t < tmp_globals.length; t++)
        {
            if (tmp_globals[t].beginsWith(ASTGUI.contexts.TimeIntervalPrefix))
            {
                TI_LIST[tmp_globals[t].lChop(ASTGUI.contexts.TimeIntervalPrefix).beforeChar('=')] = tmp_globals[t].afterChar('=');
            }
        }
        return TI_LIST;
    },
    show_advancedMode: function ()
    {
        var am = top.cookies.get('advancedmode');
        if (am && am == 'yes')
        {
            $(".AdvancedMode").show();
        } else
        {
            $(".AdvancedMode").hide();
        }
        miscFunctions.resizeMainIframe();
    },

    flip_advancedmode: function ()
    {
        var am = top.cookies.get('advancedmode');
        if (am && am == 'yes')
        {
            top.cookies.remove('advancedmode');
            $(".AdvancedMode").hide();
        } else
        {
            top.cookies.set('advancedmode', 'yes');
            $(".AdvancedMode").show();
        }
        miscFunctions.resizeMainIframe();
    },

    applyChanges: function (cb)
    {
        top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG806") });
        // jcli add
        setTimeout(function(){
            var reApply = 0;
            var c = listOfActions('configchanged.conf');
            var configchanged_conf = config2json({ filename: 'configchanged.conf', usf: 1 });
    
            if (configchanged_conf['configchanged'].hasOwnProperty('hardware') && configchanged_conf['configchanged']['hardware'] == "yes")
            {
                //top.log.debug("Executing manager command : module unload chan_dahdi.so");
                var resp = makeSyncRequest({ action: 'command', command: 'module unload chan_dahdi.so', gs_temp_allow: '98520a2695bd3b272f890bd9252f73d4' });
                if ( resp.indexOf("failed") > -1 ){
                    // maybe some fxs/fxo ports are in use or offhook 
                    top.dialog.clearDialog();
                    top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG988"), timer: 10000 });
                    reApply = 1;
                }
                else{
                    c.new_action('update', 'configchanged', 'hardware', 'no');
                    c.new_action('update', 'configchanged', 'chandahdi', 'no');
    
                    var action = "action=systemcmdwithoutput";
                    var cmd = 'sh /etc/rc.d/rc.dahdi restart';
                    var cb = function(){
                        //top.log.debug("Executing manager command : module load chan_dahdi.so");
                        makeSyncRequest({ action: 'command', command: 'module load chan_dahdi.so', gs_temp_allow: '98520a2695bd3b272f890bd9252f73d4' });
                    };
    
                    // success or complete ?
                    $.ajax({type:"GET", url:"/webcgi", data: action+'&'+cmd, complete: cb});
                }
            }
            else if (configchanged_conf['configchanged'].hasOwnProperty('chandahdi') && configchanged_conf['configchanged']['chandahdi'] == "yes")
            {
                //top.log.debug("Executing manager command : module unload chan_dahdi.so");
                var resp = makeSyncRequest({ action: 'command', command: 'module unload chan_dahdi.so', gs_temp_allow: 'd935b43e852661a7576431d66fd18cde' });
                if ( resp.indexOf("failed") > -1 ){
                    // maybe some fxs/fxo ports are in use or offhook 
                    top.dialog.clearDialog();
                    top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG988"), timer: 10000 });
                    reApply = 1;
                }
                else{
                    c.new_action('update', 'configchanged', 'chandahdi', 'no');
    
                    top.log.debug("Executing manager command : module load chan_dahdi.so");
                    makeSyncRequest({ action: 'command', command: 'module load chan_dahdi.so', gs_temp_allow: 'd935b43e852661a7576431d66fd18cde' });
                }
            }
    
            if (configchanged_conf['configchanged'].hasOwnProperty('ldap') && configchanged_conf['configchanged']['ldap'] == "yes")
            {
                c.new_action('update', 'configchanged', 'ldap', 'no');
    
                var action = "action=systemcmdwithoutput";
                var cmd = 'sh /app/asterisk/bin/ast_phonebook.sh apply';
                var cb = function(){
                    /* remove file cache */
                    if(top.sessionData.FileCache['phonebook1.conf']){
                        delete top.sessionData.FileCache['phonebook1.conf']; 
                    }
                    var t = ASTGUI.cliCommand('module reload');
                }
                $.ajax({type:"GET", url:"/webcgi", async: false, data: action+'&'+cmd, complete: cb});
            }else{
                var t = ASTGUI.cliCommand('module reload');
            }
    
            c.callActions();
            if(!reApply){
                $.removeCookie('configFilesChanged');
                parent.$('#applyChanges_Button').css("visibility", "hidden");
    		parent.$('#line_Button').css("visibility", "hidden");
                parent.$(".ui-effects-wrapper").css("width", "auto");
                top.dialog.clearDialog();
                top.dialog.dialogMessage({ type: 'info', content: $P.lang("LANG951") });
            }

            if (cb){
                cb();
            } 
        }, 100);
    },

    logoutFunction: {
        // Object to store all sequence of functions that should execute on logout
        // example if appliance - need to save changes before logout
        doLogout: function ()
        {
            var f = makeSyncRequest({ action: 'logoff' });
            top.window.location.reload();
        },
        confirmlogout: function ()
        {
            var msg = $P.lang("LANG744");
            dialog.dialogConfirm({
                confirmStr: msg,
                buttons: {
                    ok: miscFunctions.logoutFunction.doLogout
                }
            });
        }
    },
    resizeMainIframe: function ()
    {
        var cMain = $("div#main-container");
        var cBreadCrumb = $("div#crumbs_div");
        var cLeftPane = $("div#accordion_div");
        var cMenu = $("div#menu-div");
        var cHeader = $("div.header_row");
        var cFooter = $("div#footer-row");
        var cMainScreen = $("#mainscreen");
        var ww = document.body.clientWidth;
        var hh = document.body.clientHeight;

        if (ww < $(cHeader).width())
            ww = $(cHeader).width();

        var mainW = ww - $(cLeftPane).width();
        var mainH = hh - $(cHeader).height() - $(cFooter).height();

        var frameH = mainH - $(cBreadCrumb).height() - 5;
        $("#center-row").css("height", mainH + "px");
        $("#content-pad").css("width", mainW + "px");

        $("div.right_bottom_shadow").css("width", mainW + "px");
        if ($.browser.msie && (parseInt($.browser.version) == 8)) {
            $(cMainScreen).attr("height", frameH + 1 + "px");
            $(cLeftPane).css("height", mainH + 1 + "px");
        }
        else{
            $(cMainScreen).attr("height", frameH + "px");
            $(cLeftPane).css("height", mainH + "px");
        }
        $(cMainScreen).attr("width", mainW + "px");
        
        $(cMenu).css("height", (mainH - 10) + "px");
    },

    DEBUG_START: function ()
    {
        if (sessionData.DEBUG_PROFILER_BEGIN) return; // we want to call DEBUG_START only once during a gui session

        var m = _$('debug_messages');
        var aaaaa = function ()
        {
            if (sessionData.DEBUG_MODE && sessionData.DEBUG_LOG.length)
            {
                if (m.style.display == '')
                {
                    m.innerHTML = '<li>' + sessionData.DEBUG_LOG.join('<li>');
                }
            }
        };
        m.innerHTML = 'No log messages';
        var now = new Date();
        sessionData.DEBUG_PROFILER_BEGIN = now.getTime();
        setInterval(aaaaa, 3000);

        m.style.display = '';
        $('#dbw_flip').click(function ()
        {
            if (m.style.display == '')
            {
                m.style.display = 'none';
                this.innerHTML = 'Show debug messages'
                this.className = 'dbw_flip_hide';
                return;
            }
            if (m.style.display == 'none')
            {
                m.innerHTML = (sessionData.DEBUG_LOG.length) ? '<li>' + sessionData.DEBUG_LOG.join('<li>') : 'No log messages';
                m.style.display = '';
                this.innerHTML = 'Hide debug messages'
                this.className = 'dbw_flip_show';
                return;
            }
        });

        aaaaa();

        _$('debugWindow_which_Ajax').checked = sessionData.DEBUG_WHICH.Ajax;
        $('#debugWindow_which_Ajax').click(function () { sessionData.DEBUG_WHICH.Ajax = this.checked; });

        _$('debugWindow_which_Debug').checked = sessionData.DEBUG_WHICH.Debug;
        $('#debugWindow_which_Debug').click(function () { sessionData.DEBUG_WHICH.Debug = this.checked; });

        _$('debugWindow_which_Error').checked = sessionData.DEBUG_WHICH.Error;
        $('#debugWindow_which_Error').click(function () { sessionData.DEBUG_WHICH.Error = this.checked; });

        _$('debugWindow_which_Console').checked = sessionData.DEBUG_WHICH.Console;
        $('#debugWindow_which_Console').click(function () { sessionData.DEBUG_WHICH.Console = this.checked; });

        _$('debugWindow_which_Info').checked = sessionData.DEBUG_WHICH.Info;
        $('#debugWindow_which_Info').click(function () { sessionData.DEBUG_WHICH.Info = this.checked; });

        _$('debugWindow_which_Warnings').checked = sessionData.DEBUG_WHICH.Warn;
        $('#debugWindow_which_Warnings').click(function () { sessionData.DEBUG_WHICH.Warn = this.checked; });

    },

    DEBUG_CLEAR: function ()
    {
        sessionData.DEBUG_LOG = [];
        _$('debug_messages').innerHTML = 'No log messages ';
    },

    setFeedback: function (fb)
    {
        // donot call this function directly 
        // instead do -- ASTGUI.feedback( { msg:'your message here', showfor:2, color:'#000000', bgcolor:'#FFFFFF' } );
        fb.showfor = 3; // over write all showfor values (kenny said messages are disappearing before anyone could read them)
        var k = $("#feedback");
        if (sessionData.fbtimer) { clearTimeout(sessionData.fbtimer); }
        if (!fb) { k.hide(); return true; }
        if (!fb.showfor) { fb.showfor = 3; }
        if (!fb.color) { fb.color = '#6573c2'; }
        if (!fb.bgcolor) { fb.bgcolor = '#FFFFFF'; }
        switch (fb.color)
        {
            case 'green':
                fb.color = '#32633d';
                break;
            case 'red':
                fb.color = '#a02920';
                break;
            case 'brown':
                fb.color = '#6e2920';
            case 'orange':
                fb.color = '#ff8e03';
                break;
            case 'gray':
                fb.color = '#53646d';
                break;
            default:
                break;
        }
        k.css({ backgroundColor: fb.bgcolor, fontWeight: "", color: fb.color });
        k[0].innerHTML = fb.msg;
        k.fadeIn(1000);
        setTimeout(function () { top.window.scroll(0, 0); }, 50);
        var clearFb = function ()
        {
            sessionData.fbtimer = 0;
            k[0].innerHTML = '';
            k.hide();
        };
        sessionData.fbtimer = setTimeout(clearFb, fb.showfor * 1000);
    },

    AFTER_REBOOT_CMD: function ()
    { // miscFunctions.AFTER_REBOOT_CMD()
        //onLogInFunctions.makePings.stop();
        var count_down = function (n)
        {
            if (n)
            {
                if (n > 120)
                {
                    setTimeout(function () { n = n - 5; count_down(n); }, 5000);
                    var m = ' ' + String(parseInt(n / 60, 10)) + ':' + String(n % 60) + ' Seconds';
                } else
                {
                    setTimeout(function () { n = n - 1; count_down(n); }, 1000);
                    var m = n + ' Seconds';
                }

                var tmp_msg = ' GUI will be reloaded in <B><font size="+1">' + m + '</B></font>'
                    + '<BR><BR> <font size="-1">Note: The IP address where you access the gui might be changed on reboot depending on your configuration.</font>';

                //top.dialog.dialogMessage({ type: 'loading', content: tmp_msg });
            } else
            {
                if (sessionData.DEBUG_MODE)
                {
                    //alert('CountDown complete' + '\n' + 'Click OK to reload');
                }
                top.window.location.reload();
            }
        };

        var fr = top.cookies.get('firmware_reboot')
        top.cookies.remove('firmware_reboot');
        if (fr == 'yes')
        {
            count_down(480);
        } else
        {
            count_down(120);
        }
    },
    getAllDestinations_4incomings: function (without_Goto)
    { // miscFunctions.getAllDestinations() // --> returns an Array of Objects
        // There are various places in the gui where we want to preset a select box with all possible destinations
        // for Example - in incoming calls, Voicemenus, RingGroups etc.
        // this function navigates through all properties of sessionData.pbxinfo and returns an Array of Objects with all the possible destinations
        var tmp = [];
        var y = pbx.users.list();
        y.each(function (user)
        {
            /*  added by dcwei 2012-09-07   */
            //              tmp.push({ optionText: 'User Extension -- ' + user , optionValue: 'Goto(default,' + user + ',1)' });
            tmp.push({
                optionText: $P.lang('LANG248') + ' -- ' + user,
                optionValue: 'Goto(ext-local,' + user + ',1)' 
            });

            if (sessionData.pbxinfo.users[user].getProperty('hasvoicemail').isAstTrue())
            {
                tmp.push({
                    optionText: $P.lang('LANG249') + ' -- ' + user, 
                    optionValue: 'Voicemail(' + user + ',u)' 
                });
            }

        });
        var y = sessionData.pbxinfo.conferences.getOwnProperties();
        y.each(function (meetme)
        {
            tmp.push({ 
                optionText: $P.lang('LANG98') + ' -- ' + meetme,
                optionValue: 'Goto(' + ASTGUI.contexts.CONFERENCES + ',' + meetme + ',1)'
            });
        });
        var y = sessionData.pbxinfo.queues.exten.getOwnProperties();
        y.each(function (q)
        {

            tmp.push({
                optionText: $P.lang('LANG91') + ' -- ' + q,
                optionValue: 'Goto(' + ASTGUI.contexts.QUEUES + ',' + q + ',1)'
            });

/*          comment for bug 15045
            if (sessionData.pbxinfo.queues.setting['queueLogin'] != null)
            {
                tmp.push({ 
                    optionText: $P.lang('LANG92') + ' -- ' + q + sessionData.pbxinfo.queues.setting['queueLogin'],
                    optionValue: 'Goto(' + ASTGUI.contexts.QUEUES + ',' + q + sessionData.pbxinfo.queues.setting['queueLogin'] + ',1)'
                });
            }


            if (sessionData.pbxinfo.queues.setting['queueLogout'] != null)
            {
                tmp.push({
                    optionText: $P.lang('LANG93') + ' -- ' + q + sessionData.pbxinfo.queues.setting['queueLogout'],
                    optionValue: 'Goto(' + ASTGUI.contexts.QUEUES + ',' + q + sessionData.pbxinfo.queues.setting['queueLogout'] + ',1)'
                });
            }
*/
            //ybiaozhou modify QueueAgentLogin/out display(optionText) end


        });
        var y = sessionData.pbxinfo.voicemenus.getOwnProperties();
        y.each(function (vmenu)
        {
            var vm_name = sessionData.pbxinfo.voicemenus[vmenu].comment || vmenu;
            tmp.push({
                optionText: $P.lang('LANG134') +  ' -- ' + vm_name, 
                optionValue: 'Goto(' + vmenu + ',s,1)'
            });
        });
        //      var y = sessionData.pbxinfo.timebasedRules.getOwnProperties();
        //          y.each(function(tbr){
        //              var tbr_label = sessionData.pbxinfo.timebasedRules[tbr].label || tbr ;
        //              tmp.push({ optionText: 'Time Based Rule -- ' + tbr_label , optionValue: 'Goto('+ tbr +',s,1)' });
        //          });
        var y = sessionData.pbxinfo.ringgroups.getOwnProperties();
        y.each(function (rg)
        {
            var rg_name = sessionData.pbxinfo.ringgroups[rg].NAME || rg;
            //ybiaozhou modify for Goto Ring Group (HZ Trac #288) begin
            var rg_exten = sessionData.pbxinfo.ringgroups[rg].extension;
            tmp.push({
                optionText: $P.lang('LANG600') + ' -- ' + rg_name,
                optionValue: 'Goto(' + ASTGUI.contexts.ExtGroup + ',' + rg_exten + ',1)'
                });
            //ybiaozhou modify for Goto Ring Group (HZ Trac #288) end
        });
        var y = pbx.paging.list();
        y.each(function (pge)
        {
            tmp.push({ 
                optionText: $P.lang('LANG94') + ' -- ' + pge,
                optionValue: 'Goto(' + ASTGUI.contexts.PageGroups + ',' + pge + ',1)'
            });
        });
        var y = sessionData.pbxinfo.vmgroups.getOwnProperties();
        y.each(function (this_vmg_exten)
        {
            tmp.push({
                optionText: $P.lang('LANG89') +  ' -- ' + (sessionData.pbxinfo.vmgroups[this_vmg_exten].getProperty('label') || this_vmg_exten),
                optionValue: 'Goto(' + ASTGUI.contexts.VoiceMailGroups + ',' + this_vmg_exten + ',1)'
            });
        });
        if (sessionData.pbxinfo['localextensions'].getProperty('defaultDirectory'))
        {
            var nde = sessionData.pbxinfo['localextensions'].getProperty('defaultDirectory');
            tmp.push({ optionText: 'Names Directory -- ' + nde, optionValue: 'Goto(' + ASTGUI.contexts.Directory + ',' + nde + ',1)' });
        }
        //ybiaozhou modify Goto VoiceMail destination 
        /*
        if( sessionData.pbxinfo['localextensions'].hasOwnProperty('VoiceMailMain') ){
        var tmp_VMM_Exten = ASTGUI.parseContextLine.getExten( sessionData.pbxinfo['localextensions']['VoiceMailMain'] ) ;
        tmp.push({ optionText: 'Check Voicemails -- ' + tmp_VMM_Exten , optionValue: 'Goto(default,' + tmp_VMM_Exten + ',1)' });
        }
        */
        if (sessionData.pbxinfo['localextensions'].hasOwnProperty(ASTGUI.contexts.AppDialvm))
        {
            var tmp_VMM_Exten = ASTGUI.parseContextLine.getExten(sessionData.pbxinfo['localextensions'][ASTGUI.contexts.AppDialvm]);
            tmp.push({ 
                optionText: $P.lang('LANG1232') +  ' -- ' + tmp_VMM_Exten,
                optionValue: 'Goto(' + ASTGUI.contexts.AppDialvm + ',' + tmp_VMM_Exten + ',1)'
                });
        }
        //ybiaozhou modify Goto VoiceMail destination end

        var y = sessionData.pbxinfo.fax.exten.getOwnProperties();
        y.each(function (q)
        {
            tmp.push({
                optionText: $P.lang('LANG95') + ' -- ' + q,
                optionValue: 'Goto(' + ASTGUI.contexts.ExtFax + ',' + q + ',1)'
                });
        });

        /*  modified by dcwei 2012-09-07    */
        //ybiaozhou rollback to Goto(default,o,1)
        tmp.push({ optionText: $P.lang("LANG96") , optionValue: 'Goto(default,o,1)' });
        //tmp.push({ optionText: 'Operator', optionValue: 'Goto(' + ASTGUI.contexts.CallingPlan + ',o,1)' });
        tmp.push({ optionText: $P.lang("LANG97") , optionValue: 'Hangup' });
        tmp.push({ optionText: $P.lang('LANG578'), optionValue: 'Congestion' });

        var y = getDisaMember();
        y.each(function (q)
        {
            tmp.push({ optionText: $P.lang("LANG2353") + ' -- ' + q.displayname, optionValue: 'Goto(disa,' + q.disaid + ',1)' });
        });
            
        if (without_Goto)
        {
            var tmp_withoutGoto = [];
            for (var t = 0; t < tmp.length; t++)
            {
                if (tmp[t].optionValue.beginsWith('Goto('))
                {

                    tmp_withoutGoto.push({
                        optionText: tmp[t].optionText,
                        optionValue: tmp[t].optionValue.lChop('Goto(').rChop(')')
                    });

                }
            }
            return tmp_withoutGoto;
        }

        return tmp;
    },
    
    
    getAllDestinations: function (without_Goto)
    { // miscFunctions.getAllDestinations() // --> returns an Array of Objects
        // There are various places in the gui where we want to preset a select box with all possible destinations
        // for Example - in incoming calls, Voicemenus, RingGroups etc.
        // this function navigates through all properties of sessionData.pbxinfo and returns an Array of Objects with all the possible destinations
        var tmp = [];
        var y = pbx.users.list();
        y.each(function (user)
        {
            /*  added by dcwei 2012-09-07   */
            //              tmp.push({ optionText: 'User Extension -- ' + user , optionValue: 'Goto(default,' + user + ',1)' });
            tmp.push({ optionText: 'User Extension -- ' + user, optionValue: 'Goto(' + ASTGUI.contexts.CallingPlan + ',' + user + ',1)' });

            if (sessionData.pbxinfo.users[user].getProperty('hasvoicemail').isAstTrue())
            {
                tmp.push({ optionText: 'User VoiceMailBox ' + user, optionValue: 'Voicemail(' + user + ',u)' });
            }

        });
        var y = sessionData.pbxinfo.conferences.getOwnProperties();
        y.each(function (meetme)
        {
            tmp.push({ optionText: 'Conference Room -- ' + meetme, optionValue: 'Goto(' + ASTGUI.contexts.CONFERENCES + ',' + meetme + ',1)' });
        });
        var y = sessionData.pbxinfo.queues.exten.getOwnProperties();
        y.each(function (q)
        {

            tmp.push({ optionText: 'Queue -- ' + q, optionValue: 'Goto(' + ASTGUI.contexts.QUEUES + ',' + q + ',1)' });

            //ybiaozhou modify QueueAgentLogin/out display(optionText)
            /*  comment for bug 15045
            if (sessionData.pbxinfo.queues.setting['queueLogin'] != null)
            {
                tmp.push({ optionText: 'QueueAgentLogin -- ' + q + sessionData.pbxinfo.queues.setting['queueLogin'], optionValue: 'Goto(' + ASTGUI.contexts.QUEUES + ',' + q + sessionData.pbxinfo.queues.setting['queueLogin'] + ',1)' });
            }


            if (sessionData.pbxinfo.queues.setting['queueLogout'] != null)
            {
                tmp.push({ optionText: 'QueueAgentLogout -- ' + q + sessionData.pbxinfo.queues.setting['queueLogout'], optionValue: 'Goto(' + ASTGUI.contexts.QUEUES + ',' + q + sessionData.pbxinfo.queues.setting['queueLogout'] + ',1)' });

            }
            */
            //ybiaozhou modify QueueAgentLogin/out display(optionText) end


        });
        var y = sessionData.pbxinfo.voicemenus.getOwnProperties();
        y.each(function (vmenu)
        {
            var vm_name = sessionData.pbxinfo.voicemenus[vmenu].comment || vmenu;
            tmp.push({ optionText: 'IVR -- ' + vm_name, optionValue: 'Goto(' + vmenu + ',s,1)' });
        });
        //      var y = sessionData.pbxinfo.timebasedRules.getOwnProperties();
        //          y.each(function(tbr){
        //              var tbr_label = sessionData.pbxinfo.timebasedRules[tbr].label || tbr ;
        //              tmp.push({ optionText: 'Time Based Rule -- ' + tbr_label , optionValue: 'Goto('+ tbr +',s,1)' });
        //          });
        var y = sessionData.pbxinfo.ringgroups.getOwnProperties();
        y.each(function (rg)
        {
            var rg_name = sessionData.pbxinfo.ringgroups[rg].NAME || rg;
            //ybiaozhou modify for Goto Ring Group (HZ Trac #288) begin
            var rg_exten = sessionData.pbxinfo.ringgroups[rg].extension;
            tmp.push({ optionText: 'Ring Group -- ' + rg_name, optionValue: 'Goto(' + ASTGUI.contexts.ExtGroup + ',' + rg_exten + ',1)' });
            //ybiaozhou modify for Goto Ring Group (HZ Trac #288) end
        });
        var y = pbx.paging.list();
        y.each(function (pge)
        {
            tmp.push({ optionText: 'Page Group -- ' + pge, optionValue: 'Goto(' + ASTGUI.contexts.PageGroups + ',' + pge + ',1)' });
        });
        var y = sessionData.pbxinfo.vmgroups.getOwnProperties();
        y.each(function (this_vmg_exten)
        {
            tmp.push({
                optionText: 'VoiceMail Group -- ' + (sessionData.pbxinfo.vmgroups[this_vmg_exten].getProperty('label') || this_vmg_exten),
                optionValue: 'Goto(' + ASTGUI.contexts.VoiceMailGroups + ',' + this_vmg_exten + ',1)'
            });
        });
        if (sessionData.pbxinfo['localextensions'].getProperty('defaultDirectory'))
        {
            var nde = sessionData.pbxinfo['localextensions'].getProperty('defaultDirectory');
            tmp.push({ optionText: 'Names Directory -- ' + nde, optionValue: 'Goto(' + ASTGUI.contexts.Directory + ',' + nde + ',1)' });
        }
        //ybiaozhou modify Goto VoiceMail destination 
        /*
        if( sessionData.pbxinfo['localextensions'].hasOwnProperty('VoiceMailMain') ){
        var tmp_VMM_Exten = ASTGUI.parseContextLine.getExten( sessionData.pbxinfo['localextensions']['VoiceMailMain'] ) ;
        tmp.push({ optionText: 'Check Voicemails -- ' + tmp_VMM_Exten , optionValue: 'Goto(default,' + tmp_VMM_Exten + ',1)' });
        }
        */
        if (sessionData.pbxinfo['localextensions'].hasOwnProperty(ASTGUI.contexts.AppVmmain))
        {
            var tmp_VMM_Exten = ASTGUI.parseContextLine.getExten(sessionData.pbxinfo['localextensions'][ASTGUI.contexts.AppVmmain]);
            tmp.push({ optionText: 'Check My Voicemails -- ' + tmp_VMM_Exten, optionValue: 'Goto(' + ASTGUI.contexts.AppVmmain + ',' + tmp_VMM_Exten + ',1)' });
        }

        if (sessionData.pbxinfo['localextensions'].hasOwnProperty(ASTGUI.contexts.AppDialvm))
        {
            var tmp_VMM_Exten = ASTGUI.parseContextLine.getExten(sessionData.pbxinfo['localextensions'][ASTGUI.contexts.AppDialvm]);
            tmp.push({ optionText: 'Check Specific Voicemails -- ' + tmp_VMM_Exten, optionValue: 'Goto(' + ASTGUI.contexts.AppDialvm + ',' + tmp_VMM_Exten + ',1)' });
        }
        //ybiaozhou modify Goto VoiceMail destination end

        var y = sessionData.pbxinfo.fax.exten.getOwnProperties();
        y.each(function (q)
        {
            tmp.push({ optionText: 'Fax -- ' + q, optionValue: 'Goto(' + ASTGUI.contexts.ExtFax + ',' + q + ',1)' });
        });

        /*  modified by dcwei 2012-09-07    */
        //ybiaozhou rollback to Goto(default,o,1)
        tmp.push({ optionText: 'Operator', optionValue: 'Goto(default,o,1)' });
        //tmp.push({ optionText: 'Operator', optionValue: 'Goto(' + ASTGUI.contexts.CallingPlan + ',o,1)' });
        tmp.push({ optionText: 'Hangup', optionValue: 'Hangup' });
        tmp.push({ optionText: 'Congestion', optionValue: 'Congestion' });

        if (without_Goto)
        {
            var tmp_withoutGoto = [];
            for (var t = 0; t < tmp.length; t++)
            {
                if (tmp[t].optionValue.beginsWith('Goto('))
                {

                    tmp_withoutGoto.push({
                        optionText: tmp[t].optionText,
                        optionValue: tmp[t].optionValue.lChop('Goto(').rChop(')')
                    });

                }
            }
            return tmp_withoutGoto;
        }

        return tmp;
    },
    getDestinations: function (parm)
    { 
        var tmp = [];

        if (!parm || parm == "user")
        {
            var y = pbx.users.list();
            y.each(function (user)
            {
                tmp.push({ optionText: $P.lang("LANG85") + ' -- ' + user, optionValue: 'Goto(' + ASTGUI.contexts.CallingPlan + ',' + user + ',1)' });
            });
        }

        if (!parm || parm == "voicemail")
        {
            var y = pbx.users.list();
            y.each(function (user)
            {
                if (sessionData.pbxinfo.users[user].getProperty('hasvoicemail').isAstTrue())
                {
                    tmp.push({ optionText: $P.lang("LANG90") + ' -- ' + user, optionValue: 'Goto(simple_vm,'+user+',1)' });
                }
            });
        }

        if (!parm || parm == "conference")
        {
            var y = sessionData.pbxinfo.conferences.getOwnProperties();
            y.each(function (meetme)
            {
                tmp.push({ optionText: $P.lang("LANG98") + ' -- ' + meetme, optionValue: 'Goto(' + ASTGUI.contexts.CONFERENCES + ',' + meetme + ',1)' });
            });
        }

        if (!parm || parm == "queue")
        {
            var y = sessionData.pbxinfo.queues.exten.getOwnProperties();
            y.each(function (q)
            {
                tmp.push({ optionText: $P.lang("LANG91") + ' -- ' + q, optionValue: 'Goto(' + ASTGUI.contexts.QUEUES + ',' + q + ',1)' });

                /*
                if (sessionData.pbxinfo.queues.setting['queueLogin'] != null)
                {
                    tmp.push({ optionText: $P.lang("LANG92") + ' -- ' + q + sessionData.pbxinfo.queues.setting['queueLogin'], optionValue: 'Goto(' + ASTGUI.contexts.QUEUES + ',' + q + sessionData.pbxinfo.queues.setting['queueLogin'] + ',1)' });
                }

                if (sessionData.pbxinfo.queues.setting['queueLogout'] != null)
                {
                    tmp.push({ optionText: $P.lang("LANG93") +' -- ' + q + sessionData.pbxinfo.queues.setting['queueLogout'], optionValue: 'Goto(' + ASTGUI.contexts.QUEUES + ',' + q + sessionData.pbxinfo.queues.setting['queueLogout'] + ',1)' });

                } 
                */ 
            });
        }

        if (!parm || parm == "ivr")
        {
            var y = sessionData.pbxinfo.voicemenus.getOwnProperties();
            y.each(function (vmenu)
            {
                var vm_name = sessionData.pbxinfo.voicemenus[vmenu].comment || vmenu;
                tmp.push({ optionText: 'IVR -- ' + vm_name, optionValue: 'Goto(' + vmenu + ',s,1)' });
            });
        }

        if (!parm || parm == "rggroup")
        {
            var y = sessionData.pbxinfo.ringgroups.getOwnProperties();
            y.each(function (rg)
            {
                var rg_name = sessionData.pbxinfo.ringgroups[rg].NAME || rg;
                var rg_exten = sessionData.pbxinfo.ringgroups[rg].extension;
                tmp.push({ optionText: $P.lang("LANG600") + ' -- ' + rg_name, optionValue: 'Goto(' + ASTGUI.contexts.ExtGroup + ',' + rg_exten + ',1)' });
            });
        }

        if (!parm || parm == "pge")
        {
            var y = pbx.paging.list();
            y.each(function (pge)
            {
                tmp.push({ optionText: $P.lang("LANG94") + ' -- ' + pge, optionValue: 'Goto(' + ASTGUI.contexts.PageGroups + ',' + pge + ',1)' });
            });
        }

        if (!parm || parm == "vmgroup")
        {
            var y = sessionData.pbxinfo.vmgroups.getOwnProperties();
            y.each(function (this_vmg_exten)
            {
                tmp.push({
                    optionText: $P.lang("LANG89") + ' -- ' + (sessionData.pbxinfo.vmgroups[this_vmg_exten].getProperty('label') || this_vmg_exten),
                    optionValue: 'Goto(' + ASTGUI.contexts.VoiceMailGroups + ',' + this_vmg_exten + ',1)'
                });
            });
        }

        if (!parm) {
            if (sessionData.pbxinfo['localextensions'].getProperty('defaultDirectory'))
            {
                var nde = sessionData.pbxinfo['localextensions'].getProperty('defaultDirectory');
                tmp.push({ optionText: 'Names Directory -- ' + nde, optionValue: 'Goto(' + ASTGUI.contexts.Directory + ',' + nde + ',1)' });
            }
            //ybiaozhou modify Goto VoiceMail destination 
            /*
            if( sessionData.pbxinfo['localextensions'].hasOwnProperty('VoiceMailMain') ){
            var tmp_VMM_Exten = ASTGUI.parseContextLine.getExten( sessionData.pbxinfo['localextensions']['VoiceMailMain'] ) ;
            tmp.push({ optionText: 'Check Voicemails -- ' + tmp_VMM_Exten , optionValue: 'Goto(default,' + tmp_VMM_Exten + ',1)' });
            }
            */
            if (sessionData.pbxinfo['localextensions'].hasOwnProperty(ASTGUI.contexts.AppVmmain))
            {
                var tmp_VMM_Exten = ASTGUI.parseContextLine.getExten(sessionData.pbxinfo['localextensions'][ASTGUI.contexts.AppVmmain]);
                tmp.push({ optionText: 'Check My Voicemails -- ' + tmp_VMM_Exten, optionValue: 'Goto(' + ASTGUI.contexts.AppVmmain + ',' + tmp_VMM_Exten + ',1)' });
            }

            if (sessionData.pbxinfo['localextensions'].hasOwnProperty(ASTGUI.contexts.AppDialvm))
            {
                var tmp_VMM_Exten = ASTGUI.parseContextLine.getExten(sessionData.pbxinfo['localextensions'][ASTGUI.contexts.AppDialvm]);
                tmp.push({ optionText: 'Check Specific Voicemails -- ' + tmp_VMM_Exten, optionValue: 'Goto(' + ASTGUI.contexts.AppDialvm + ',' + tmp_VMM_Exten + ',1)' });
            }
            //ybiaozhou modify Goto VoiceMail destination end
        }

        if (!parm || parm == "fax")
        {
            var y = sessionData.pbxinfo.fax.exten.getOwnProperties();
            y.each(function (q)
            {
                tmp.push({ optionText: $P.lang("LANG95") + ' -- ' + q, optionValue: 'Goto(' + ASTGUI.contexts.ExtFax + ',' + q + ',1)' });
            });
        }
        
        if (!parm || parm == "disa")
        {
            var y = getDisaMember();
            y.each(function (q)
            {
                tmp.push({ optionText: $P.lang("LANG2353") + ' -- ' + q.displayname, optionValue: 'Goto(disa,' + q.disaid + ',1)' });
            });
        }

        if (!parm) {
            tmp.push({ optionText: $P.lang("LANG96") , optionValue: 'Goto(default,o,1)' });
            tmp.push({ optionText: $P.lang("LANG97") , optionValue: 'Hangup' });
            tmp.push({ optionText: $P.lang('LANG578'), optionValue: 'Congestion' });
        }

        return tmp;
    },

    getAllExtensions: function (options)
    { // miscFunctions.getAllExtensions() - returns Array of all Extensions
        var tmp = [];

        options = $.extend( {
            "modules": {
                "users": true,
                "voicemenus": true,
                "conferences": true,
                "ringgroups": true,
                "pagings": true,
                "vmgroups": true,
                "queues": true,
                "localextensions": true,
                "fax": true
            }
        }, options || {});

        try
        {
            if (options.modules.users)
            {
                tmp = tmp.concat(pbx.users.list());
            }

            if (options.modules.voicemenus)
            {
                var y = sessionData.pbxinfo.voicemenus.getOwnProperties();
                y.each(function (item)
                {
                    var tmp_thisVMenu = ASTGUI.cloneObject(sessionData.pbxinfo.voicemenus[item]);
                    if (tmp_thisVMenu.getProperty('alias_exten'))
                    {
                        tmp.push(ASTGUI.parseContextLine.getExten(tmp_thisVMenu.alias_exten));
                    }
                });
            }

            if (options.modules.conferences)
            {
                var y = sessionData.pbxinfo.conferences.getOwnProperties();
                y.each(function (item)
                {
                    var tmp_thisMeetMe = ASTGUI.cloneObject(sessionData.pbxinfo.conferences[item]);
                    if (tmp_thisMeetMe.getProperty('dialStr'))
                    {
                        tmp.push(ASTGUI.parseContextLine.getExten(tmp_thisMeetMe.dialStr));
                    }
                });
            }

            if (options.modules.ringgroups)
            {
                var y = sessionData.pbxinfo.ringgroups.getOwnProperties();
                y.each(function (item)
                {
                    var tmp_thisRg = ASTGUI.cloneObject(sessionData.pbxinfo.ringgroups[item]);
                    if (tmp_thisRg.getProperty('extension'))
                    {
                        tmp.push(tmp_thisRg.extension);
                    }
                });
            }

            if (options.modules.pagings)
            {
                tmp = tmp.concat(pbx.paging.list());
            }

            if (options.modules.vmgroups)
            {
                tmp = tmp.concat(sessionData.pbxinfo.vmgroups.getOwnProperties());
            }

            if (options.modules.queues)
            {
                tmp = tmp.concat(sessionData.pbxinfo.queues.exten.getOwnProperties());
            }

            if (options.modules.localextensions)
            {
                //  localextensions,parkpos 
                var y = sessionData.pbxinfo.localextensions;
                for (item in y)
                {
                    if (y.hasOwnProperty(item))
                    {
                        tmp.push(y[item]);
                    }
                }

                //parked extensions
                var feature_conf_general = context2json({
                    filename: 'features.conf',
                    context: 'general',
                    usf: 1
                });

                // add parkext 
                // everytime readcfg extensions,the localextensions will be reset, parkext may lose from localextensions if they don't read features.conf
                // to make sure check extensions will not ignore parkext, add parkext extension
                if (feature_conf_general.parkext)
                {
                    tmp.push(feature_conf_general.parkext);
                }

                if (feature_conf_general.hasOwnProperty('parkpos'))
                {
                    var parkpos = feature_conf_general['parkpos'];
                    parkpos = parkpos.split('-');
                    parkpos[0] = parseInt(parkpos[0], 10);
                    parkpos[1] = parseInt(parkpos[1], 10);

                    for (i = parkpos[0]; i <= parkpos[1]; i++)
                    {
                        tmp.push(i.toString());
                    }
                }
            }

            // fax extensions
            if (options.modules.fax)
            {
                tmp = tmp.concat(sessionData.pbxinfo.fax.exten.getOwnProperties());
            }

        } catch (err)
        {

        } finally
        {
            return tmp;
        }
    },

    ifExtensionAlreadyExists: function (a)
    { // miscFunctions.ifExtensionAlreadyExists() - returns true if an extension already exists, false Other wise
        return this.getAllExtensions().contains(a);
    }
};

var loadGUI = function ()
{
    if (sessionData && sessionData.isLoggedIn) {
        $("#main-container").show();
    }
    DOM_accordion_div = _$('accordion_div');
    DOM_mainscreen = _$('mainscreen'); 
    miscFunctions.resizeMainIframe();
    window.onresize = miscFunctions.resizeMainIframe;
    onLogInFunctions.checkifLoggedIn();

    /* unfortunately, there are certain cases in 1.4 where
    * both commas and pipes aren't supported, such as when
    * doing time intervals for includes :-/
    * */
    if (ASTGUI.version.lt("1.6.0"))
    {
        top.session.delimiter = '|';
    }
};

var after_localajaxinit = function ()
{
    $P.lang(document, true);

    if (window.console && window.console.firebug && window.console.firebug == '1.2.0b7')
    {
        alert('This version of firebug is known to break the gui.\n'
            + 'Please disable firebug & reload ');
        return;
    }
    //dialog.dialogMessage({ type: 'loading', content: 'Loading ...' });
    setTimeout(loadGUI, 300);
};

/*Match to the webcgi UrlEscape function, Added by rzhang*/
function UrlEscape(str)
{ 
   var ret=""; 
   var strSpecial="!\"#$%&'()*+,/:;<=>?[]^`{|}~%"; 
   for(var i=0;i<str.length;i++)
     { 
       var chr = str.charAt(i); 
       var c=chr.charCodeAt(0); 
       
       if(strSpecial.indexOf(chr)!=-1)
       {
         ret+="%"+c.toString(16); 
       }
       else 
         ret+=chr; 
     } 
   return ret; 
}

/*Match to the webcgi UrlEscape function, Added by rzhang*/
function UrlDecode(val)
{
   if ( val == undefined || val == "" )
   {
       return "";
   }
    
   val=val.replace(/\+/g, '%20');
   var str=val.split("%");
   var cval=str[0];
   for (var i=1;i<str.length;i++)
   {
        cval+=String.fromCharCode(parseInt(str[i].substring(0,2),16))+str[i].substring(2);
   }

   return cval;
}

var getType = function(object) {
        var _t;
        return ((_t = typeof(object)) == "object" ? object == null && "null" || Object.prototype.toString.call(object).slice(8, -1) : _t).toLowerCase();
    }

function isString(o) {
   return getType(o) == "string";
}

/* Added by rzhang*/
function JSON_encode(string) 
{  
    return string.replace(/(\\|\"|\n|\r|\t|\\b|\f)/g, "\\$1");  
} 

function scan_cgi(buf)
{
    $.ajax({ type: "GET", url: "/database.zccgi", data: buf, success: scanOver });
    top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG905")});

    var url = document.URL;
    function scanOver(res)
    {
        top.dialog.clearDialog();
        var tmp = res.split("\r\n");
        if (tmp[1] == "SEARCH OK\n")
        {
            top.dialog.dialogConfirm({
                //confirmStr: $P.lang("LANG844"),
                confirmStr:$P.lang("LANG917"),
                buttons: {
                ok:  function (){
                    top.module.jumpMenu("zc_devices.html", "filter=res");
                    }
                }
            });
        }
        else
        {
            var num = tmp[1].lChop("ZCERROR_");
            top.dialog.dialogMessage({ type: 'error', content: $P.lang(zeroconfigErr[num]),  callback: function () { mWindow.location.reload(); } });
        }

    };
}
$(document).keydown(function (e) {
    var doPrevent;
    if (e.keyCode == 8) {
        var d = e.srcElement || e.target;
        if (d.tagName.toUpperCase() == 'INPUT' || d.tagName.toUpperCase() == 'TEXTAREA') {
            doPrevent = d.readOnly || d.disabled;
        }
        else
            doPrevent = true;
    }
    else
        doPrevent = false;

    if (doPrevent)
        e.preventDefault();
});

var getDisaMember = function ()
{
    var res = $.ajax({type: "post",url: "/webcgi",data: "action=disagetall&keyword=displayname,disaid", async:false});
    return eval("("+res.responseText+")").body;
}
