/*
* Asterisk-GUI	- an Asterisk configuration interface
*
* menuprompts_upload functions
*
* Copyright (C) 2006-2011, Digium, Inc.
*
* Pari Nannapaneni <pari@digium.com>
* Erin Spiceland <espiceland@digium.com>
*
* See http://www.asterisk.org for more information about
* the Asterisk project. Please do not directly contact
* any of the maintainers of this project for assistance;
* the project provides a web site, mailing lists and IRC
* channels for your use.
*
* This program is free software, distributed under the terms of
* the GNU General Public License Version 2. See the LICENSE file
* at the top of the source tree.
*
*/
/*
 * Description: UCM6100 WebGUI
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 * Modifications:
 * Remove digium related product definitions and procedures              
 * IVR Prompts:there is no "Apply Changes" when delete the prompts       
 * Support multiple languages                                            
 * 
 */
var $P = top.$;

var upload_Filename = ""; // will be updated by upload_form.html
var starteduploading = 0;
var upload_Path; // path for 'uploads' as defined in http.conf - this variable will be automatically updated from http.conf

onUploadForm_load = function ()
{
    if (!top.sessionData.httpConf.postmappings_defined || !top.sessionData.httpConf.uploadPaths['voicemenuprompts'])
    {
        var tmp_a = top.sessionData.directories.menusRecord.rChop('/');
        var u = new listOfSynActions('http.conf');
        if (!top.sessionData.httpConf.postmappings_defined)
        {
            u.new_action('newcat', 'post_mappings', '', '');
        }
        u.new_action('append', 'post_mappings', 'voicemenuprompts', tmp_a);
        u.callActions();
        top.sessionData.httpConf.postmappings_defined = true;
        top.sessionData.httpConf.uploadPaths['voicemenuprompts'] = tmp_a;
        //ASTGUI.cliCommand('reload');
    }
    var upload_action_path = (top.sessionData.httpConf.prefix) ? '/' + top.sessionData.httpConf.prefix + '/voicemenuprompts' : '/voicemenuprompts';
    _$('uploadiframe').contentWindow.document.getElementById('form22').action = upload_action_path;
};

var file_exist = function(fname)
{
    var res = true;
    if (parent.mWindow.FILENAME_LIST != undefined) {
        parent.mWindow.FILENAME_LIST.each(function(name){
            if ( fname == name )
            { 
                res = false;
                return res;
            }
        });
    }
    return res;
}

onUploadForm_beforeUploading = function ()
{
    var tmp_fname = upload_Filename;
    if ( tmp_fname.endsWith('.mp3') || tmp_fname.endsWith('.wav') || tmp_fname.endsWith('.gsm') || tmp_fname.endsWith('.ulaw') || tmp_fname.endsWith('.alaw'))
    {

        var res = file_exist(tmp_fname);
        if (res)
        {
            top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG881")});
        }
        else
        {
            top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG2146") });
        }
        return res;
    } 
    else
    {
        top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG882") });
        return false;
    }
};

function localajaxinit()
{
    $P.lang(document, true);
    //top.document.title = 'Upload a custom IVR Prompt';
	// var tmp_cmd = "action=fileOpMkdir&type=sounds_record&data=record";
	// $.ajax({type: "GET", url: "/webcgi", data: tmp_cmd, success: function(){}});
    return false;

};
