/*
* Description: UCM6100 WebGUI 
*
* Copyright (C) 2013 Grandstream Networks, Inc.
*
*/
(function ($)
{
    window.moduleMenu = function (config)
    {
        var me = this;
        me.config = $.extend(me.initConfig, config);
        me.getData();
    }
    moduleMenu.prototype = {
        initConfig: {
            url: "../locale/moduleMenuData.json",
            modulePos: 'moduleList',   //moduleList position
            menuPos: 'menuList',       //menuList position
            crumbPos: 'crumbs_div',     //crumbs position
            isDisplayName: {
                'modelName': '5120',
                'hideName': ['LAN', 'DHCP']
            },
            model_info: ""
        },
        getData: function ()
        {
            var url, 
                me = this
                config = me.config;
                url = config.url
            $.ajax({
                type: "GET",
                url: url,
                dataType: "json",
                success: function (data)
                {
                    config.data = eval(data);
                    me.generalId();
                    
                }
            });
        },
        generalId: function () {
            var me = this,
                config = me.config;
            var data = config.data;

            for (var i = 0; i < data.length; i++) {
                data[i].id = "m" + (i + 1);
                for (var j = 0; j < data[i].submenu.length; j++) {
                    data[i].submenu[j].id = "m" + (i + 1) + "_" + (j + 1);
                    for (var k = 0; k < data[i].submenu[j].submenu.length; k++) {
                        data[i].submenu[j].submenu[k].id = "m" + (i + 1) + "_" + (j + 1)+ "_" + (k + 1);
                    }
                }
            }
            me.config.data = data;
            me.init();
        },
        /*
        ### initialized component and create component main structure
        */
        init: function ()
        {
            var me = this,
                config = me.config,
                modulePos = me.modulePos = me.config.modulePos;
            menuPos = me.menuPos = me.config.menuPos;
            crumbsPos = me.crumbsPos = me.config.crumbsPos
            //create main dom's elements
            me.moduleList = $("<ul>").addClass("module").appendTo("#" + modulePos);  //moduleList ul
            me.dropDiv = $("<div>").addClass("dropdown").appendTo("#" + menuPos); //menuList ul

            $("<div>").addClass("right_bg_shadow").appendTo("#" + crumbsPos); //crumbs div
            $("<span>").addClass("crumbs").appendTo("#" + crumbsPos);
            $("<img>").addClass("refresh_icon").attr({ localeTitle: "LANG109", title: $.lang("LANG109"), border: "0", src: "./images/iframeRefresh.png" }).appendTo("#" + crumbsPos);

            //if config have data it shoud render directly 
            if (config.data)
            {
                me.loadData(config.data);
            };
        },
        /*
        ### create moduleList and menuList
        *** data:[JSON] According to the specified JSON format to generate moduleList and menuList
        */
        loadData: function (data)
        {
            var me = this;
            me.render(me.config.data = data)
        },
        render: function ()
        {
            var me = this;
            me.renderModule();     //render moduleList
        },
        renderModule: function ()
        {
            var me = this;
            var data = me.config.data;
            for (var i = 0; i < data.length; i++)
            {
                var moduleLi = $("<li>").appendTo(me.moduleList);
                me.menuList = $("<ul>").addClass("dropdown-menu")
                                       .attr("id", data[i].id)
                                       .appendTo(me.dropDiv);
                $("<a>").attr({
                            "href": "#",
                            "localeMenu": data[i].id,
                            "locale": data[i].name,
                            "id": data[i].id  
                        })
                        .html($.lang(data[i].name))
                        .appendTo(moduleLi);
                me.renderMenu(data[i]);
            }
            //$(me.moduleList.children()[0]).addClass("active");

            me.moduleList.bind("click", function (ev)
            {
                var moduleId = $(ev.target).attr('id');
                //var muduleName = $(ev.target).html();
                if (moduleId != undefined)
                {
                    $(".submenu-menu-img").hide();
                    $(".module-active").removeClass("module-active");
                    $(".menu-active").removeClass("menu-active");
                    $(".submenu-menu-a-active").removeClass("submenu-menu-a-active");
                    $(".dropdown-menu").hide();
                    $(".dropdown-menu").filter("#" + moduleId)
                                       .css("display", "block");
                    $(ev.target.parentNode).addClass("module-active")
                                           .siblings()
                                           .removeClass("module-active");
                    me.locationMenu(moduleId, 1);
                };

            });
        },
        renderMenu: function (moduleData)
        {
            var me = this;
            var menuLists = moduleData.submenu;
            for (var i = 0; i < menuLists.length; i++)
            {
                var menuLi = $("<li>").appendTo(me.menuList);
                $("<a>").appendTo(menuLi)
                        .addClass("menu-a")
                        .attr({
                            "href": menuLists[i].url,
                            "id": menuLists[i].id,
                            "localeMenu": menuLists[i].id,
                            "locale": menuLists[i].name
                        })
                        .html($.lang(menuLists[i].name));
                var menuLevelData = menuLists[i];
                me.renderMenuLevel(menuLevelData);
            }
            $("#" + moduleData.id).parent().parent().children().eq(0).addClass("module-active");
            me.locationMenu(moduleData.id, 0);
            $(".dropdown-menu").eq(0).css("display", "block");
            $(".dropdown-submenu").unbind("click mouseover mouseleave");
            //bind menu click event
            var menuClick = function (ev)
            {
                if ($(this).children().filter("a").hasClass("menu-active"))
                {
                    //click an active menu, do nothing to prevent fold the active submenu.
                    ev.stopPropagation();
                    return false;
                }
                var sibling = $(this).next();
                //var menuId = me.getMenuId(ev);
                var toggleUl = $(sibling);
                var toggleStyle = toggleUl.siblings().filter("ul");
                var submenuState = toggleUl.children().children();
                var evTarget = submenuState.eq(1);
                var url = evTarget.attr("href");
                $(this).children().filter("a").addClass("menu-active");
                $(this).siblings().filter("li").children().filter("a").removeClass("menu-active");
                $(".submenu-menu-a-active").removeClass("submenu-menu-a-active");
                $(this).children()
                       .filter("ul")
                       .removeClass("submenu-menu");
                $(sibling).filter("ul").removeClass("submenu-menu");
                $(sibling).filter("ul").attr("click", "click");
                $(this).siblings().bind("mouseover", menuMouseover);
                submenuState.removeClass("submenu-menu-line-active submenu-menu-a-active submenu-menu-line-hover submenu-menu-a-hover");
                submenuState.filter(".submenu-menu-img")
                            .css("display", "none");
                submenuState.filter(".submenu-menu-imgIe")
                            .css("display", "none");
                $(sibling).children()
                          .children()
                          .filter(".submenu-menu-line")
                          .css("display", "inline-block");
                toggleStyle.hide();
                toggleUl.filter("ul").slideToggle();
                evTarget.prev().addClass("submenu-menu-line-active");
                evTarget.addClass("submenu-menu-a-active");
                evTarget.next().css("display", "inline-block");
                setTimeout(function ()
                {
                    top.sessionData.userPage = 1;
                    top.sessionData.userSort = "";
                    top.sessionData.userBy = "";
                    $(DOM_mainscreen).contents().empty();
                    $(DOM_mainscreen).attr("src", url + "?" + version);
                    $.cookie("jumpMenu", url);
                }, 300);
                me.crumbs();
                ev.stopPropagation();
                return false;
            };
            //menuMouseover function
            var menuMouseover = function (ev)
            {
                var thisElement = this;
                var menuId = me.getMenuId(ev);
                var overUl = $("#" + menuId).next();
                if (overUl.length != 0)
                {
                    $(thisElement).addClass("dropdown-submenu-hover")
                           .siblings()
                           .filter("li")
                           .removeClass("dropdown-submenu-hover")
                           .children()
                           .filter("a")
                           .removeClass("dropdown-submenu-hover");
                    overUl.parent()
                          .siblings()
                          .filter("li")
                          .children()
                          .filter("ul")
                          .removeClass("submenu-menu");
                }
                $(".submenu-menu-line-hover").removeClass("submenu-menu-line-hover");
                $(".submenu-menu-a-hover").removeClass("submenu-menu-a-hover");
                if ($(thisElement).next().css("display") == "none")
                {
                    $(thisElement).children().eq(1).addClass("submenu-menu");
                    //$(this).children().eq(1).css("display", "block");
                    $(thisElement).siblings().filter("li")
                                      .children()
                                      .filter("ul")
                                      .children()
                                      .children()
                                      .removeClass("submenu-menu-line-active submenu-menu-a-active submenu-menu-line-hover submenu-menu-a-hover");
                    //var headerHeight = $(".header_row").css("height");
                    //var dropdown = $(".dropdown").css("top");
                    //var dropdown-submenu = $(".dropdown-submenu").css("height");
                        var top = ($(thisElement).offset().top - 130) + "px";  //130=headerHeight(96px) + dropdown(30px) + dropdown-submenu/3
                    var sibling = ev.target.nextSibling;
                    $(thisElement).children().filter("ul").css("top", top);
                    $(thisElement.children).filter("ul")
                                    .parent()
                                    .siblings()
                                    .children()
                                    .filter("ul")
                                    .removeClass("submenu-menu");
                    var lists = overUl.children();
                    lists.eq(0).addClass("dropdown-submenu-overUlFirstLi");
                    lists.eq(lists.length - 1).addClass("dropdown-submenu-overUlLastLi");
                    $(sibling).filter("ul").children()
                                           .find("span")
                                           .addClass("submenu-span");
                    $(sibling).filter("ul").bind("mouseleave", function ()
                    {
                        $(sibling).filter("ul").removeClass("submenu-menu");
                    });
                }
                var menuA = $(thisElement).children().filter("a");
                var menuText = menuA.text()
                var result = moduleMenu.prototype.textSize({
                    fontSize: "15px",
                    fontWeight: "bold"  
                }, menuA);
                if (result.width > menuA[0].offsetWidth) {
                    $(menuA).attr("title", menuText);
                }
                else {
                    $(menuA).removeAttr("title");
                }
                ev.stopPropagation();
                return false;
            }
            //menuMouseleave function
            var menuMouseleave = function (ev)
            {
                var sibling = $(ev.target).siblings();
                $(ev.target).removeClass("dropdown-submenu-hover");
                $(".submenu-menu").removeClass("submenu-menu");
                ev.stopPropagation();
                return false;
            }
            //bind submenu mouseover and mouseleave event
            $(".dropdown-submenu").bind({
                click: menuClick,
                mouseover: menuMouseover,
                mouseleave: menuMouseleave
            });
        },
        renderMenuLevel: function (obj)
        {
            var me = this;
            var menuLevels = obj.submenu;
            var submenuA, overName, overName;
            var parentLi = $("#" + obj.id).parent();
            parentLi.addClass("dropdown-submenu");
            var levelUl = $("<ul>").insertAfter(parentLi).addClass("dropdown-submenu-menu");
            var mouseoverUl = $("<ul>").appendTo(parentLi).addClass("dropdown-submenu-overUl");
            for (var i = 0; i < menuLevels.length; i++)
            {
                var name = menuLevels[i].name;
                var nameLen = name.length;
                if (me.isDisplay(name))
                {
                    var levelLi = $("<li>").appendTo(levelUl);
                    name = me.changeName(name);
                    var overLi = $("<li>").appendTo(mouseoverUl);
                    submenuA = $("<a>").appendTo(levelLi)
                                       .attr({
                                           "href": menuLevels[i].url,
                                           "id": menuLevels[i].id,
                                           "localeMenu": menuLevels[i].id
                                       })
                                       .addClass("submenu-menu-a");
                    overName = $("<a>").appendTo(overLi)
                                       .attr({
                                           "href": menuLevels[i].url,
                                           "id": menuLevels[i].id,
                                           "localeMenu": menuLevels[i].id
                                       })
                                       .addClass("submenu-menu-a");
                    submenuA.html($.lang(name)).attr("locale", name);
                    overName.html($.lang(name)).attr("locale", name);
                    $("<a>").insertBefore(submenuA).addClass("submenu-menu-line");
                    $("<a>").appendTo(levelLi).addClass("submenu-menu-img");
                }
                // if (menuLevels[i].submenu.length > 0) {
                //  me.renderMenuLevel(menuLevels[i]);
                // };
            }
            $(".submenu-menu-a").unbind("click");
            // bind submenu click event
            var submenuClick = function (ev)
            {
                var url = $(ev.target).attr("href");
                var name = $(ev.target).html();
                //var titleName = $(ev.target).attr("title");
                var evTarget = ev.target;
                var evTargetParent = evTarget.parentNode;
                var parent = evTargetParent.parentNode.parentNode;
                $(".submenu-menu-a-active").removeClass("submenu-menu-a-active");
                if ($(evTargetParent.parentNode).filter(".dropdown-submenu-overUl").length > 0)
                {
                    $(parent).children().filter("a").addClass("menu-active");
                    $(parent).siblings().filter("li").children().filter("a").removeClass("menu-active");
                    $(evTargetParent.parentNode).removeClass("submenu-menu");
                    $(evTargetParent.children).filter("a").attr("id");
                    evTarget = $(evTargetParent.parentNode.parentNode.nextSibling.children).children().filter("#" + $(evTargetParent.children).filter("a").attr("id"))[0];
                    evTargetParent = evTarget.parentNode;
                    $(evTargetParent.parentNode).siblings().filter("ul[style*='block']").hide();
                    $(evTargetParent.parentNode).slideToggle();
                }
                $(evTargetParent).siblings()
                                     .children()
                                     .removeClass("submenu-menu-line-active submenu-menu-a-active");
                $(evTargetParent).siblings()
                                     .children()
                                     .filter(".submenu-menu-img")
                                     .css("display", "none");
                if ($(evTargetParent.firstChild).not(".submenu-menu-a").length > 0)
                {
                    $(evTargetParent.firstChild).addClass("submenu-menu-line-active");
                }
                $(evTarget).addClass("submenu-menu-a-active");
                $(evTarget).next().css("display", "inline-block");
                me.crumbs();
                setTimeout(function ()
                {
                    top.sessionData.userPage = 1;
                    top.sessionData.userSort = "";
                    top.sessionData.userBy = "";
                    $(DOM_mainscreen).contents().empty();
                    $(DOM_mainscreen).attr("src", url + "?" + version);
                    $.cookie("jumpMenu", url);
                }, 300);
                ev.stopPropagation();
                return false;
            }
            $(".submenu-menu-a").bind("click", submenuClick);

            // bind submenu-a mouseover event
            $(".submenu-menu-a").bind("mouseover", function (ev)
            {
                var evTarget = ev.target;
                var evTargetParent = ev.target.parentNode;
                var submenu = evTargetParent.parentNode;
                //clear all a tags in the mouseover and click state
                $(evTargetParent).siblings()
                                     .children()
                                     .removeClass("submenu-menu-line-hover submenu-menu-a-hover");
                if ($(evTargetParent.firstChild).not(".submenu-menu-a").length > 0)
                {
                    $(evTargetParent.firstChild).addClass("submenu-menu-line-hover");
                }
                $(evTarget).addClass("submenu-menu-a-hover");
                $(submenu).prev()
                              .filter("li")
                              .children()
                              .filter("a")
                              .addClass("menu-active");
                var result = moduleMenu.prototype.textSize({
                    fontSize: "14px",
                    fontWeight: ""
                }, $(this));
                if (result.width > this.offsetWidth) {
                    $(this).attr("title", $(this).text());
                }
                else {
                    $(this).removeAttr("title");
                }
                ev.stopPropagation();
                return false;
            });

            // bind dropdown-submenu-overUl mouseleave event
            $(".dropdown-submenu-overUl").bind("mouseleave", function (ev)
            {
                $(this).parent().removeClass("dropdown-submenu-hover");
                $(this).removeClass("submenu-menu");
                ev.stopPropagation();
                return false;
            });
        },
        getMenuId: function (ev)
        {
            var menuId = $(ev.target.children).attr('id');
            if (menuId == undefined)
            {
                menuId = $(ev.target).attr('id');
                if (menuId == undefined)
                {
                    return;
                }
            }
            return menuId;
        },
        locationMenu: function (id, status)
        {
            var me = this;
            var firstLi = $(".dropdown-menu").filter("#" + id).children().eq(0);
            var firstLiChildren = firstLi.next().children().eq(0).children();
            var firstLiSiblings = firstLi.siblings();
            var url = firstLiChildren.eq(1).attr("href");
            if (status == 1)
            {
                $(".submenu-menu-line-hover").removeClass("submenu-menu-line-hover");
                $(".submenu-menu-a-hover").removeClass("submenu-menu-a-hover");
                $(".submenu-menu-line-active").removeClass("submenu-menu-line-active");
                $(".submenu-menu-a-active").removeClass("submenu-menu-a-active");
                if ($.browser.msie)
                {
                    $(".submenu-menu-imgIe").css("display", "none");
                }
                else
                {
                    $(".submenu-menu-img").css("display", "none");
                }
                setTimeout(function ()
                {
                    top.sessionData.userPage = 1;
                    top.sessionData.userSort = "";
                    top.sessionData.userBy = "";
                    $(DOM_mainscreen).contents().empty();
                    $(DOM_mainscreen).attr("src", url + "?" + version);
                    $.cookie("jumpMenu", url);
                }, 300);
            }
            firstLi.children()
                   .filter("ul")
                   .removeClass("submenu-menu")
                   .parent()
                   .siblings()
                   .children()
                   .filter("ul")
                   .removeClass("submenu-menu");
            firstLi.children()
                   .filter("a")
                   .addClass("menu-active");
            firstLiSiblings.filter("ul")
                           .hide();
            firstLiSiblings.filter("li")
                           .children()
                           .filter("a")
                           .removeClass("dropdown-submenu-hover");
            firstLiSiblings.filter("li")
                           .removeClass("dropdown-submenu-hover")
                           .children()
                           .removeClass("menu-active");
            firstLiChildren.eq(0).addClass("submenu-menu-line-active");
            firstLiChildren.eq(1).addClass("submenu-menu-a-active");
            firstLiChildren.eq(2).css("display", "inline-block");
            firstLi.next().css("display", "block");
            me.crumbs();
        },
        jumpMenu: function (src, transParam) {
            var me = this;
            var labelA = $("a[href='"+src+"']");

            //jump module
            var moduleId = labelA.parent().parent().parent().attr('id');
            if (moduleId != undefined)
            {
                $(".module-active").removeClass("module-active");
                $(".menu-active").removeClass("menu-active");
                $(".submenu-menu-a-active").removeClass("submenu-menu-a-active");
                $(".dropdown-menu").hide();
                $(".dropdown-menu").filter("#" + moduleId)
                                   .css("display", "block");
                $('#' + me.initConfig.modulePos + ' #' + moduleId).parent().addClass("module-active")
                                       .siblings()
                                       .removeClass("module-active");
                //me.locationMenu(moduleId, 1);
            };

            //jump menu
            var labelUl = $("a[href='"+src+"']").parent().parent().filter(".dropdown-submenu-menu");
            if (labelUl.css("display") == "none") {
                labelUl.slideToggle();
            }
            labelUl.siblings().filter("ul").hide();
            me.clearClass();
            labelUl.prev().find("a").eq(0).addClass("menu-active");
            labelA.addClass("submenu-menu-a-active");
            labelA.siblings().eq(0).addClass("submenu-menu-line-active");
            labelA.siblings().eq(1).css("display", "inline-block");
            setTimeout(function ()
            {
                top.sessionData.userPage = 1;
                top.sessionData.userSort = "";
                top.sessionData.userBy = "";
                $(DOM_mainscreen).contents().empty();
                if (transParam) {
                    $(DOM_mainscreen).attr("src", src + "?" + version + "&" + transParam);
                }
                else {
                    $(DOM_mainscreen).attr("src", src + "?" + version);
                }
                $.cookie("jumpMenu", src);
            }, 300);
            me.crumbs();
        },
        clearClass: function () {
            $(".submenu-menu-img").hide();
            $(".menu-active").removeClass("menu-active");
            $(".submenu-menu-line-hover").removeClass("submenu-menu-line-hover");
            $(".submenu-menu-a-hover").removeClass("submenu-menu-a-hover");
            $(".submenu-menu-a-active").removeClass("submenu-menu-a-active");
            $(".submenu-menu-line-active").removeClass("submenu-menu-line-active");
        },
        crumbs: function ()
        {
            var moduleName = $(".module-active > a").attr("locale");
            var menuName = $(".menu-active").attr("locale");
            var submenuName = $(".submenu-menu-a-active").attr("locale");
            if (submenuName == undefined)
            {
                submenuName = $(".submenu-menu-a-active").attr("locale");
            }
            var crumbsStr = "<font locale="+moduleName+">"+$.lang(moduleName)+"</font>" + " >> " + "<font locale="+menuName+">"+$.lang(menuName)+"</font>" + " >> " + "<font locale="+submenuName+">"+$.lang(submenuName)+"</font>";
            $(".crumbs").html(crumbsStr);
            $(".refresh_icon").bind("click", function (ev)
            {
                setTimeout(function ()
                {
                    var src = $(".submenu-menu-a-active").attr("href");
                    top.sessionData.userPage = 1;
                    top.sessionData.userSort = "";
                    top.sessionData.userBy = "";
                    $(DOM_mainscreen).contents().empty();
                    $(DOM_mainscreen).attr("src", src + "?" + version);
                    $.cookie("jumpMenu", src);
                }, 50);
                ev.stopPropagation();
                return false;
            });
        },
        isDisplay: function (submenuName)
        {
            var me = this, config = me.config;
            var name = config.isDisplayName.modelName;
            var hideName = config.isDisplayName.hideName;
            var namePos = config.model_info.model_name.indexOf(name);

            var allow_nat = config.model_info.allow_nat;
            var p231 = config.model_info.P231;

            // hide the dynamic defense in the switch mode
            //if ( p231 != null && p231 == "1" )
            //{
            //    if ( submenuName == "LANG2303" )
            //        return false;
            //}

            if ( (allow_nat != null && allow_nat == "0") || (allow_nat == null && namePos < 0) )
            {
                /*
                for (var i = 0; i < hideName.length; i++)
                {
                    if (submenuName == hideName[i])
                    {
                        return false;
                    }
                }
                */
                if ( $.inArray(submenuName, hideName) != -1 )
                    return false;
                return true;
            }
            else 
            {
                return true;
            }
        },
        changeName: function (name) {
            var me = this, config = me.config;
            var modelName = config.isDisplayName.modelName;
            var modelInfo = config.model_info.model_name;
            var originalName = config.changes.originalName;
            var newName = config.changes.newName;
            var allow_nat = config.model_info.allow_nat;
            if ( (allow_nat != null && allow_nat == "0") || (allow_nat == null && modelName.indexOf(modelInfo) < 0) ){
                if (originalName == name) {
                    return newName;
                }
                else{
                    return name;
                }
            }
            else{
                return name;
            }
        },
        textSize: function (styles, obj) {
            var text = obj.text();
            var a = document.createElement("a");
            var result = {};
            result.width = a.offsetWidth;
            result.height = a.offsetWidth;
            if (obj instanceof jQuery && obj.hasClass("submenu-menu-a-active")) {
                $(a).addClass("submenu-menu-a-active"); 
            }
            a.style.fontSize=styles.fontSize;
            a.style.fontWeight=styles.fontWeight;
            a.style.visibility = "hidden";
            document.body.appendChild(a);
            if (typeof a.textContent != "undefined")
                a.textContent = text;
            else a.innerText = text;
            result.width = a.offsetWidth - result.width;
            result.height = a.offsetHeight - result.height;
            a.parentNode.removeChild(a);
            return result;
        }
    };
})(jQuery)
