/*
* Asterisk-GUI  - an Asterisk configuration interface
*
* mohfiles.html functions
*
* Copyright (C) 2006-2011, Digium, Inc.
*
* Pari Nannapaneni <pari@digium.com>
* Erin Spiceland <espiceland@digium.com>
*
* See http://www.asterisk.org for more information about
* the Asterisk project. Please do not directly contact
* any of the maintainers of this project for assistance;
* the project provides a web site, mailing lists and IRC
* channels for your use.
*
* This program is free software, distributed under the terms of
* the GNU General Public License Version 2. See the LICENSE file
* at the top of the source tree.
*
*/
/*
 * Description: UCM6100 WebGUI
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 * Modifications:
 * Remove digium related product definitions and procedures                    
 * Modify upload realization                                  
 * 
 */
$P = top.$;
var mWindow = window;
var mohdirPrefix = 'guimohdir_';
var CURRENTMOH_CLASSNAME = '';
var CURRENTMOH_PATH = '';
var CURRENTMOH_PATH_PM_NAME = ''; // postmappings name given to current path in http.conf
var upload_Filename = ""; // will be updated by upload_form.html
var starteduploading = 0;
var IFRAME_CREATED = false;
var MOHLIST = [];
var select = "";
window.onload = function ()
{
    $P.lang(document, true);
    mode = gup("mode");
    select = decodeURI(gup("select"));
    if (mode)
    {
        mWindow = top.window.frames["mainscreen"]; // this will be the main window 

        $('#mohClass_sort').on('click', function(event){
            $("#select").css("background-position", "0px -22px");
        }).on('change', function(event){
            $("#select").html($('#mohClass_sort option[value="'+$('#mohClass_sort').val()+'"]').html());
        });
        if (mode == "add")
        {
            //ASTGUI.domActions.alignBontopofA('mohclass_addButton', 'div_newMOH_Class');
            $("#div_newMOH_Class").show();
            $('#New_mohClass_name').focus();
            $('#mohClass_sort option[value="random"]').attr("selected", true);
            $('#select').html($('#mohClass_sort option[value="random"]').html());
        }
        else if(mode == "edit"){
            var configs = config2json({ filename: 'musiconhold.conf', usf: 1 });
            $("#div_newMOH_Class").show();
            $('#New_mohClass_name').val(select).attr({
                'readonly': true,
                'disabled': 'disabled'   
            });
            $('#mohClass_sort option[value="'+configs[select].sort+'"]').attr("selected", true);
            $('#select').html($('#mohClass_sort option[value="'+configs[select].sort+'"]').html());
        }

        if ($("#form").tooltip) {
            $("#form").tooltip();
        }
        $P("#form", document).validate({
            rules: {
                "New_mohClass_name": {
                    required: true,
                    isExist: [$P.lang("LANG270").format($P.lang("LANG1603")), isExist],
                    letterDigitUndHyphen: true
                }
            },
            submitHandler: function() {
                manage_moh.save_MohClass();
            }
        });
        top.Custom.init(document);
        return false;
    }
    else
    {
        top.document.title = $P.lang("LANG584").format(top.model_info.model_name, $P.lang("LANG671"));
        $("title").attr("locale", "LANG671");

        var showEditForm = function(){
            select = _$('moh_classes').options[_$('moh_classes').selectedIndex].text;
            top.dialog.dialogInnerhtml({
                dialogTitle: $P.lang("LANG2505"),
                frameSrc: "mohfiles_modal.html?mode=edit&select=" + select
            });
        };

        $('#mohclass_editButton').on("click", showEditForm);
        $('#mohclass_deleteButton').on("click", manage_moh.delete_MohClass);

        manage_moh.load_mohClasses();
        ASTGUI.events.add('moh_classes', 'change', manage_moh.select_MohClass);
        if (select) {
            if (select != "undefined") {
                var count=$("#moh_classes option").length;
                for(var i=0;i<count;i++)  
                {
                    if($("#moh_classes").get(0).options[i].text == select)  
                    {  
                        $("#moh_classes").get(0).options[i].selected = true;  
                        break;  
                    }  
                }
            }
            else {
                $("#moh_classes").get(0).options[0].selected = true;
            }
        }
        else {
            $("#moh_classes").get(0).options[0].selected = true;
        }
        $('#thispageContent').hide();
        $('#mohclass_deleteButton').show();
        CURRENTMOH_CLASSNAME = _$('moh_classes').options[_$('moh_classes').selectedIndex].text;
        CURRENTMOH_PATH = _$('moh_classes').value;
        CURRENTMOH_PATH_PM_NAME = manage_moh.get_PostMappingsName(CURRENTMOH_PATH);
        manage_moh.update_listofFilesTable();
        top.Custom.init(document);
    }
};

var onUploadForm_load = function ()
{
    var tmp_a = (parent.sessionData.httpConf.prefix) ? parent.sessionData.httpConf.prefix : '';
    var tmp = (tmp_a) ? '/' + tmp_a + '/' + CURRENTMOH_PATH_PM_NAME : '/' + CURRENTMOH_PATH_PM_NAME;
    _$('uploadiframe').contentWindow.document.getElementById('form22').action = tmp;
};

var onUploadForm_beforeUploading = function ()
{
    var tmp_fname = upload_Filename;
    if (tmp_fname.endsWith('.mp3') || tmp_fname.endsWith('.wav') || tmp_fname.endsWith('.gsm') || tmp_fname.endsWith('.ulaw') || tmp_fname.endsWith('.alaw'))
    {
        starteduploading = 1;
		top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG866")});
        return true;
    } else
    {
        starteduploading = 0;
        top.dialog.dialogMessage({ type: 'error', content: $P.lang("LANG867") });
        return false;
    }
};

var onUploadForm_unload = function ()
{
    if (!starteduploading) { return; }
    top.dialog.dialogMessage({ type: 'loading', content:  $P.lang("LANG868")});
    $('#uploadForm_container').hide();
    setTimeout(function ()
    {
        top.dialog.clearDialog();
        top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG906"), callback: function () { mWindow.location.reload(); } });
    }, 1000);
    return;
};

var getLocalhref = function(){
    var url = mWindow.location.href;
    var search = mWindow.location.search;
    if(search != "")
    {
        url = url.substring(0, url.indexOf(search));
    }
    return url;
}
var isExist = function() {
    if(mode == "edit"){
        return true;
    }else if(mode == "add"){
        var tmp_moh_classname = _$('New_mohClass_name').value.trim().toLowerCase();
        var options = parent.window.frames["mainscreen"].$("select").children();
        var mohLists = options.length;
        var mohListsArr = new Array;
        for(var i = 0; i < mohLists; i++)
        {
            mohListsArr[i] = options.eq(i).text().toLowerCase();
        }
        if ($.inArray(tmp_moh_classname, mohListsArr) < 0) {
            return true
        }   
        else{
            return false;
        }
    }
}
var manage_moh = {
    load_mohClasses: function ()
    { // manage_moh.load_mohClasses();
        var mcls = config2json({ filename: 'musiconhold.conf', usf: 1 });
        for (var this_class in mcls)
        {
            if (mcls.hasOwnProperty(this_class))
            {
                if (this_class != "rbt")
                {
                    ASTGUI.selectbox.append('moh_classes', this_class, mcls[this_class].directory);
                    MOHLIST.push(this_class);
                }
            }
        }
        if (_$('moh_classes') != null)
        {
            _$('moh_classes').selectedIndex = -1;
        }
    },

    delete_file: function (filename)
    {
        var tmp_moh_classname = _$('moh_classes').options[_$('moh_classes').selectedIndex].text;
        if (tmp_moh_classname == 'default')
        {
            var table = _$('soundFilesTable');
            if (table.rows.length == 2)  /* It includes the title, so length is 2 when there is only one file*/
            {
                top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG870") });
                return;
            }
        }
        top.dialog.dialogConfirm({
            confirmStr: $P.lang("LANG818").format(filename),
            buttons:{
                ok: function ()
                {
					var pos = CURRENTMOH_PATH.indexOf('guimohdir');
					var dir = CURRENTMOH_PATH.substring(pos, CURRENTMOH_PATH.length) + '/';
					if ( pos > -1 )
                    {
                        var tmp_cmd = "action=fileOpDelete&type=moh&data=" + encodeURI(dir+filename);
                    }
                    else
                    {
                        var tmp_cmd = "action=fileOpDelete&type=moh&data=" + encodeURI(filename);
                    }

                    var cb = function()
                    {
                        url = getLocalhref();
                        top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG871"), callback: function(){top.DOM_mainscreen.src = url + "?select=" + select } });
                    }
                    $.ajax({type: "GET", url: "/webcgi", data: tmp_cmd, success: cb});
                }
            }
        });
    },

    update_listofFilesTable: function ()
    { // manage_moh.update_listofFilesTable();
        var addrow_totable = function (filename)
        {
            var newRow = _$('soundFilesTable').insertRow(-1);
            newRow.className = ((_$('soundFilesTable').rows.length) % 2 == 1) ? 'odd' : 'even';
            ASTGUI.domActions.tr_addCell(newRow, { html: filename, align: 'left',width:"500px" });
            var tmp = "<button class='options del' localetitle=\"LANG739\" title=" + $P.lang("LANG739") + "></button>&nbsp;";
            ASTGUI.domActions.tr_addCell(newRow, { html: tmp, align: 'center' });
        };
        $('#thispageContent').hide();
		top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG875")});
        parent.ASTGUI.listSystemFiles(CURRENTMOH_PATH + '/', function (sndfiles)
        {
            try
            {
                ASTGUI.domActions.clear_table(_$('soundFilesTable'));
                var newRow = _$('soundFilesTable').insertRow(-1);
                newRow.className = 'frow';
                ASTGUI.domActions.tr_addCell(newRow, { html: $P.lang("LANG1606"), align: 'left', width:"500px",locale: "LANG1606"});
                ASTGUI.domActions.tr_addCell(newRow, { html:  $P.lang("LANG74"), align: 'center',locale: "LANG74"});

                for (var i = 0; i < sndfiles.length; i++)
                {
                    if (!sndfiles[i].beginsWith(mohdirPrefix) && (sndfiles[i].endsWith('.mp3') || sndfiles[i].endsWith('.wav') || sndfiles[i].endsWith('.gsm') || sndfiles[i].endsWith('.alaw') || sndfiles[i].endsWith('.ulaw')))
                    {
                        addrow_totable(sndfiles[i].stripTags(), i);
                    }
                }
                var _sft = _$('soundFilesTable');
                if (_sft.rows.length == 1)
                {
                    ASTGUI.domActions.clear_table(_$('soundFilesTable'));
                    var newRow = _sft.insertRow(-1);
                    var newCell0 = newRow.insertCell(0);
                    newCell0.align = "center";
                    newCell0.innerHTML = "<a locale=\"LANG1605\">"+ $P.lang("LANG1605") +"</a>";
                }
            } finally
            {
                if (!IFRAME_CREATED)
                {
                    var url = "";
                    var uploadIframe = $("<iframe frameborder='0'>").appendTo($("#uploadForm_container")).attr({ id: 'uploadiframe', name: 'uploadiframe', marginheight: '0', marginwidth: '0',  scrolling: 'auto', width: '100%', height: '60px' });
			     if (CURRENTMOH_CLASSNAME == "default")
			     {
                            url = 'upload_form.html?type=moh'
                            $(uploadIframe).attr("src", url);
			     }
			     else
			     {
                            url = 'upload_form.html?type=moh&data=' + encodeURI(mohdirPrefix + CURRENTMOH_CLASSNAME);
                            $(uploadIframe).attr("src", url);
			     }
			     IFRAME_CREATED = true;
                }
                $('#uploadForm_container').show();
                $('#thispageContent').show();
                top.dialog.clearDialog();
            }
        });
        $("#soundFilesTable .del").live("click", function (ev) {
            var filename = $(this).parent().siblings().text()
            manage_moh.delete_file(filename);
            ev.stopPropagation();
            return false;
        });
    },

    delete_MohClass: function ()
    { // manage_moh.delete_MohClass();
        var tmp_moh_classname = _$('moh_classes').options[_$('moh_classes').selectedIndex].text;
        var tmp_MOH_PATH = _$('moh_classes').value;
        if (!tmp_moh_classname)
        {
            top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG830") });
            return;
        }
        if (tmp_moh_classname == 'default')
        {
            top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG831") });
            return;
        }

        top.dialog.dialogConfirm({
            confirmStr: $P.lang("LANG818").format(tmp_moh_classname),
            buttons: {
                ok: function ()
                {
                    var tmp_MOH_PATH_PM_NAME = manage_moh.get_PostMappingsName(tmp_MOH_PATH);

                    top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG872")});
                    // delete entry from musiconhold.conf
                    var u = new listOfSynActions('musiconhold.conf');
                    u.new_action('delcat', tmp_moh_classname, '', '');
                    u.callActions();

                    // delete entry from http.conf 
                    u.clearActions('http.conf');
                    u.new_action('delete', 'post_mappings', tmp_MOH_PATH_PM_NAME, '');
                    u.callActions();

                    // delete dir on disk
					var tmp_cmd = "action=fileOpDelete&type=moh&data=" + encodeURI(tmp_MOH_PATH_PM_NAME);
					var cb = function()
                    {
                        url = getLocalhref();
                        ASTGUI.cliCommand('reload'); // reload asterisk
                        top.dialog.clearDialog();
                        top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG873"), callback: function(){
                            setTimeout(function() {
                            top.DOM_mainscreen.src = url
                        }, 1000)} });
                    }
					$.ajax({type: "GET", url: "/webcgi", data: tmp_cmd, success: cb});
                }
            }
        });
    },

    save_MohClass: function ()
    { // manage_moh.save_MohClass()
        if(mode == "add"){
            top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG874")});
        }else{
            top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG2508")});
        }

        setTimeout(function(){
            if ($P("#form", document).valid()){
                var tmp_moh_classname = _$('New_mohClass_name').value.trim();
                var tmp_moh_sort = _$('mohClass_sort').value;
                var tmp_MOH_PATH_PM_NAME = mohdirPrefix + tmp_moh_classname;
                var tmp_MOH_PATH = top.sessionData.directories.MOH + tmp_MOH_PATH_PM_NAME;
                var u = new listOfSynActions('musiconhold.conf');
    
                if(mode == "add"){
                    // create entry from musiconhold.conf
                    u.new_action('newcat', tmp_moh_classname, '', '');
                    u.new_action('append', tmp_moh_classname, 'directory', tmp_MOH_PATH);
                    u.new_action('append', tmp_moh_classname, 'mode', 'files');
                    u.new_action('append', tmp_moh_classname, 'sort', tmp_moh_sort);
                    u.callActions();
    
                    // create entry from http.conf 
                    u.clearActions('http.conf');
                    u.new_action('update', 'post_mappings', tmp_MOH_PATH_PM_NAME, tmp_MOH_PATH);
                    u.callActions();
    
                    // create dir on disk
    	        var tmp_cmd = "action=fileOpMkdir&type=moh&data=" + encodeURI(tmp_MOH_PATH_PM_NAME);
    	        var cb = function()
                    {
                        url = getLocalhref();
                        ASTGUI.cliCommand('reload'); // reload asterisk
                        top.dialog.clearDialog();
                        top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG815"), callback: function(){top.DOM_mainscreen.src = url + "?select=" + tmp_moh_classname } });
                    }
    	        $.ajax({type: "GET", url: "/webcgi", data: tmp_cmd, success: cb});
                }
                else if(mode == "edit"){
                    u.new_action('autoupdate', tmp_moh_classname, 'sort', tmp_moh_sort);
                    u.new_action('delete', tmp_moh_classname, 'random', '');
    
                    var after = function(){
                        url = getLocalhref();
                        ASTGUI.cliCommand('reload'); // reload asterisk
                        top.dialog.clearDialog();
                        top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG815"), callback: function(){top.DOM_mainscreen.src = url + "?select=" + select } });
                    };
                    u.callActions(after);
                }
            }
        }, 100);
    },

    show_AddMohClass_form: function ()
    {
        ASTGUI.domActions.alignBontopofA('mohclass_addButton', 'div_newMOH_Class');
        $('#div_newMOH_Class').show();
        _$('New_mohClass_name').focus();
    },

    select_MohClass: function ()
    { // manage_moh.select_MohClass();
        $("#uploadForm_container").find("iframe").remove();
        IFRAME_CREATED = false;
        $('#thispageContent').hide();
        $('#mohclass_deleteButton').show();
        CURRENTMOH_CLASSNAME = _$('moh_classes').options[_$('moh_classes').selectedIndex].text;
        select = encodeURI(CURRENTMOH_CLASSNAME);
        $("#moh_classes").get(0).options[_$('moh_classes').selectedIndex].selected = true;
        CURRENTMOH_PATH = _$('moh_classes').value;
        CURRENTMOH_PATH_PM_NAME = manage_moh.get_PostMappingsName(CURRENTMOH_PATH);
        // _$('label_selectedClass').innerHTML = "manage MOH class - <B>'" + CURRENTMOH_CLASSNAME + "'</B>";
        manage_moh.update_listofFilesTable();
    },

    get_PostMappingsName: function (some_path)
    {
        // lookup this path in http.conf and return the name
        var t = context2json({ filename: 'http.conf', context: 'post_mappings', usf: 1 });
        for (var this_path_label in t)
        {
            if (t.hasOwnProperty(this_path_label))
            {
                if (t[this_path_label] == some_path)
                    return this_path_label;
            }
        }
        // TODO : if path is not found add new one and reload asterisk
        return '';
    }
};
