/*
 * Description: UCM6100 WebGUI
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 * Modifications:
 *  Added support for paging settings
 *
 */
$P = top.$;
var mWindow = window;


window.onload = function ()
{
    $P.lang(document, true);
    mWindow = top.window.frames["mainscreen"]; // this will be the main window 
    initForm();
    $("#text_pgExten").focus();
    return false; // bypass reload dialog
};


var initForm = function ()
{
    var c = context2json({ filename: 'extensions.conf', context: 'globals', usf: 1 });
    ASTGUI.updateFieldToValue('text_Alert_Info_Header', c.getProperty('PAGING_HEADER'));

	if ($("#form").tooltip) {
		$("#form").tooltip();
	}
	$P("#form", document).validate({
		rules: {
			"text_Alert_Info_Header": {
				required: true, 
				alphanumeric: true
			}
		},
        submitHandler: function() {
            saveSettings_work();
        }
	});

}

var saveSettings_work = function ()
{
    ASTGUI.updateaValue({ file: 'extensions.conf', context: 'globals', variable: 'PAGING_HEADER', value: ASTGUI.getFieldValue('text_Alert_Info_Header') });

    var action = new listOfActions('extensions.conf');
    action.new_action('autoupdate', 'globals', 'PAGING_HEADER', ASTGUI.getFieldValue('text_Alert_Info_Header'));
    action.callActions( function (success, err_msg) {
        if (success)
        {
            top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG844"), callback: function () { mWindow.location.reload(); } });
        }
        else
        {
            top.dialog.dialogMessage({ type: 'error', content: err_msg, callback: function () { mWindow.location.reload(); } });
        }

    });
};

var link= function()
{
    top.dialog.clearDialog();
    top.module.jumpMenu("features.html");
};

