/*
* Asterisk-GUI  - an Asterisk configuration interface
*
* sip.html functions
*
* Copyright (C) 2006-2008, Digium, Inc.
*
* Pari Nannapaneni <pari@digium.com>
*
* See http://www.asterisk.org for more information about
* the Asterisk project. Please do not directly contact
* any of the maintainers of this project for assistance;
* the project provides a web site, mailing lists and IRC
* channels for your use.
*
* This program is free software, distributed under the terms of
* the GNU General Public License Version 2. See the LICENSE file
* at the top of the source tree.
*
*/
/*
 * Description: UCM6100 WebGUI
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 * Modifications:
 * Added support for IE10
 * Added support for multi-language
 * 
 */
// Realtime options - 'rtautoclear','rtcachefriends','rtsavesysname','rtupdate','ignoreregexpire'
$P = top.$;

var fieldnames = ['localnet', 'allowexternaldomains', 'allowguest', 'allowoverlap', 'allowsubscribe', 'allowtransfer', 'alwaysauthreject', 'autodomain', 'bindaddr', 'bindport', 'callevents', 'canreinvite', 'compactheaders', 'context', 'defaultexpiry', 'domain', 'dtmfmode', 'dumphistory', 'externhost', 'externip', 'externtcpport', 'externtlsport', 'externrefresh', 'fromdomain', 'g726nonstandard', 'jbenable', 'jbforce', 'jbimpl', 'jblog', 'jbmaxsize', 'jbresyncthreshold', 'language', 'maxcallbitrate', 'maxexpiry', 'minexpiry', 'mohinterpret', 'mohsuggest', 'mwi_from', 'nat', 'notifyringing', 'progressinband', /*'promiscredir',*/ 'realm', 'recordhistory', /*'register',*/ 'registerattempts', 'registertimeout', 'relaxdtmf', 'rtpholdtimeout', 'rtptimeout', 'sendrpid', 'sipdebug', 'srvlookup', 'subscribecontext', /* 't1min',*/ /*'t38pt_udptl' ,*/'tos_audio', 'tos_sip', 'tos_video', 'trustrpid', 'useragent', 'usereqphone', 'videosupport'];
var fieldnames2 = ['stunaddr', 'stunrefresh'];
// added by dcwei 2012-11-08
var OLD_REALM = '';
var bindportVal, bindaddrVal, srvlookupVal;
window.onload = function ()
{
    $P.lang(document, true);
    top.document.title = $P.lang("LANG584").format(top.model_info.model_name, $P.lang("LANG690"));
    $("title").attr("locale", "LANG690");
    var c = context2json({ filename: 'sip.conf', context: 'general', usf: 1 });
    var d = context2json({ filename: 'res_stun_monitor.conf', context: 'general', usf: 1 });
    var AU = ASTGUI.updateFieldToValue; // temporarily cache function
    fieldnames.each(function (fld)
    {
        var val = (c[fld]) ? c[fld] : '';
        if (fld == "bindport") {
            bindportVal = val;
        }
        else if (fld == "bindaddr") {
            bindaddrVal = val;
        }
        else if ( fld == "srvlookup" )
        {
            srvlookupVal = val;
        }
        
        AU(fld, val);
        if (_$(fld)) {
            if ( (fld === 'mohinterpret' || fld === 'mohsuggest') && _$(fld).selectedIndex === -1 )
            {
                ASTGUI.updateFieldToValue(fld, 'default');
            }
        }
        else
        {   
            /*Judgement: is on the NAT page*/
            var table = document.getElementById("localnetTable");
            if ( table != undefined && fld === 'localnet' )
            {
                var rowID = 0;
                var net_array = val.split(",");
                var CIDR_mask = "0";
                net_array.forEach(function(entry) {
                    var addr = entry.split("/");
                    /*parse /255.255.255.0 to /24 */
                    if (addr[1]) {
                        if ( addr[1].indexOf(".") != -1 )
                        {
                            CIDR_mask = DDNtoCIDR(addr[1]).toString();
                        }
                        else
                        {
                            CIDR_mask = addr[1];
                        }
                    }
                    if ( rowID == 0 )
                    {
                        input = document.getElementById("localnet0");
                        check = document.getElementById("subnetmask0");
                        if (input && check) {
                            input.value = addr[0];
                            for (var c = 0; c < 32; c++)
                            {
                                if ( check.options[c].value == CIDR_mask )
                                {
                                    check.options[c].selected=true;
                                    break;
                                }
                            }
                        }
                    }
                    else
                    {
                        btn = document.getElementById("btn"+(rowID-1));
                        addRow(btn, "localnetTable");
                        input = document.getElementById("localnet"+rowID);
                        check = document.getElementById("subnetmask"+rowID);
                        input.value = addr[0];
                        for (var c = 0; c < 32; c++)
                        {
                            if (check.options[c].value == CIDR_mask)
                            {
                                check.options[c].selected=true;
                                break;
                            }
                        }
                        
                    }
                    rowID++;
                })
            }

            /*Judgement: is on the General page*/
            var table = document.getElementById("domainTable");
            if ( table != undefined && fld === 'domain' )
            {
                var rowID = 0;
                var domain_array = val.split(",");
                domain_array.forEach(function(entry) {
                    
                    if ( rowID == 0 )
                    {
                        input = document.getElementById("domain0");
                        if (input) {
                            input.value = entry;
                        }
                    }
                    else
                    {
                        btn = document.getElementById("btndomain"+(rowID-1));
                        addDomainRow(btn, "domainTable");
                        input = document.getElementById("domain"+rowID);
                        input.value = entry;
                    }
                    rowID++;
                })
            }
        }
    });
    fieldnames2.each(function (fldd)
    {
        var val = (d[fldd]) ? d[fldd] : '';
        AU(fldd, val);
    });
    // added by dcwei 2012-11-08
    OLD_REALM = c['realm'];

    var disallowed = [];
    var real_codecs;
    ASTGUI.CODECSLIST.populateCodecsList(_$('allow'));
    if (c.hasOwnProperty('allow')) { real_codecs = c['allow']; }
    if (c.hasOwnProperty('disallow')) { disallowed = c['disallow'].split(','); }
    var default_selected = ['ulaw', 'alaw', 'gsm'];
    default_selected.each(function (val)
    {
        if (!disallowed.contains(val) && !c.hasOwnProperty('allow'))
        {
            real_codecs = real_codecs + "," + val;
        }
    });
    ASTGUI.CODECSLIST.selectCodecs(_$('allow'), real_codecs);
    top.Custom.init(document);
}

function addRow(btn, tableID) {

    var table = document.getElementById(tableID);
    
    var rowIndex = btn.parentElement.parentElement.rowIndex;
    //btn.className = "btn_del";
    //btn.onclick = Function ("deleteRow(this, '"+tableID+"');");

    var rowCount = table.rows.length;
    var maxCount = 10; 
    if (rowCount >= maxCount)
    {
        top.dialog.clearDialog();
        top.dialog.dialogMessage({ type: 'error', content: $P.lang("LANG808").format(maxCount, $P.lang('LANG1845'))});
        return;
    }
    
    var row = table.insertRow(rowCount);
    ++row_ID;
    var colCount = table.rows[0].cells.length;

    for(var i=0; i<colCount; i++) {

        var newcell = row.insertCell(i);
        newcell.innerHTML = table.rows[0].cells[i].innerHTML;
        
        //alert(newcell.childNodes);
        switch(newcell.childNodes[0].type) {
            case "text":
                    newcell.childNodes[0].value = "";
                    newcell.childNodes[0].id = "localnet"+row_ID;
                    newcell.childNodes[0].name = "localnet"+row_ID;
                    $P(newcell.childNodes[0]).rules("add", {required:true,ipAddress:true});
                    break;
            case "select-one":
                    //newcell.childNodes[0].selectedIndex = 8;
                    newcell.childNodes[0].id="subnetmask"+row_ID; 
                    newcell.childNodes[0].name="subnetmask"+row_ID;
                    break;
            case "button":
                    newcell.childNodes[0].className = "btn_del";    
                    newcell.childNodes[0].id="btn"+row_ID;
                    newcell.childNodes[0].onclick = Function ("deleteRow(this, '"+tableID+"');");
                    break;
        }
    }
};

function deleteRow(btn, tableID) {
    var table = document.getElementById(tableID);
    var rowCount = table.rows.length;
    var rowIndex = btn.parentElement.parentElement.rowIndex;
    
    if( rowCount > rowIndex )
    {
        table.deleteRow(rowIndex);
    }
    
    //rowCount = table.rows.length;
    //if( rowCount <= 1 || rowCount == row )
    //{
    //    /*Changed the function to 'Add'*/
    //    btn.className = "btn_add";
    //    btn.onclick = Function ("addRow(this, '"+tableID+"');");
    //}
};	
 
 
function addDomainRow(btn, tableID) {

    var table = document.getElementById(tableID);
    
    var rowIndex = btn.parentElement.parentElement.rowIndex;
    //btn.className = "btn_del";
    //btn.onclick = Function ("deleteRow(this, '"+tableID+"');");

    var rowCount = table.rows.length;
    
    if (rowCount >= 10)
    {
        top.dialog.clearDialog();
        top.dialog.dialogMessage({ type: 'error', content: $P.lang("LANG948") });
        return;
    }
    
    var row = table.insertRow(rowCount);
    ++row_domain_ID;
    var colCount = table.rows[0].cells.length;

    for(var i=0; i<colCount; i++) {

        var newcell = row.insertCell(i);
        newcell.innerHTML = table.rows[0].cells[i].innerHTML;
        
        //alert(newcell.childNodes);
        switch(newcell.childNodes[0].type) {
            case "text":
                    newcell.childNodes[0].value = "";
                    newcell.childNodes[0].id = "domain"+row_domain_ID;
                    newcell.childNodes[0].name = "domain"+row_domain_ID;
                    $P(newcell.childNodes[0]).rules("add", {required:true,host: ['domain']});
                    break;
            case "button":
                    newcell.childNodes[0].className = "btn_del";    
                    newcell.childNodes[0].id="btndomain"+row_domain_ID;
                    newcell.childNodes[0].onclick = Function ("deleteDomainRow(this, '"+tableID+"');");
                    break;
        }
    }
};

function deleteDomainRow(btn, tableID) {
    var table = document.getElementById(tableID);
    var rowCount = table.rows.length;
    var rowIndex = btn.parentElement.parentElement.rowIndex;
    
    if( rowCount > rowIndex )
    {
        table.deleteRow(rowIndex);
    }
    
    //rowCount = table.rows.length;
    //if( rowCount <= 1 || rowCount == row )
    //{
    //    /*Changed the function to 'Add'*/
    //    btn.className = "btn_add";
    //    btn.onclick = Function ("addRow(this, '"+tableID+"');");
    //}
};	
 

function dec2Bin(dec)
{
    if(dec >= 0) {
        return dec.toString(2);
    }
    else {
        //make the number positive
        dec = Math.abs(dec);
        //get the first compliment
        var res = dec ^ parseInt((new Array(dec.toString(2).length+1)).join("1"),2);
        //get the second complimet
        return (res+1).toString(2);
    }
};

function getStrCount(scrstr, armstr)
{ 
    var count=0;
    while(scrstr.indexOf(armstr) != -1 )
    {
        scrstr = scrstr.replace(armstr,"");
        count++;    
    }
    return count;
};

/*Dotted Decimal Netmask 
  to
  CIDR prefix length
*/
function DDNtoCIDR(DDN)
{
    var CIDR = 0;
    var net_array = DDN.split(".");
    net_array.forEach(function(entry) 
    {
        bin = dec2Bin(parseInt(entry, 10));
        CIDR += getStrCount(bin, "1");
    });
    return CIDR;
};


var save_pre = function () {
    digitFields = ['defaultexpiry', 'maxexpiry', 'minexpiry', 'rtptimeout', 'rtpholdtimeout'];

    $.each(digitFields, function (idx, item) {
        var $item = $('#' + item);
        var value = $item.val();
        if (value)
        {
            $item.val(parseInt(value, 10));
        }
    });

};

var fnSaveChanges = function ()
{
    var cat = 'general';

    var skip_ifempty = ['register', 'localnet', 'externhost', 'externip'];
    var AG = ASTGUI.getFieldValue;

    save_pre();

    var stun = new listOfSynActions('res_stun_monitor.conf');
    fieldnames2.each(function (fldd)
    {
        var field = AG(fldd);
        if (field != null)
        {
            var val = field.trim();
            if (val == "")
            {
                //if (skip_ifempty.contains(fldd)) { return; }
                stun.new_action('delete', cat, fldd, '');
            } else
            {
                stun.new_action('update', cat, fldd, val);
            }
        }

    });


    var x = new listOfActions('sip.conf');
    fieldnames.each(function (fld)
    {
        var field = AG(fld);
        if (field != null)
        {
            var val = field.trim();
            if (val == "")
            {
                //if (skip_ifempty.contains(fld)) { return; }
                x.new_action('delete', cat, fld, '');
            }
            else
            {
                x.new_action('autoupdate', cat, fld, val);
                
            }
        }
        else if (fld == "localnet")
        {
            var table = document.getElementById('localnetTable');
            if ( table != undefined )
            {
                x.new_action('delete', cat, fld, '');

                /*Note: Maybe we need to make sure the input_list is match to the select_list by id*/
                var input_list=table.getElementsByTagName("input");
                var select_list=table.getElementsByTagName("select");
                var val_list=new Array();
    
                var i = 0;
                for (i = 0; i < input_list.length; i++)
                {
                    val_list[i] = input_list[i].value+"/"+select_list[i].options[select_list[i].selectedIndex].value;
                }
                
                val_list.each(function (val)
                {
                    x.new_action('append', cat, fld, val);
                });
            }
        }
        else if (fld == "domain")
        {
            var table = document.getElementById('domainTable');
            if ( table != undefined )
            {
                x.new_action('delete', cat, fld, '');

                /*Note: Maybe we need to make sure the input_list is match to the select_list by id*/
                var input_list=table.getElementsByTagName("input");
                var val_list=new Array();
    
                var i = 0;
                for (i = 0; i < input_list.length; i++)
                {
                    val_list[i] = input_list[i].value;
                }
                
                val_list.each(function (val)
                {
                    x.new_action('append', cat, fld, val);
                });
            }
        }

    });
    /*  move codec to single file 
    x.new_action('delete', cat, 'disallow', '');
    x.new_action('delete', cat, 'allow', '');
    x.new_action('append', cat, 'disallow', 'all');

    var codeList = ASTGUI.CODECSLIST.getSelectedCodecs(_$('allow'));
    if (codeList !== null)
        x.new_action('append', cat, 'allow', codeList);

    */
    var resp = stun.callActions();

    var after = function ()
    {
        top.dialog.clearDialog();
        var domPortVal = $("#bindport").val();
        var domAddrVal = $("#bindaddr").val();
        var domSrvlookupVal = ASTGUI.getFieldValue('srvlookup');
        if((domPortVal && bindportVal != domPortVal) || (domAddrVal && bindaddrVal != domAddrVal) || (domSrvlookupVal && srvlookupVal != domSrvlookupVal)) {        
            top.dialog.dialogConfirm({
                confirmStr: $P.lang("LANG926"),
                buttons: {
                    ok: confirm_reboot,
                    cancel:  function (){
                        bindportVal = $("#bindport").val();
                        bindaddrVal = $("#bindaddr").val();
                        srvlookupVal = ASTGUI.getFieldValue('srvlookup');
                    }
                }
            });  
        }
        else {
            top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG844") });
        }
        if (domPortVal) {
            var newJail = new listOfActions('jail.conf');
            var actionStr = "iptables-multiport[name=asterisk-udp, port=\""+domPortVal+"\", protocol=udp]";
            newJail.new_action("update", "asterisk-udp", "action", actionStr);
            newJail.callActions();
        }
    };

    if (resp && !resp.contains('Response: Success'))
    {
        top.log.error('Error updating res_stun_monitor.conf.');
        top.log.error(resp);
    }
    else
    {
        top.dialog.dialogMessage({ type: 'loading', content: $P.lang('LANG826') });
        setTimeout(function () { x.callActions(after); }, 300);
    }
}
function confirm_reboot()
{
    top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG832") });
    $.ajax({
        type: "GET",
        url: "../webcgi?action=reboot",
        success: function ()
        {
            setTimeout("top.window.location.reload();", 120000);
        },
        error: function (jqXHR, textStatus, errorThrown)
        {
            top.dialog.clearDialog();
            if (errorThrown != null && errorThrow.length > 0)
                top.dialog.dialogMessage({ type: 'error', content: errorThrown });
            else
                top.dialog.dialogMessage({ type: 'error', content: $P.lang("LANG853") });
        }
    })
}
