/*
* Asterisk-GUI	- an Asterisk configuration interface
*
* users.html functions
*
* Copyright (C) 2006-2010, Digium, Inc.
*
* Pari Nannapaneni <pari@digium.com>
*
* See http://www.asterisk.org for more information about
* the Asterisk project. Please do not directly contact
* any of the maintainers of this project for assistance;
* the project provides a web site, mailing lists and IRC
* channels for your use.
*
* This program is free software, distributed under the terms of
* the GNU General Public License Version 2. See the LICENSE file
* at the top of the source tree.
*
*/
/*
 * Description: UCM6100 WebGUI
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 * Modifications:
 * Added some options to users.conf
 * 
 */

var mWindow = top.window.frames["mainscreen"]; // this will be the main window
var isNewUSER;
var isCreateUser = false;
var EXTENSION_EDIT;
var zapchan_Before = '';
var newusers_list = [];
$P = top.$;
var table_list;
var zeroconfigErr = {
    "1": "LANG918",
    "2": "LANG919",
    "3": "LANG920"
};
/* modify by yjwu | ybiaozhou*/
//var MULTI_FIELDS = ['edit_check_multiple_obcid','edit_multiple_obcid','edit_check_multiple_dialplan','edit_multiple_dialplan','edit_check_multiple_hasvoicemail','edit_multiple_hasvoicemail','edit_check_multiple_vmsecret', 'edit_multiple_vmCHoice1', 'edit_multiple_vmCHoice2', 'edit_multiple_vmsecret', 'edit_check_multiple_hassip', 'edit_multiple_hassip', 'edit_check_multiple_hasiax', 'edit_multiple_hasiax', 'edit_check_multiple_allow',  'edit_multiple_codec_one', 'edit_multiple_codec_two', 'edit_multiple_codec_three', 'edit_multiple_codec_fourth', 'edit_multiple_codec_fifth', 'edit_check_multiple_flashrxflash',  'edit_multiple_flash', 'edit_multiple_rxflash', 'edit_check_multiple_secret', 'edit_check_multiple_iax', 'edit_multiple_seCHoice1', 'edit_multiple_seCHoice2', 'edit_multiple_secret', 'edit_check_multiple_nat',  'edit_multiple_nat', 'edit_check_multiple_canreinvite', 'edit_multiple_canreinvite', 'edit_check_multiple_dtmfmode',  'edit_multiple_dtmfmode', 'edit_check_multiple_insecure',  'edit_multiple_insecure', 'edit_check_multiple_3waycalling',  'edit_multiple_3waycalling', 'edit_check_multiple_indirectory',  'edit_multiple_indirectory', 'edit_check_multiple_callwaiting',  'edit_multiple_callwaiting', 'edit_check_multiple_cti',  'edit_multiple_cti', 'edit_check_multiple_isagent',  'edit_multiple_isagent', 'edit_check_multiple_pickupgroup',  'edit_multiple_pickupgroup', 'edit_multiple_requirecalltoken', 'edit_multiple_maxcallnumbers'];
var MULTI_FIELDS = ['edit_check_multiple_obcid', 'edit_multiple_obcid', 'edit_check_multiple_permission','edit_check_multiple_hasvoicemail', 'edit_check_multiple_vmsecret', 'edit_check_multiple_ringtimeout', 'edit_multiple_ringtimeout', 'edit_check_multiple_dial', 'edit_multiple_hasiax', 'edit_check_multiple_allow', 'edit_check_multiple_secret', 'edit_check_multiple_iax', 'edit_check_multiple_nat', 'edit_multiple_nat', 'edit_check_multiple_canreinvite', 'edit_multiple_canreinvite', 'edit_check_multiple_dtmfmode', 'edit_check_multiple_insecure', 'edit_check_multiple_qualify', 'edit_multiple_qualify', 'edit_check_multiple_qualifyfreq', 'edit_multiple_qualifyfreq', 'edit_multiple_maxcallnumbers','edit_check_multiple_maxcallnumbers', 'edit_check_multiple_disablepin', 'edit_multiple_disablepin', 'edit_check_multiple_srtp', 'edit_multiple_srtp', 'edit_check_multiple_faxdetect', 'edit_multiple_faxdetect', 'edit_check_multiple_strategy', 'edit_multiple_strategy', 'edit_check_multiple_pickup', 'edit_check_multiple_language', 'edit_multiple_language'];

var fxs_in_use = function ()
{
    var USERSLIST =  parent.pbx.users.list();
    var port = _$('edit_fxs').value;
    var user = ASTGUI.getFieldValue('new_ext');
    for (var i = 0; i < USERSLIST.length; i++)
    {
        if (user != USERSLIST[i])
        {
            var user_port = parent.sessionData.pbxinfo.users[USERSLIST[i]].dahdichan;
            if (user_port != 'undefined' && user_port == port)
            {
                return false;
            }
        }
    }
    return true;
}

var check_network = function(val, ele)
{

    var regSubnet = /^((1\d\d|2[0-4]\d|25[0-5]|[1-9]\d|\d)\.){3}0$/;
    if ( val && !regSubnet.test(val))
        return false;
    
    return true;
}

var check_video_codec = function()
{
    //var list = ["ulaw", "alaw", "gsm", "g726", "g726aal2", "ilbc", "g722", "adpcm", "lpc10", "g729", "g723"];
    var list = ["ulaw", "alaw", "gsm", "g726", "g726aal2", "ilbc", "g722", "adpcm", "g729", "g723"];
    var res = false;
    var valuelist = ASTGUI.selectbox.readAllValues('select_allow_codec');

    valuelist.each(function(value){
        if (res == true)
        {
            return res;
        }
        list.each(function(codec){
            if (value == codec)
                res = true;
                return res;
        });
    });
   
    return res;
}

var check_max_users = function()
{
    if (ASTGUI.globals.MAX_USER < parent.pbx.users.list().length +  Number(_$("batch_number").value))
    {
        return false;
    }
    else
    {
        return true;
    }
}

var init_validator = function()
{
    if ($("#form").tooltip) {
        $("#form").tooltip();
    }
    $P("#form", document).validate({
        rules:{
            "new_ext": {
                required: true,
                digits: true,
                extensionRange: ["ue_start", "ue_end"],
                minlength: 2,
                customCallback: [$P.lang("LANG2126"), function()
                {
                    return !parent.miscFunctions.ifExtensionAlreadyExists(_$("new_ext").value);
                }]
            },
            "edit_fullname": {
                alphanumericUndSpace: true,
                minlength: 2
            },
            "edit_OutBoundCallerid": {
                digits: true,
                minlength: 2
            },
            "edit_secret": {
                keyboradNoSpacesemicolon: true,
                minlength: 4,
                customCallback: [$P.lang("LANG2127").format("user"), function()
                {
                    return _$('edit_secret').value != '' || (!_$('edit_hasSip').checked && !_$('edit_hasIax').checked);
                }]
            },
            "edit_multiple_secret": {
                required: true,
                keyboradNoSpacesemicolon: true,
                minlength: 4
            },
            "edit_vmsecret": {
                //required: true,
                digits: true,
                minlength: 4
            },
            "edit_multiple_vmsecret": {
                /*required: function()
                {
                    //$('#edit_check_multiple_hasvoicemail:checked, #edit_multiple_hasvoicemail:not(:checked)')
                    return !(_$('edit_check_multiple_hasvoicemail').checked && (!_$('edit_multiple_hasvoicemail').checked));
                },*/
                digits: true,
                minlength: 4
            },
            "batch_vmsecret": {
                /*required: function()
                {
                    return _$('batch_hasvoicemail').checked;
                },*/
                digits: true,
                minlength: 4
            },
            "edit_email": {
                email: true
            },
            "edit_trunk_secret": {
                digits: true,
                minlength: 2
            },
            "edit_cfbext": {
                //phoneNumberOrExtension: true
                numeric_pound_star: true
            },
            "edit_cfnext": {
                //phoneNumberOrExtension: true
               numeric_pound_star: true
            },
            "edit_cfuext": {
                //phoneNumberOrExtension: true
                numeric_pound_star: true
            },
            "edit_ringtimeout": {
                digits: true,
                range: [3,600]
            },
            "edit_hasSip": {
                customCallback: [$P.lang("LANG2128"), function()
                {
                    return _$('edit_hasSip').checked || _$('edit_hasIax').checked || (_$('edit_fxs').selectedIndex > 0);
                }]
            },
            "edit_multiple_hassip": {
                customCallback: [$P.lang("LANG2129"), function()
                {
                    return _$('edit_multiple_hassip').checked || _$('edit_multiple_hasiax').checked;
                }]
            },
            "batch_hassip": {
                customCallback: [$P.lang("LANG2129"), function()
                {
                    return (_$('batch_hassip').checked || _$('batch_hasiax').checked);
                }]
            },
            "edit_fxs": {
                customCallback: [$P.lang("LANG2130"), fxs_in_use]
            },
            "edit_rxgain": {
                required: true,
                gain: [-30,6]
            },
            "edit_txgain": {
                required: true,
                gain: [-30,6]
            },
            "edit_minflash": {
                required: true,
                digits: true,
                range: [30,1000]
            },
            "edit_rxflash": {
                required: true,
                digits: true,
                range: [40,2000],
                bigger: [$P.lang("LANG1119"),$P.lang("LANG1117"),$("#edit_minflash")]
            },
            "select_allow_codec": {
                selectItemMin: 1,
                customCallback: [$P.lang("LANG2138"), check_video_codec]
            },
            "edit_qualifyfreq": {
                required: true,
                digits: true,
                range: [1, 3600]
            },
            "edit_authid": {
                authid: true
            },
            "edit_maxcallnumbers": {
                digits: true
            },
            "local_network1": {
                customCallback: [$P.lang("LANG2131"), check_network]
            },
            "local_network2": {
                customCallback: [$P.lang("LANG2131"), check_network]
            },
            "local_network3": {
                customCallback: [$P.lang("LANG2131"), check_network]
            },
            "specific_ip":{
                required: true,
                ipDns: ["ip"]
            },
            "batchnumber": {
                required: true,
                digits: true,
                range: [1, 30],
                customCallback: [$P.lang("LANG811").format(ASTGUI.globals.MAX_USER, parent.pbx.users.list().length), check_max_users]
            }
        },
        newValidator: true,
        submitHandler: function() {
            if (mode == "batchusers")
            {
                add_RangeOfUsers();
            }
            else if (mode == "add_user")
            {
                SAVE_USER_FORM();
            }
            else if (mode == "edit_user")
            {
                SAVE_USER_FORM();
            }
            else if (mode == "edit_users")
            {
                save_multiple_users();
            }
        }
    });
}

var saveChanges = function () {
    if (isNewUSER)
    {
        AskextensionRange(_$("new_ext").value, "ue_start", "ue_end");
    }
}

var saveBatchAdd = function () {
    AskextensionRange(_$("batch_ext").value, "ue_start", "ue_end");
}

var bind_codecs_action = function (id)
{
    ASTGUI.events.add('button_add_' + id, 'click', function ()
    {
        if (!_$('select_available_' + id).value || _$('select_allow_' + id).disabled)
        {
            return;
        }

        $(':selected', _$('select_available_' + id)).each( function (idx, item) {
            var val = $(item).val();
            var text = $(item).html() || val;
            $(item).remove();
            ASTGUI.selectbox.append(_$('select_allow_' + id), text, val);
        });
        $P("#select_allow_" + id, document).valid();
    });

    ASTGUI.events.add('button_remove_' + id, 'click', function ()
    {
        if (!_$('select_allow_' + id).value || _$('select_allow_' + id).disabled)
        {
            return;
        }

        $(':selected', _$('select_allow_' + id)).each( function (idx, item) {
            var val = $(item).val();
            var text = $(item).html() || val;
            $(item).remove();
            ASTGUI.selectbox.append(_$('select_available_' + id), text, val);
        });
        $P("#select_allow_" +id, document).valid();
    });

    ASTGUI.events.add('button_removeall_' + id, 'click', function ()
    {
        if (_$('select_allow_' + id).disabled)
        {
            return;
        }
        
        /*
        ASTGUI.selectbox.clear(DOM_allow);
        ASTGUI.selectbox.clear(DOM_available);
        var listOfCodecs = top.sessionData.listOfCodecs;

        for (var item in listOfCodecs)
        {
            if (!listOfCodecs.hasOwnProperty(item))
            {
                continue;
            }
            ASTGUI.selectbox.append(DOM_available, listOfCodecs[item], item);
        }
        $P("#select_allow_codecs", document).valid(); 
        */
        
        $(_$('select_allow_' + id)).children().each( function (idx, item) {
            var val = $(item).val();
            var text = $(item).html() || val;
            $(item).remove();
            ASTGUI.selectbox.append(_$('select_available_' + id), text, val);
        });
        $P("#select_allow_" + id, document).valid(); 
    });

    ASTGUI.events.add('button_addall_' + id, 'click', function ()
    {
        if (_$('select_allow_' + id).disabled)
        {
            return;
        }
        
        // modified to do not override former order in selected box, just append it
        $(_$('select_available_' + id)).children().each( function (idx, item) {
            var val = $(item).val();
            var text = $(item).html() || val;
            $(item).remove();
            ASTGUI.selectbox.append(_$('select_allow_' + id), text, val);
        });
        $P("#select_allow_" + id, document).valid();
    });

    if (id == "codec")
    {
        //bind up/down/top/bottom button
        $('#button_up').click( function () {
            ASTGUI.domActions.selectScrollUp('select_allow_codec');
        });
    
        $('#button_down').click( function () {
            ASTGUI.domActions.selectScrollDown('select_allow_codec');
        });
    
        $('#button_top').click( function () {
            ASTGUI.domActions.selectScrollTop('select_allow_codec');
        });
    
        $('#button_bottom').click( function () {
            ASTGUI.domActions.selectScrollBottom('select_allow_codec');
        });
    }
};

var initialize_formFields = function ()
{ // initialize_formFields();
    // Load Analog stations into 'edit_fxs'
    var n=1;
    ASTGUI.selectbox.append('edit_fxs', $P.lang("LANG133"), '');
    parent.sessionData.FXS_PORTS_DETECTED.each(function (item) { ASTGUI.selectbox.append('edit_fxs', 'FXS ' + n, item); n++ });

    ASTGUI.selectbox.append('edit_language', $P.lang("LANG257"), '');
    ASTGUI.selectbox.append('edit_multiple_language', $P.lang("LANG257"), '');
    ASTGUI.selectbox.append('batch_language', $P.lang("LANG257"), '');
    
    $.ajax({
        type: "GET",
        url: "./userdefined/language.json",
        dataType: "json",
        async: false,
        success: function (data)
        {		 
            var languageData = eval(data);

            for (var i = 0; i < languageData.length; i++)
            {
                ASTGUI.selectbox.append('edit_language', languageData[i].name, languageData[i].id );
                ASTGUI.selectbox.append('edit_multiple_language', languageData[i].name, languageData[i].id );
                ASTGUI.selectbox.append('batch_language', languageData[i].name, languageData[i].id );
            };
        }
    });
    
    
    (function ()
    {
        var R = [];
        R.push({ optionText: $P.lang("LANG133"), optionValue: '' });
        for (var r in parent.sessionData.listOfCodecs)
        {
            R.push({ optionText: parent.sessionData.listOfCodecs[r], optionValue: r });
        }
    })();

    //ASTGUI.selectbox.populateOptions('edit_pickupgroup', 63);
    //ASTGUI.selectbox.populateOptions('edit_multiple_pickupgroup', 63);
    //ASTGUI.domActions.enableDisableByCheckBox('edit_hasSip', ['edit_nat', 'edit_canreinvite', 'edit_dtmfmode', 'edit_insecure']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_hasvoicemail', ['edit_vmsecret']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_qualify', ['edit_qualifyfreq']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_obcid', ['edit_multiple_obcid']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_permission', ['edit_multiple_permission']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_hasvoicemail', ['edit_multiple_hasvoicemail']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_vmsecret', ['edit_multiple_vmCHoice0', 'edit_multiple_vmCHoice1', 'edit_multiple_vmCHoice2']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_ringtimeout', ['edit_multiple_ringtimeout']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_dial', ['edit_multiple_hassip', 'edit_multiple_hasiax']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_allow', ['select_allow_codec', 'select_available_codec' ]);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_secret', ['edit_multiple_seCHoice0', 'edit_multiple_seCHoice1', 'edit_multiple_seCHoice2']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_iax', ['edit_multiple_requirecalltoken']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_qualify', ['edit_multiple_qualify']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_qualifyfreq', ['edit_multiple_qualifyfreq']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_maxcallnumbers', ['edit_multiple_maxcallnumbers']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_nat', ['edit_multiple_nat']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_canreinvite', ['edit_multiple_canreinvite']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_dtmfmode', ['edit_multiple_dtmfmode']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_insecure', ['edit_multiple_insecure']);
    //ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_indirectory', ['edit_multiple_indirectory']);
    //ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_cti', ['edit_multiple_cti']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_disablepin', ['edit_multiple_disablepin']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_srtp', ['edit_multiple_srtp']);
    //ybiaozhou add faxdetect
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_faxdetect', ['edit_multiple_faxdetect']);
    //ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_transport', ['edit_multiple_transport']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_strategy', ['edit_multiple_strategy', 'edit_multiple_specific_ip', 'edit_multiple_local_network1', 'edit_multiple_local_network2', 'edit_multiple_local_network3']);
    ASTGUI.domActions.enableDisableByCheckBox('batch_qualify', ['batch_qualifyfreq']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_pickup', ['select_allow_pickup', 'select_available_pickup' ]);
    ASTGUI.domActions.enableDisableByCheckBox('edit_check_multiple_language', ['edit_multiple_language']);
    ASTGUI.domActions.enableDisableByCheckBox('edit_enablehotdesk', ['edit_authid'], true);
}

var RESET_USER_FORM_FIELDS = function ()
{ // RESET_USER_FORM_FIELDS();
    /* modify by yjwu | jcli | ybiaozhou */
    //ASTGUI.resetTheseFields( ['new_ext','edit_fullname','edit_user_dialplan','edit_OutBoundCallerid','edit_hasvoicemail','edit_vmsecret','edit_email','edit_hasSip','edit_hasIax','edit_fxs','edit_flash','edit_rxflash','codec_one','codec_two','codec_three','codec_fourth','codec_fifth','macaddress','linenumber','edit_secret','edit_nat','edit_canreinvite','edit_dtmfmode','edit_insecure', 'edit_mwifrom', 'edit_3wayCalling','edit_inDirectory','edit_callWaiting','edit_cti','edit_isagent','edit_pickupgroup','edit_linekeys','edit_maxcallnumbers' ,'edit_requirecalltoken'] );
    ASTGUI.resetTheseFields(['edit_trunk_secret', 'edit_email', 'edit_hasIax', 'edit_canreinvite', 'edit_inDirectory', 'edit_cti', 'edit_qualify','edit_qualifyfreq', 'edit_maxcallnumbers', 'edit_disablepin', 'edit_cidsignalling', 'edit_polarityswitch', 'strategy_ipacl', 'edit_cfbext', 'edit_cfnext', 'edit_cfuext','edit_ringtimeout','edit_authid', 'edit_language']);
    // jcli end
    _$('edit_fxs').selectedIndex = 0;
    _$('strategy_ipacl').selectedIndex = 0;
     _$('edit_language').selectedIndex = 0;
    
    $('#mwi_from').hide();

    /* remove by yjwu */
    /*ASTGUI.updateFieldToValue( 'edit_user_dialplan', parent.sessionData.GUI_PREFERENCES.getProperty('default_dialplan') ); */

    if (isNewUSER == false)
    {
        _$('new_ext').disabled = true;
        var uinfo = parent.sessionData.pbxinfo.users[EXTENSION_EDIT];

        /*
        if (uinfo.getProperty('mailbox').contains('MailboxStore'))
        {
            $('#tmp_hideIfRmwi').hide();
        }
        else
        {
            $('#tmp_hideIfRmwi').show();
        }
        */

        ASTGUI.updateFieldToValue('new_ext', EXTENSION_EDIT);
        ASTGUI.updateFieldToValue('edit_fullname', uinfo.getProperty('fullname'));
        /* modify by yjwu*/
        /*ASTGUI.updateFieldToValue( 'edit_user_dialplan', uinfo.getProperty('context') ); */
        var a = ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'PERMISSION' });
        ASTGUI.updateFieldToValue('edit_user_permission', a);
        var a = ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'AUTORECORD' });
        if (a) {
            ASTGUI.updateFieldToValue('edit_user_record', a);
        }
        var a = (ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'pinless' }) == 'NOPASSWD' ? 'yes' : 'no');
        ASTGUI.updateFieldToValue('edit_disablepin', a);
        var outboundStr = ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'OUTBOUNDCID' });
        //var c = /.*\<(.*)\>/;
        var outboundcid = '';
        if (outboundStr)
        {
            var match = outboundStr.match(/.*\<(.*)\>/);
            if (match)
            {
                outboundcid = match[1];
            }
        }

        //ASTGUI.updateFieldToValue('edit_OutBoundCallerid', b ? b.match(c)[1] : '');
        ASTGUI.updateFieldToValue('edit_OutBoundCallerid',outboundcid);

        var sec = ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'PROXY_PWD' });
        ASTGUI.updateFieldToValue('edit_trunk_secret', sec);
        //$('#edit_callerid_span').html(EXTENSION_EDIT);
        //ASTGUI.updateFieldToValue( 'edit_OutBoundCallerid', parent.astgui_manageusers.getOBCID_user(EXTENSION_EDIT) );
        /* modify end */
        var lan = ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'language' });
        
        var option = _$('edit_language').options;
        var lan_exist = false;
        for(var i=0; i < option.length; i++)
        {
            if (option[i].value == lan)
            {
                lan_exist = true;
                break;
            }
        }
        
        if (lan)
        {
            if (lan_exist)
            {
                ASTGUI.updateFieldToValue('edit_language', lan);
            }
            else
            {
                ASTGUI.updateFieldToValue('edit_language', "en");
            }
        }
        
        ASTGUI.updateFieldToValue('edit_hasvoicemail', uinfo.getProperty('hasvoicemail'));
        var vmsecret = uinfo.getProperty('vmsecret');
        if ( vmsecret == "-" )
        {
            vmsecret = "";
        }
        ASTGUI.updateFieldToValue('edit_vmsecret', vmsecret);
        ASTGUI.updateFieldToValue('edit_email', uinfo.getProperty('email'));
        _$('edit_vmsecret').disabled = !_$('edit_hasvoicemail').checked;
        ASTGUI.updateFieldToValue('edit_hasSip', uinfo.getProperty('hassip'));
        ASTGUI.updateFieldToValue('edit_hasIax', uinfo.getProperty('hasiax'));
        ASTGUI.updateFieldToValue('edit_fxs', uinfo.getProperty(top.sessionData.DahdiChannelString));
        // jcli modify 
        ASTGUI.updateFieldToValue('edit_flash', uinfo.getProperty('flash') || '750');
        ASTGUI.updateFieldToValue('edit_minflash', uinfo.getProperty('rxflash_min') || '200');
        ASTGUI.updateFieldToValue('edit_rxflash', uinfo.getProperty('rxflash') || '1250');

        // [ 'cidsignalling','rxgain', 'txgain', 'answeronpolarityswitch', 'hanguponpolarityswitch' ]; // add by jcli
        ASTGUI.updateFieldToValue('edit_cidsignalling', uinfo.getProperty('cidsignalling'));
        ASTGUI.updateFieldToValue('edit_rxgain', uinfo.getProperty('rxgain') || '0');
        ASTGUI.updateFieldToValue('edit_txgain', uinfo.getProperty('txgain') || '0');
        ASTGUI.updateFieldToValue('edit_polarityswitch', uinfo.getProperty('answeronpolarityswitch'));
        //ASTGUI.updateFieldToValue( 'edit_hanguponpolarityswitch', uinfo.getProperty('hanguponpolarityswitch') );
        // jcli end

        var allow_codecs = uinfo.getProperty('allow') ? uinfo.getProperty('allow').split(',') : [];
        reset_form_codecs(allow_codecs, top.sessionData.listOfCodecs, "codec");

        var allow_pickup = uinfo.getProperty('callgroup') ? uinfo.getProperty('callgroup').split(',') : [];
        reset_form_codecs(allow_pickup, top.sessionData.pickupgroup, "pickup");

        ASTGUI.updateFieldToValue('edit_secret', uinfo.getProperty('secret'));
        ASTGUI.updateFieldToValue('edit_nat', uinfo.getProperty('nat'));
        ASTGUI.updateFieldToValue('edit_canreinvite', uinfo.getProperty('canreinvite') ? uinfo.getProperty('canreinvite') : 'no');
        ASTGUI.updateFieldToValue('edit_dtmfmode', uinfo.getProperty('dtmfmode'));
        ASTGUI.updateFieldToValue('edit_insecure', uinfo.getProperty('insecure') || 'port');
        ASTGUI.updateFieldToValue('edit_mwifrom', uinfo.getProperty('mwi_from'));
        ASTGUI.updateFieldToValue('edit_3wayCalling', uinfo.getProperty('threewaycalling') || 'yes');
        ASTGUI.updateFieldToValue('edit_inDirectory', uinfo.getProperty('hasdirectory'));
        ASTGUI.updateFieldToValue('edit_sharpissendkey', uinfo.getProperty('sharpissendkey') || 'yes');
        ASTGUI.updateFieldToValue('edit_callWaiting', uinfo.getProperty('callwaiting') || 'no');
        ASTGUI.updateFieldToValue('edit_echocancel', uinfo.getProperty('echocancel') || 'yes');
        ASTGUI.updateFieldToValue('edit_cti', uinfo.getProperty('hasmanager'));
        //ybiaozhou remove [isagent] ASTGUI.updateFieldToValue( 'edit_isagent', uinfo.getProperty('hasagent') );
        //ASTGUI.updateFieldToValue('edit_pickupgroup', uinfo.getProperty('pickupgroup'));

        ASTGUI.updateFieldToValue('edit_qualify', uinfo.getProperty('qualify') || 'yes');
        ASTGUI.updateFieldToValue('edit_qualifyfreq', uinfo.getProperty('qualifyfreq') || '60');
        ASTGUI.updateFieldToValue('edit_authid', uinfo.getProperty('authid') || '');
        _$('edit_qualifyfreq').disabled = !_$('edit_qualify').checked;
        ASTGUI.updateFieldToValue('edit_maxcallnumbers', uinfo.getProperty('maxcallnumbers'));
        ASTGUI.updateFieldToValue('edit_requirecalltoken', uinfo.getProperty('requirecalltoken') || 'yes');
        ASTGUI.updateFieldToValue('strategy_ipacl', uinfo.getProperty('strategy_ipacl'));
        var sendcalleridafterVal = uinfo.getProperty('sendcalleridafter');
        if (sendcalleridafterVal) {
            ASTGUI.updateFieldToValue('edit_sendcalleridafter', sendcalleridafterVal);
        }
        else {
            ASTGUI.updateFieldToValue('edit_sendcalleridafter', "1");
        }
        /* jcli add */
        if (uinfo.getProperty('strategy_ipacl') == '1')
        {
            var subnets = uinfo.getProperty('permit').split(',');
            for ( var k=1; k<subnets.length; k++)
            {
                var address = subnets[k].split('/');
                ASTGUI.updateFieldToValue('local_network'+k, address[0]);
            }
        }
        else if (uinfo.getProperty('strategy_ipacl') == '2')
        {
            var address = uinfo.getProperty('permit').split('/')[0];
            ASTGUI.updateFieldToValue('specific_ip', address);
        }
        /* jcli end */
        ASTGUI.updateFieldToValue('edit_srtp', uinfo.getProperty('encryption'));
        ASTGUI.updateFieldToValue('edit_faxdetect', uinfo.getProperty('faxdetect'));
        ASTGUI.updateFieldToValue('edit_transport', uinfo.getProperty('transport'));
        zapchan_Before = uinfo.getProperty(top.sessionData.DahdiChannelString);
        //call forward busy/no answer/uncondition
        var cfb_ext = ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'CFB'}) || '';
        ASTGUI.updateFieldToValue('edit_cfbext', cfb_ext);
        var cfn_ext = ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'CFN'}) || '';
        ASTGUI.updateFieldToValue('edit_cfnext', cfn_ext);
        var cfu_ext = ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'CFU'}) || '';
        ASTGUI.updateFieldToValue('edit_cfuext', cfu_ext);
        var timeout = ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'RT'}) || '';        
        /*if (!timeout)
        {
            timeout = parent.sessionData.pbxinfo.GLOBALS['RINGTIME'];
        }*/
        ASTGUI.updateFieldToValue('edit_ringtimeout', timeout);
        var skipvmauth = ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'SKIPVMAUTH' });
        if(skipvmauth == null || skipvmauth.length == 0)                        
            ASTGUI.updateFieldToValue('edit_skipvmauth', 'no');                 
        else                                                                
            ASTGUI.updateFieldToValue('edit_skipvmauth', skipvmauth.toLowerCase());
        
        var enable_hotdesk = ASTGUI.ASTDB.getKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'ENABLEHOTDESK' });
        if(enable_hotdesk == null || enable_hotdesk.length == 0)
            ASTGUI.updateFieldToValue('edit_enablehotdesk', 'no');
        else
            ASTGUI.updateFieldToValue('edit_enablehotdesk', enable_hotdesk.toLowerCase());
        
        _$('edit_authid').disabled = _$('edit_enablehotdesk').checked;
        
        if(enable_hotdesk != null && enable_hotdesk == "YES")
        {
            var new_rule = { 
                           alphanumeric: true, 
                           minlength: 4,
                           customCallback: [$P.lang("LANG2127").format("user"), function()
                           {
                               return _$('edit_secret').value != '' || (!_$('edit_hasSip').checked && !_$('edit_hasIax').checked);
                           }]
                           };
            $P("#edit_secret", document).rules("remove");
            
            $P("#edit_secret", document).rules("add", new_rule);
        }
        else
        {
            var new_rule = {
                       keyboradNoSpacesemicolon: true,
                       minlength: 4,
                       customCallback: [$P.lang("LANG2127").format("user"), function()
                       {
                           return _$('edit_secret').value != '' || (!_$('edit_hasSip').checked && !_$('edit_hasIax').checked);
                       }]
                       };
            $P("#edit_secret", document).rules("remove");
        
            $P("#edit_secret", document).rules("add", new_rule);
        }
    }
    else
    {
        _$('new_ext').disabled = false;
        ASTGUI.updateFieldToValue('edit_hasSip', 'yes');
        //ASTGUI.updateFieldToValue( 'edit_hasIax', 'yes' );
        ASTGUI.updateFieldToValue('edit_hasvoicemail', 'yes');
        ASTGUI.updateFieldToValue('edit_nat', 'yes');
        ASTGUI.updateFieldToValue('edit_flash', '750');
        ASTGUI.updateFieldToValue('edit_minflash', '200');
        ASTGUI.updateFieldToValue('edit_rxflash', '1250');
        // jcli add
        ASTGUI.updateFieldToValue('edit_sharpissendkey', 'yes');
        ASTGUI.updateFieldToValue('edit_echocancel', 'yes');
        ASTGUI.updateFieldToValue('edit_callWaiting', 'no');
        ASTGUI.updateFieldToValue('edit_3wayCalling', 'yes');
        ASTGUI.updateFieldToValue('edit_rxgain', '0');
        ASTGUI.updateFieldToValue('edit_txgain', '0');
        // jcli end
        var tmp_allextensions = ASTGUI.cloneObject(parent.miscFunctions.getAllExtensions());
        /* var tmp_newEXT = tmp_allextensions.firstAvailablestring( parent.sessionData.GUI_PREFERENCES.getProperty('ue_start') );
        user to support "0" in the previous of extension */
        var tmp_newEXT = tmp_allextensions.firstAvailable(parent.sessionData.GUI_PREFERENCES.getProperty('ue_start'));
        ASTGUI.updateFieldToValue('new_ext', tmp_newEXT);
        //ASTGUI.updateFieldToValue('edit_fullname', tmp_newEXT);
        if (parent.sessionData.GUI_PREFERENCES.getProperty('rand_password') == 'no')
        {
            ASTGUI.updateFieldToValue('edit_vmsecret', tmp_newEXT);
            ASTGUI.updateFieldToValue('edit_secret', tmp_newEXT);
        }
        else
        {
            ASTGUI.updateFieldToValue('edit_vmsecret', randPassword(0));
            ASTGUI.updateFieldToValue('edit_secret', randPassword());
        }

        ASTGUI.updateFieldToValue('edit_transport', 'udp,tcp,tls');
        //ASTGUI.updateFieldToValue('edit_ringtimeout', parent.sessionData.pbxinfo.GLOBALS['RINGTIME']);
        //update default codecs
        reset_form_codecs('default', top.sessionData.listOfCodecs, "codec");
        reset_form_codecs(['1'], top.sessionData.pickupgroup, "pickup");
        ASTGUI.updateFieldToValue('edit_skipvmauth', 'no');
        ASTGUI.updateFieldToValue('edit_enablehotdesk', 'no');
    }
    if (_$('edit_hasSip').updateStatus != undefined) {
        _$('edit_hasSip').updateStatus();
    }
}

var NEW_USER_FORM = function ()
{ // NEW_USER_FORM();
    isNewUSER = true;
    isCreateUser = true;
    EXTENSION_EDIT = '';
    zapchan_Before = '';

    RESET_USER_FORM_FIELDS();
    change_show(); /* disable/enabled 3-way/callwaiting based on analog */
}
var getBatchUser = function () {
    newusers_list = [];
    var t = Number(ASTGUI.getFieldValue('batch_number'));
    var tmp_user = ASTGUI.getFieldValue('batch_ext');

    while (t)
    {
        if (top.miscFunctions.ifExtensionAlreadyExists(tmp_user))
        {
            tmp_user = bigNumAdd(tmp_user);
            continue;
        }

        if (!top.ASTGUI.miscFunctions.isExtensionInRange(tmp_user, 'ue_start', 'ue_end'))
        {
            var v = parent.sessionData.GUI_PREFERENCES.getProperty('ue_start');
            var w = parent.sessionData.GUI_PREFERENCES.getProperty('ue_end');

            top.dialog.dialogConfirm({
                confirmStr: $P.lang("LANG812") + $P.lang("LANG2132").format(tmp_user,v,w),
                buttons: {
                    ok:  function (){
                        top.module.jumpMenu('preferences.html');
                    },
                    cancel:  function (){
                        top.dialog.container.show();
                        top.dialog.shadeDiv.show();
                    }
                }
            });

            return false; 
        } 

        newusers_list.push(tmp_user);
        //top.log.debug( 'adding user ' + tmp_nu);

        tmp_user = bigNumAdd(tmp_user);
        t--;
    }
    return newusers_list;
}
var add_RangeOfUsers = function ()
{
    if($P("#form", document).valid())
    {
        var newusersLists = new Array;
        getBatchUser();
        newusersLists.push("<font>"+newusers_list[0]+"</font>");
        for (var i = 1; i < newusers_list.length; i++) {
            newusersItem = newusers_list[i];
            var prev = parseInt(newusers_list[i]) - 1;
            if (parseInt(newusers_list[i - 1]) == prev) {
                newusersItem = "<font>"+newusers_list[i]+"</font>";
            }
            else{
                newusersItem = "<font color='green'>"+newusers_list[i]+"</font>";
            }
            newusersLists.push(newusersItem);
        }
        top.dialog.dialogConfirm({
            confirmStr: $P.lang("LANG813").format( newusersLists.join('  ') ),
            buttons: {
                ok: function ()
                {
                    top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG736") });
                    
                    var p = listOfActions('phonebook1.conf');
                    var autoRecord = ASTGUI.getFieldValue('batch_user_record');
                    for( var i=0; i<newusers_list.length; i++)
                    {
                        ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + newusers_list[i], key: 'AUTORECORD', keyvalue: autoRecord });
                        p.new_action('newcat', newusers_list[i]+'', '', '');
                        p.new_action('autoupdate', newusers_list[i]+'', 'AccountNumber', newusers_list[i]+'');
                    }
                    p.callActions();

                    var c = listOfActions('configchanged.conf');
                    c.new_action('update', 'configchanged', 'ldap', 'yes');
                    c.callActions();
                    var do_batch_add = function ()
                    {
                        var post_data = { "batch-add": {} };
                        var dblist = [];
                        var userlist = [];

                        userlist.push('fullname:');
                        userlist.push('registersip:no');
                        userlist.push('host:dynamic');
                        var pickup = ASTGUI.selectbox.readAllValues('select_allow_pickup').join(',') || '';
                        userlist.push('callgroup:' + pickup);
                        userlist.push('pickupgroup:' + pickup);
                        userlist.push('mailbox');
                        userlist.push('call-limit:100');
                        userlist.push('username');
                        userlist.push('transfer:yes');
                        userlist.push('context:from-internal');
                        userlist.push('cid_number');
                        dblist.push('PERMISSION:' + ASTGUI.getFieldValue('batch_permission'));
                        userlist.push('hasvoicemail:' + ASTGUI.getFieldValue('batch_hasvoicemail'));
                        if (_$('batch_language').value)
                        {
                            userlist.push('language:' + _$('batch_language').value);
                        }

                        var value = "";

                        if (_$('batch_rand_vmsecret').checked)
                        {
                            value = "vmsecret:r";
                        }
                        else if (_$('batch_same_vmsecret').checked)
                        {
                            var vmsecret = ASTGUI.getFieldValue('batch_vmsecret');
                            if ( vmsecret == null || vmsecret == "")
                            {
                                vmsecret = "-";
                            }
                            value = "vmsecret:" + vmsecret;
                        }
                        else
                        {
                            value = "vmsecret";
                        }
                        
                        userlist.push(value);
                        userlist.push('email:');
                        userlist.push('hasdirectory:no');
                        userlist.push('hasmanager:no');
                        
                        if (_$('batch_ringtimeout').value)
                        {
                            value = "RT:" + _$('batch_ringtimeout').value;
                            dblist.push(value);
                        }
                        
                        value = "language:" + _$('batch_language').value;
                        dblist.push(value);
                        
                        userlist.push('hassip:' + ASTGUI.getFieldValue('batch_hassip'));
                        userlist.push('hasiax:' + ASTGUI.getFieldValue('batch_hasiax'));

                        if (_$('batch_hassip').checked && _$('batch_hasiax').checked)
                        {
                            value = "DIAL:SIP/&IAX2/";
                        }
                        else
                        {
                            value = "DIAL:" + (_$('batch_hassip').checked ? "SIP/" : "IAX2/");
                        }
                        dblist.push(value);

                        if (_$('batch_rand_secret').checked)
                        {
                            value = "secret:r";
                        }
                        else if (ASTGUI.getFieldValue('batch_secret'))
                        {
                            value= "secret:" + encodeURIComponent(ASTGUI.getFieldValue('batch_secret'));
                        }
                        else
                        {
                            value = "secret";
                        }
                        userlist.push(value);
                        userlist.push('callcounter:yes');
                        userlist.push('nat:' + ASTGUI.getFieldValue('batch_nat'));
                        userlist.push('canreinvite:' + ASTGUI.getFieldValue('batch_canreinvite'));
                        userlist.push('dtmfmode:' + ASTGUI.getFieldValue('batch_dtmfmode'));
                        userlist.push('insecure:' + ASTGUI.getFieldValue('batch_insecure'));
                        userlist.push('encryption:' + ASTGUI.getFieldValue('batch_srtp'));
                        userlist.push('faxdetect:' + ASTGUI.getFieldValue('batch_faxdetect'));
                        userlist.push('transport:udp,tcp,tls');
                        userlist.push('requirecalltoken:' + ASTGUI.getFieldValue('batch_requirecalltoken'));
                        userlist.push('qualify:' + ASTGUI.getFieldValue('batch_qualify'));
                        if (_$('batch_qualify').checked)
                        {
                            userlist.push('qualifyfreq:' + ASTGUI.getFieldValue('batch_qualifyfreq'));                    
                        }
                        
                        if (_$('batch_strategy').value == 0)
                        {
                            userlist.push('strategy_ipacl:0');
                            userlist.push('deny:0.0.0.0/255.255.255.255');
                            userlist.push('permit:0.0.0.0/0.0.0.0');
                        } 
                        else if (_$('batch_strategy').value == 1)
                        {
                            var buf = "";
                            var arr = "";
                            var value = "";
                            buf = window.location.host;
                            arr = buf.split(":");
                            value = arr[0] + "/255.255.255.0";
                            userlist.push('strategy_ipacl:1');
                            userlist.push('deny:0.0.0.0/0.0.0.0');
                            if(_$('batch_local_network1').value)
                                value += ","+ _$('batch_local_network1').value + "/255.255.255.0";
                            if(_$('batch_local_network2').value)
                                value += ","+ _$('batch_local_network2').value + "/255.255.255.0";
                            if(_$('batch_local_network3').value)
                                value += ","+ _$('batch_local_network3').value + "/255.255.255.0";
                            userlist.push('permit:' + value);
                        }
                        else if (_$('batch_strategy').value == 2)
                        {
                            userlist.push('strategy_ipacl:2');
                            userlist.push('deny:0.0.0.0/0.0.0.0');
                            userlist.push('permit:' + _$('batch_specific_ip').value + "/255.255.255.255");
                        }        
        
                        dblist.push('pinless:' + (ASTGUI.getFieldValue('batch_disablepin') == 'yes' ? 'NOPASSWD' : 'HASPASSWD'));
                        userlist.push('disallow:all');
                        value = ASTGUI.selectbox.readAllValues('select_allow_codec').join(',') || '';
                        userlist.push('allow:' + value);
                        userlist.push('maxcallnumbers:' + ASTGUI.getFieldValue('batch_maxcallnumbers')); 

                        post_data["batch-add"]["users"] = newusers_list;
                        post_data["batch-add"]["users.conf"] = userlist;
                        post_data["batch-add"]["astdb"] = dblist;
                        post_data["batch-add"]["extensions.conf"] = (ASTGUI.getFieldValue('batch_hasvoicemail') != 'no') ? (["hasvoicemail"]) : (["hasvoicemail:novm"]);

                        var json = JSON.stringify(post_data["batch-add"]);
                        post_data["batch-add"] = json;
                        $P.gs.actionSubmit(document, "batchUsers", null, { 
                            "dataType": "json", 
                            "checkReload": false, 
                            "postToBody": true, 
                            "data": post_data,
                            "feedback": false,
                            "onResponseProcessed": function () {
                                top.dialog.dialogMessage({ 
                                    type: 'success', 
                                    content: $P.lang("LANG815"), 
                                    callback: function () { mWindow.location.reload(); } 
                                });
                            } 
                        });
                        
                    }
                    setTimeout(do_batch_add, 100);
                },
                cancel: function ()
                {
                    top.dialog.container.show();
                    top.dialog.shadeDiv.show();
                }
            }
        });
    }
};
/* add by yjwu */

var EDIT_USER_FORM = function (item)
{
    $('#User_AdvancedEditButton').show();
    isNewUSER = false;
    isCreateUser = false;
    EXTENSION_EDIT = item;
    RESET_USER_FORM_FIELDS();
    change_show(); /* disable/enabled 3-way/callwaiting based on analog */
};

var getSelectedUsers = function ()
{
    return mWindow.ASTGUI.domActions.get_checked('selected_extensions');
};

var EDIT_SELECTEDUSERS_FORM = function ()
{
    ASTGUI.resetTheseFields(MULTI_FIELDS);
    MULTI_FIELDS.each(function (this_field_str)
    {
        try
        {
            _$(this_field_str).updateStatus();
        } catch (err)
        {

        }
    });

    //reuse the codec select widget
    $('#codec_div').insertAfter($('#multi_codecs'));
    $('#codec_div').show();
    $('#pickup_div').insertAfter($('#multi_pickup'));
    $('#pickup_div').show();
    reset_form_codecs('default' , top.sessionData.listOfCodecs, "codec");
    reset_form_codecs(['1'], top.sessionData.pickupgroup, "pickup");
    _$('edit_multiple_permission').selectedIndex = 0;
    _$('edit_multiple_dtmfmode').selectedIndex = 0;
    _$('edit_multiple_insecure').selectedIndex = 0;
    _$('edit_multiple_strategy').selectedIndex = 0;
    _$('edit_multiple_language').selectedIndex = 0;
    _$("edit_multiple_vmsecret").value = "";
    _$("edit_multiple_secret").value = "";
    _$("edit_multiple_hasvoicemail").checked = true;
    _$("edit_multiple_seCHoice0").checked = true;
    _$("edit_multiple_vmCHoice0").checked = true;
    _$("edit_multiple_hassip").checked = true;
    _$("edit_multiple_nat").checked = true;
    //_$('edit_multiple_transport').selectedIndex = 3;
};

var BATCH_USERS_FORM = function ()
{
    var tmp_allextensions = ASTGUI.cloneObject(parent.miscFunctions.getAllExtensions());  
    var tmp_newEXT = tmp_allextensions.firstAvailable(parent.sessionData.GUI_PREFERENCES.getProperty('ue_start'));

    _$('batch_ext').value = tmp_newEXT;
    _$('batch_number').value = '5';
    _$('batch_hasvoicemail').checked = 'on';
    _$('batch_rand_secret').checked = 'on';
    _$('batch_rand_vmsecret').checked = 'on';
    _$('batch_hassip').checked = 'on';
    _$('batch_nat').checked = 'on';
    _$('batch_canreinvite').value = 'no';
    _$('batch_qualify').checked = 'on';
    _$('batch_qualifyfreq').value = '60';
    //reuse the codec select widget
    $('#codec_div').insertAfter($('#batch_codecs'));
    $('#codec_div').show();
    $('#pickup_div').insertAfter($('#batch_pickup'));
    $('#pickup_div').show();
    reset_form_codecs('default' , top.sessionData.listOfCodecs, "codec");
    reset_form_codecs(['1'], top.sessionData.pickupgroup, "pickup");
};

/* 
* for multi delete, operate_relative_info(users);
* for multi modify, canceling IAX tech,  delete-relative_info_multi(users, { "techs" : ["hasiax"] });
* for multi modify, remove hasvoicemail,  delete-relative_info_multi(users, { "del_vm" : true } );
* 
*/
var operate_relative_info = function (users, modify_option)
{

    var batch_post = [];
    var action_extensions = new listOfActions('extensions.conf');
    var QUEUES_CONF = config2json({ filename: 'queues.conf', usf: 0 });
    var action_queues = new listOfActions('queues.conf');
    var FOLLOWME_CONF = config2json({ filename: 'followme.conf', usf: 0 });
    var action_followme = new listOfActions('followme.conf');

    //ring group
    var pbx_ringgroups = parent.sessionData.pbxinfo.ringgroups;
    var ringgroups = {};
    for (var group in pbx_ringgroups)
    {
        if (!pbx_ringgroups.hasOwnProperty(group))
        {
            continue;
        }

        ringgroups[group] = { "members": pbx_ringgroups[group].members.slice(0),  //clone array
            "modified": false
        };
    }
    //end of ring group


    // initial page/intercom
    var pbx_pagegroups = parent.sessionData.pbxinfo.pagegroups;
    var pagegroups = {};
    for (var group in pbx_pagegroups)
    {
        if (!pbx_pagegroups.hasOwnProperty(group))
        {
            continue;
        }

        //exten = 1232,1,Macro(pagingintercom,SIP/6017&IAX2/6017,dq)
        var old_exten_content = pbx_pagegroups[group].afterChar('=');
        var tmp_args = ASTGUI.parseContextLine.getArgs(old_exten_content);
        var members = tmp_args[1] ? tmp_args[1].split('&') : [];
        var delete_flag = false;

        pagegroups[group] = { "oldExten": old_exten_content,
            "members": members.slice(0),     //clone array
            "modified": false
        };
    }
    //end of page/intercom

    //initial voicemail group
    var pbx_vmgroups = parent.sessionData.pbxinfo.vmgroups;
    var vmgroups = {};
    for (var group in pbx_vmgroups)
    {
        if (!pbx_vmgroups.hasOwnProperty(group))
        {
            continue;
        }

        vmgroups[group] = { "mailboxes": pbx_vmgroups[group].mailboxes.slice(0),
            "modified": false
        };
    }
    //end of voicemail group

    for (var user_idx = 0; user_idx < users.length; user_idx++)
    {
        var user = users[user_idx];

        //get user techs
        var techs = [];
        if (modify_option && modify_option.techs) //modify techs option
        {
            //we can remove sip/iax in multi-modify page
            if ((modify_option.techs.indexOf('hassip') != -1)
                 && parent.sessionData.pbxinfo.users[user]['hassip']
                 && parent.sessionData.pbxinfo.users[user]['hassip'].isAstTrue())
            {
                techs.push('SIP/');
            }

            if ((modify_option.techs.indexOf('hasiax') != -1)
                 && parent.sessionData.pbxinfo.users[user]['hasiax']
                 && parent.sessionData.pbxinfo.users[user]['hasiax'].isAstTrue())
            {
                techs.push('IAX2/');
            }
            if ((modify_option.techs.indexOf('hasdahdi') != -1)
                && parent.sessionData.pbxinfo.users[user]['dahdichan'])
            {
                techs.push('DAHDI/');
            }
        }
        else    // delete users
        {
            if (parent.sessionData.pbxinfo.users[user]['hassip']
                && parent.sessionData.pbxinfo.users[user]['hassip'].isAstTrue())
            {
                techs.push('SIP/');
            }
            if (parent.sessionData.pbxinfo.users[user]['hasiax']
                && parent.sessionData.pbxinfo.users[user]['hasiax'].isAstTrue())
            {
                techs.push('IAX2/');
            }
            if (parent.sessionData.pbxinfo.users[user]['dahdichan'])
            {
                techs.push('DAHDI/');
            }
        }


        //call queues
        for (var context in QUEUES_CONF)
        {
            if (!QUEUES_CONF.hasOwnProperty(context))
            {
                continue;
            }

            for (var i = 0; i < techs.length; i++)
            {
                if (QUEUES_CONF[context].indexOf('member=' + techs[i] + user) != -1)
                {
                    action_queues.new_action('delete', context, 'member', techs[i] + user, '');
                }

                //remove dynamic agent
                var tmp_str = "action=QueueRemove&Queue=" + context + "&Interface=" + techs[i] + user;

                /* using onebatch ,instead of send actions one by one. tricky,but works for now */
                batch_post.push(tmp_str);
            }

        }
        //end of call queues 

        //ring group
        // update ring group, works only delete user not modify user
        if (!modify_option)
        {
            for (var group in ringgroups)
            {
                if (!ringgroups.hasOwnProperty(group))
                {
                    continue;
                }

                var temp_members = ringgroups[group].members;
                var idx = temp_members.indexOf(user);
                if (idx != -1)
                {
                    temp_members.splice(idx, 1);
                    ringgroups[group].modified = true;
                }
            }
        }
        //end of ring group

        //page/intercom
        for (var group in pagegroups)
        {
            if (!pagegroups.hasOwnProperty(group))
            {
                continue;
            }

            for (var i = 0; i < techs.length; i++)
            {
                var members = pagegroups[group].members;
                var idx = members.indexOf(techs[i] + user);
                if (-1 != idx)
                {
                    members.splice(idx, 1);
                    pagegroups[group].modified = true;
                }
            }
        }
        //end of page/intercom

        //voicemail group
        // only work on delete user and ( modify user when uncheck hasvoicemail )
        if (!modify_option || (modify_option && modify_option.del_vm))
        {
            for (var group in vmgroups)
            {
                if (!vmgroups.hasOwnProperty(group))
                {
                    continue;
                }


                var mailboxes = vmgroups[group].mailboxes;
                var idx = mailboxes.indexOf(user);
                if (idx != -1)
                {
                    mailboxes.splice(idx, 1);
                    vmgroups[group].modified = true;
                }
            }
        }
        //end of voicemail group
        //follow me 
        if (!modify_option)  //follow me works only in delete user
        {
            for (var context in FOLLOWME_CONF)
            {
                if (!FOLLOWME_CONF.hasOwnProperty(context))
                {
                    continue;
                }

                if (context == user)
                {
                    action_followme.new_action('delcat', context, '', '');
                }
                else if (users.indexOf(context) == -1)    //context will not be removed
                {

                }
                //else the context in the delete user lists, will be removed, skip
            }
        }
        //end of follow me
    }   //end of per user

    // DO actions
    // update ring group, works only delete user not modify user
    if (!modify_option)
    {
        for (var group in ringgroups)
        {
            if (!ringgroups.hasOwnProperty(group))
            {
                continue;
            }

            if (ringgroups[group].modified)
            {
                var temp_members = ringgroups[group].members;
                /* if null, we use quotes, in case that CLI returns invalid params */
                var member_str = temp_members.join('-') || "\'\'";

                //var tmpstr = "action=command&command=database put GROUP/" + group + " MEMBERS " + member_str;
                var tmpstr = "action=DBput&Family=GROUP/" + group + "&Key=MEMBERS&Val=" + member_str;
                batch_post.push(tmpstr);

                //ASTGUI.ASTDB.updateKey( { dbname: 'GROUP/' + group, key : 'NUM', keyvalue : temp_members.length} );
                //tmpstr = "action=command&command=database put GROUP/" + group + " NUM " + temp_members.length;
                tmpstr = "action=Dbput&Family=GROUP/" + group + "&Key=NUM&Val=" + temp_members.length;
                batch_post.push(tmpstr);
            }
        }
    }
    //end of update ring group

    // update page/intercom
    for (var group in pagegroups)
    {
        if (!pagegroups.hasOwnProperty(group))
        {
            continue;
        }

        if (pagegroups[group].modified)
        {
            var modify_group = pagegroups[group];
            action_extensions.new_action('delete', ASTGUI.contexts.PageGroups, 'exten', '', modify_group.oldExten);
            var tmp = modify_group.oldExten.split(',');
            tmp[3] = pagegroups[group].members.join('&');
            var new_exten = tmp.join(',');
            action_extensions.new_action('append', ASTGUI.contexts.PageGroups, 'exten', new_exten);
            pbx_pagegroups[group] = 'exten=' + new_exten;
        }
    }
    //end of page/intercom

    //update voicemail group
    // only work on delete user and ( modify user when uncheck hasvoicemail )
    if (!modify_option || (modify_option && modify_option.del_vm))
    {
        for (var group in vmgroups)
        {
            if (!vmgroups.hasOwnProperty(group))
            {
                continue;
            }

            if (vmgroups[group].modified)
            {
                var tmp_group = ASTGUI.cloneObject(pbx_vmgroups[group]);
                tmp_group.mailboxes = vmgroups[group].mailboxes;
                // we may modified ourselves, instead of calling pbx.vm_groups, if too many network connections
                parent.pbx.vm_groups.remove(group);
                parent.pbx.vm_groups.add(group, tmp_group);
            }
        }
    }
    //end of voicemail group

    //follow me 
    if (!modify_option)  //follow me works only in delete user
    {
        for (var context in FOLLOWME_CONF)
        {
            if (!FOLLOWME_CONF.hasOwnProperty(context))
            {
                continue;
            }

            if (users.indexOf(context) != -1)
            {
                action_followme.new_action('delcat', context, '', '');
            }
            else //context will not be removed, we should delete the number=user1&user2,second
            {
                var ctx = FOLLOWME_CONF[context];
                var pattern = new RegExp("number=[*#0-9&]*,[0-9]+");
                for (var i in ctx)
                {
                    if (!ctx.hasOwnProperty(i) || !pattern.test(ctx[i]))   //not a number field
                    {
                        continue;
                    }

                    //number=1000&1001,30
                    var number_str = ctx[i].betweenXY('=', ',');
                    var numbers = number_str.split('&');
                    var second = ctx[i].afterChar(',');
                    var new_numbers = $(numbers).not(users).get();
                    var new_number_str = new_numbers.join('&');

                    if (number_str != new_number_str)
                    {
                        if (new_number_str)
                        {
                            var new_value = new_number_str + ',' + second;
                            action_followme.new_action('update', context, 'number', new_value, ctx[i].afterStr('number='));
                        }
                        else
                        {
                            action_followme.new_action('delete', context, 'number', '', ctx[i].afterStr('number='));
                        }

                    }

                }
            }
        }

    } //end of follow me

    //call conf action
    action_queues.batchActions();
    action_extensions.batchActions();
    action_followme.batchActions();
    // send actions 
    while (batch_post.length > 0)
    {
        var slice_len = (batch_post.length < 30) ? batch_post.length : 30;
        var tmp_data = batch_post.slice(0, slice_len);
        batch_post.splice(0, slice_len);
        var post_data = { "actions": JSON.stringify(tmp_data) };
        $P.gs.actionSubmit(document, "onebatch", null, { 
            "dataType": "json", 
            "checkReload": false, 
            "postToBody": true, 
            "data": post_data,
            "feedback": false,
            "onResponseProcessed": function ()
            {
                top.dialog.clearDialog();
                top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG816"), callback: function () { mWindow.location.reload(); } });

            }
        });
    }
};

var DELETE_USER = function (obj)
{ // DELETE_USER();
    var a = obj.id;
    ASTGUI.refetchIncomingRules();
    var incomingrules = parent.sessionData.pbxinfo['incomingrules'];
    var item = 'Goto(from-internal,'+a+',1)';
    var item1 = 'Voicemail('+a+',u)';
    var rule;
    var tmp_trunk= '';
    var flags = false;
    for ( var it in incomingrules )
    {
        rule = incomingrules[it];
        rule = rule.toString();
        if ( rule.indexOf(item) > -1 || rule.indexOf(item1) > -1 )
        {
            flags = true;
            var index = it.split('-')[2];
            index = 'trunk_' + index;
            tmp_trunk = ASTGUI.getTrunkNameByIndex(index);
            break;
        }
    }

    top.dialog.dialogConfirm({
        confirmStr: flags ? $P.lang("LANG817").format(a, tmp_trunk) : $P.lang("LANG818").format(a),
        buttons: {
            ok: function ()
            {
                // jcli add to make fxs user changes work right now.
                var c = listOfActions('configchanged.conf');
                if (typeof (parent.sessionData.pbxinfo.users[a].dahdichan) != "undefined" && parent.sessionData.pbxinfo.users[a].dahdichan != "")
                {
                    c.new_action('update', 'configchanged', 'chandahdi', 'yes');
                }
                c.new_action('update', 'configchanged', 'ldap', 'yes');
                c.callActions();
                var p = listOfActions('phonebook1.conf');
                p.new_action('delcat', a, '', '');
                p.callActions();
                // jcli end

                //ybiaozhou remove relative info
                operate_relative_info([a]);

                /* add by yjwu */
                var DELETE = new listOfActions('extensions.conf');
                var context = ASTGUI.contexts.UsrPrefix + a;

                DELETE.new_action('delete', ASTGUI.contexts.ExtLocal, 'include', '', context);
                DELETE.new_action('delcat', context, '', '');
                //DELETE.new_action('delete', 'globals', ASTGUI.globals.obcidUsrPrefix + a, '');
                //try{ delete parent.sessionData.pbxinfo['GLOBALS'][ASTGUI.globals.obcidUsrPrefix + a] } catch(err){ }
                //ASTGUI.ASTDB.deletetree(a);
                ASTGUI.ASTDB.deletetree({ "dbname": 'AAUSER/' + a });

                var FOLLOWME_CONF = config2json({ filename: 'followme.conf', usf: 0 });
                var u = new listOfActions('followme.conf');
                if (FOLLOWME_CONF.hasOwnProperty(a))
                {
                    u.new_action('delcat', a, '', '');
                    var followme = ASTGUI.contexts.FollowmePrefix + a;
                    DELETE.new_action('delcat', followme, '', '');
                    DELETE.new_action('delete', ASTGUI.contexts.ExtFindmefollow, 'include', '', followme);
                }
                u.callActions();

                //operator  ybiaozhou  begin
                if (parent.sessionData.pbxinfo['localextensions']['Operator'])
                {
                    //"Goto(from-internal,6001,1)"
                    var old_exten = parent.sessionData.pbxinfo['localextensions']['Operator'];
                    var tmp_args = ASTGUI.parseContextLine.getArgs(old_exten);
                    if (tmp_args[1] && tmp_args[1] == a)
                    {
                        DELETE.new_action('delete', 'default', 'exten', '', 'o,1,' + old_exten);
                        delete parent.sessionData.pbxinfo['localextensions']['Operator'];
                    }
                }
                //end of operator   ybiaozhou end

                DELETE.callActions();
                /* add end */

                var processDelete = function (vm)
                {
                    if (!vm)
                        vm = false;
                    parent.pbx.users.remove({ user: a, vmdel: vm, callback: function (){
                        top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG821").format(a, $P.lang("LANG2471")), callback: function () { list_extension(); } });
                    }});
                }
                top.dialog.dialogConfirm({
                    confirmStr: $P.lang("LANG822"),
                    buttons: {
                        ok: function ()
                        {
                            processDelete(true);
                        },
                        cancel: function()
                        {
                            processDelete(false);
                        }
                    }
                });
            }
        }
    });
}

var DELETE_SELECTED_USERS = function ()
{ // DELETE_SELECTED_USERS();
    var sel_users = getSelectedUsers();
    if (!sel_users.length)
    {
        top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG823") });
        return;
    }

    top.dialog.dialogConfirm({
        confirmStr: $P.lang("LANG824").format(sel_users.join(", ")),
        buttons: {
            ok: function ()
            {
                top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG825") });
                var c = listOfActions('configchanged.conf');
                for (var i = 0; i < sel_users.length; i++)
                {
                    if (typeof (parent.sessionData.pbxinfo.users[sel_users[i]].dahdichan) != "undefined" && parent.sessionData.pbxinfo.users[sel_users[i]].dahdichan != "")
                    {
                        c.new_action('update', 'configchanged', 'chandahdi', 'yes');
                        break;
                    }
                }
                c.new_action('update', 'configchanged', 'ldap', 'yes');
                c.callActions();
                var p = listOfActions('phonebook1.conf');
                for (var i = 0; i < sel_users.length; i++)
                {
                    p.new_action('delcat', sel_users[i], '', '');
                }
                p.callActions();

                var DO_SELECTED = function ()
                { // DELETE_SELECTED_USERS();
                    operate_relative_info(sel_users);
                    var post_data = { "batch-delete": {} };
                    post_data["batch-delete"]["users"] = sel_users;
                    var json = JSON.stringify(post_data["batch-delete"]);
                    //console.log(json);
                    post_data["batch-delete"] = json;
                    $P.gs.actionSubmit(document, "batchUsers", null, {
                        "dataType": "json",
                        "checkReload": false,
                        "postToBody": true,
                        "data": post_data,
                        "feedback": false,
                        "onResponseProcessed": function ()
                        {
                            top.dialog.clearDialog();
                            top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG816"), callback: function () { mWindow.location.reload(); } });

                        }
                    });

                }
                setTimeout(DO_SELECTED, 100);
            }
        }
    });
}

var SAVE_USER_FORM = function ()
{ // SAVE_USER_FORM();
    var p = listOfActions('phonebook1.conf');
    if (isNewUSER)
    {
        var NU_EXT = ASTGUI.getFieldValue('new_ext');
            EXTENSION_EDIT = NU_EXT;
            isNewUSER = false;
        var newuser_settings = ASTGUI.toCustomObject({ fullname: ASTGUI.getFieldValue('edit_fullname'), registersip: 'no', host: 'dynamic' });

        top.pbx.users.add(NU_EXT, newuser_settings);
        p.new_action('newcat', NU_EXT, '', '');
    }
    p.new_action('autoupdate', EXTENSION_EDIT, 'AccountNumber', EXTENSION_EDIT);
    p.new_action('autoupdate', EXTENSION_EDIT, 'CallerIDName', ASTGUI.getFieldValue('edit_fullname'));
    p.new_action('autoupdate', EXTENSION_EDIT, 'Email', ASTGUI.getFieldValue('edit_email'));
    p.callActions();

    top.dialog.dialogMessage({ type: 'loading', content:  $P.lang("LANG826")});
    var u = EXTENSION_EDIT;
    var tmp_obj = {};
    var x = new listOfActions();
    x.filename('users.conf');
    x.new_action('update', u, 'fullname', ASTGUI.getFieldValue('edit_fullname')); tmp_obj['fullname'] = ASTGUI.getFieldValue('edit_fullname');
    x.new_action('update', u, 'context', ASTGUI.contexts.CallingPlan); tmp_obj['context'] = ASTGUI.contexts.CallingPlan;
    x.new_action('update', u, 'cid_number', EXTENSION_EDIT); tmp_obj['cid_number'] = EXTENSION_EDIT;
    x.new_action('update', u, 'hasvoicemail', ASTGUI.getFieldValue('edit_hasvoicemail')); tmp_obj['hasvoicemail'] = ASTGUI.getFieldValue('edit_hasvoicemail');
    if (_$('edit_hasvoicemail').checked)
    {
        var vmsecret = ASTGUI.getFieldValue('edit_vmsecret');
        if ( vmsecret == null || vmsecret == "" )
        {
            vmsecret = "-"; 
        }
        x.new_action('update', u, 'vmsecret', vmsecret); tmp_obj['vmsecret'] = vmsecret;
        x.new_action('update', u, 'email', ASTGUI.getFieldValue('edit_email')); tmp_obj['email'] = ASTGUI.getFieldValue('edit_email');
    }
    x.new_action('update', u, 'hasdirectory', ASTGUI.getFieldValue('edit_inDirectory')); tmp_obj['hasdirectory'] = ASTGUI.getFieldValue('edit_inDirectory');
    x.new_action('update', u, 'hasmanager', ASTGUI.getFieldValue('edit_cti')); tmp_obj['hasmanager'] = ASTGUI.getFieldValue('edit_cti');
    if (ASTGUI.getFieldValue('edit_cti') == 'yes')
    {
        var tmp_permisions = 'system,call,log,verbose,command,agent,user,config,originate';
        x.new_action('update', u, 'managerread', tmp_permisions); tmp_obj['managerread'] = tmp_permisions;
        x.new_action('update', u, 'managerwrite', tmp_permisions); tmp_obj['managerwrite'] = tmp_permisions;
    } else
    {
        x.new_action('delete', u, 'managerread', '', ''); tmp_obj['managerread'] = '';
        x.new_action('delete', u, 'managerwrite', '', ''); tmp_obj['managerwrite'] = '';
    }
    //ybiaozhou remove [isagent]       x.new_action('update', u, 'hasagent',         ASTGUI.getFieldValue('edit_isagent') );        tmp_obj['hasagent'] = ASTGUI.getFieldValue('edit_isagent') ;
    x.new_action('update', u, 'hassip', ASTGUI.getFieldValue('edit_hasSip')); tmp_obj['hassip'] = ASTGUI.getFieldValue('edit_hasSip');
    x.new_action('update', u, 'hasiax', ASTGUI.getFieldValue('edit_hasIax')); tmp_obj['hasiax'] = ASTGUI.getFieldValue('edit_hasIax');
    x.new_action('update', u, 'secret', ASTGUI.getFieldValue('edit_secret')); tmp_obj['secret'] = ASTGUI.getFieldValue('edit_secret');
    if (_$('edit_hasSip').checked)
    {
        x.new_action('update', u, 'nat', ASTGUI.getFieldValue('edit_nat')); tmp_obj['nat'] = ASTGUI.getFieldValue('edit_nat');
        x.new_action('update', u, 'canreinvite', ASTGUI.getFieldValue('edit_canreinvite')); tmp_obj['canreinvite'] = ASTGUI.getFieldValue('edit_canreinvite');
        x.new_action('update', u, 'dtmfmode', ASTGUI.getFieldValue('edit_dtmfmode')); tmp_obj['dtmfmode'] = ASTGUI.getFieldValue('edit_dtmfmode');
        x.new_action('update', u, 'insecure', ASTGUI.getFieldValue('edit_insecure')); tmp_obj['insecure'] = ASTGUI.getFieldValue('edit_insecure');
        x.new_action('update', u, 'qualify', ASTGUI.getFieldValue('edit_qualify')); tmp_obj['qualify'] = ASTGUI.getFieldValue('edit_qualify');
        if (_$('edit_qualify').checked)
        {
            x.new_action('update', u, 'qualifyfreq', ASTGUI.getFieldValue('edit_qualifyfreq')); tmp_obj['qualify'] = ASTGUI.getFieldValue('edit_qualifyfreq');
        }
        x.new_action('update', u, 'authid', ASTGUI.getFieldValue('edit_authid')); tmp_obj['authid'] = ASTGUI.getFieldValue('edit_authid');
    }
    if (_$('edit_hasIax').checked)
    {
        if (ASTGUI.getFieldValue('edit_requirecalltoken') == '')
        {
            x.new_action('delete', u, 'requirecalltoken', ''); tmp_obj['requirecalltoken'] = '';
        }
        else
        {
            x.new_action('update', u, 'requirecalltoken', ASTGUI.getFieldValue('edit_requirecalltoken')); tmp_obj['requirecalltoken'] = ASTGUI.getFieldValue('edit_requirecalltoken');
        }
        if (ASTGUI.getFieldValue('edit_maxcallnumbers'))
        {
            x.new_action('update', u, 'maxcallnumbers', ASTGUI.getFieldValue('edit_maxcallnumbers')); tmp_obj['maxcallnumbers'] = ASTGUI.getFieldValue('edit_maxcallnumbers');
        }
        else
        {
            x.new_action('delete', u, 'maxcallnumbers', ''); tmp_obj['maxcallnumbers'] = '';
        }
    }

    //x.new_action('update', u, 'pickupgroup', ASTGUI.getFieldValue('edit_pickupgroup')); tmp_obj['pickupgroup'] = ASTGUI.getFieldValue('edit_pickupgroup');
    x.new_action('update', u, 'encryption', ASTGUI.getFieldValue('edit_srtp')); tmp_obj['encryption'] = ASTGUI.getFieldValue('edit_srtp');
    x.new_action('update', u, 'faxdetect', ASTGUI.getFieldValue('edit_faxdetect')); tmp_obj['faxdetect'] = ASTGUI.getFieldValue('edit_faxdetect');
    x.new_action('update', u, 'transport', ASTGUI.getFieldValue('edit_transport')); tmp_obj['edit_transport'] = ASTGUI.getFieldValue('edit_transport');

    // added by dcwei 2012-07-11
    if (ASTGUI.getFieldValue('strategy_ipacl') == 0)
    {
        x.new_action('update', u, 'strategy_ipacl', ASTGUI.getFieldValue('strategy_ipacl'));
        x.new_action('update', u, 'deny', '0.0.0.0/255.255.255.255');
        x.new_action('update', u, 'permit', '0.0.0.0/0.0.0.0'); tmp_obj['strategy_ipacl'] = ASTGUI.getFieldValue('strategy_ipacl');
    } else if (ASTGUI.getFieldValue('strategy_ipacl') == 1)
    {
        var buf = "";
        var arr = "";
        var value = "";
        buf = window.location.host;
        arr = buf.split(":");
        value = arr[0] + "/255.255.255.0";
        x.new_action('update', u, 'strategy_ipacl', ASTGUI.getFieldValue('strategy_ipacl'));
        x.new_action('update', u, 'deny', '0.0.0.0/0.0.0.0');
        /* jcli add */
        if(ASTGUI.getFieldValue('local_network1'))
            value += ","+ ASTGUI.getFieldValue('local_network1')+"/255.255.255.0";
        if(ASTGUI.getFieldValue('local_network2'))
            value += ","+ ASTGUI.getFieldValue('local_network2')+"/255.255.255.0";
        if(ASTGUI.getFieldValue('local_network3'))
            value += ","+ ASTGUI.getFieldValue('local_network3')+"/255.255.255.0";
        /* jcli end*/
        x.new_action('update', u, 'permit', value); tmp_obj['strategy_ipacl'] = ASTGUI.getFieldValue('strategy_ipacl');
    } else if (ASTGUI.getFieldValue('strategy_ipacl') == 2)
    {
        x.new_action('update', u, 'strategy_ipacl', ASTGUI.getFieldValue('strategy_ipacl'));
        x.new_action('update', u, 'deny', '0.0.0.0/0.0.0.0');
        x.new_action('update', u, 'permit', _$('specific_ip').value+"/255.255.255.255"); 
        tmp_obj['strategy_ipacl'] = ASTGUI.getFieldValue('strategy_ipacl');
    }
    else
    {
        x.new_action('update', u, 'strategy_ipacl', ASTGUI.getFieldValue('strategy_ipacl'));
        x.new_action('update', u, 'deny', '0.0.0.0/0.0.0.0');
        x.new_action('update', u, 'permit', '0.0.0.0/255.255.255.255'); tmp_obj['strategy_ipacl'] = ASTGUI.getFieldValue('strategy_ipacl');
    }

    var tmp_cl = parent.sessionData.pbxinfo.users[u].getProperty('call-limit');
    if (!tmp_cl)
    {
        x.new_action('update', u, 'call-limit', '100');
        tmp_obj['call-limit'] = '100';
    }

    // jcli modify
    var c = listOfActions('configchanged.conf');
    if ((zapchan_Before != ASTGUI.getFieldValue('edit_fxs')) || ASTGUI.getFieldValue('edit_fxs'))
    {
        c.new_action('update', 'configchanged', 'chandahdi', 'yes');
    }
    c.new_action('update', 'configchanged', 'ldap', 'yes');
    c.callActions();
    // jcli end
    (function ()
    {
        var fs = ASTGUI.getFieldValue('edit_fxs');
        if (fs)
        {
            var tmp_flash = ASTGUI.getFieldValue('edit_flash') || '750';
            var tmp_minflash = ASTGUI.getFieldValue('edit_minflash') || '200';
            var tmp_rxflash = ASTGUI.getFieldValue('edit_rxflash') || '1250';
            // jcli comment these to avoid dahdi signalling conflict, hangzhou trac #372 
            //var sg = (parent.sessionData.PORTS_SIGNALLING.ls.contains(fs)) ? 'fxo_ls':'fxo_ks' ;

            /* jcli add for analog fxs user */
            var tmp_cidsignalling = ASTGUI.getFieldValue('edit_cidsignalling');
            var tmp_rxgain = ASTGUI.getFieldValue('edit_rxgain').replace(/^\+/, '') || '0';
            var tmp_txgain = ASTGUI.getFieldValue('edit_txgain').replace(/^\+/, '') || '0';
            var tmp_answeronpolarityswitch = ASTGUI.getFieldValue('edit_polarityswitch');
            var tmp_hanguponpolarityswitch = tmp_answeronpolarityswitch;
            x.new_action('update', u, 'cidsignalling', tmp_cidsignalling); tmp_obj['cidsignalling'] = tmp_cidsignalling;
            x.new_action('update', u, 'rxgain', tmp_rxgain); tmp_obj['rxgain'] = tmp_rxgain;
            x.new_action('update', u, 'txgain', tmp_txgain); tmp_obj['txgain'] = tmp_txgain;
            x.new_action('update', u, 'answeronpolarityswitch', tmp_answeronpolarityswitch); tmp_obj['answeronpolarityswitch'] = tmp_answeronpolarityswitch;
            x.new_action('update', u, 'hanguponpolarityswitch', tmp_hanguponpolarityswitch); tmp_obj['hanguponpolarityswitch'] = tmp_hanguponpolarityswitch;

            x.new_action('delete', u, top.sessionData.DahdiChannelString, '');
            x.new_action('append', u, top.sessionData.DahdiChannelString, fs); tmp_obj[top.sessionData.DahdiChannelString] = fs;
            // jcli comment these to avoid dahdi signalling conflict, hangzhou trac #372 
            //x.new_action('update', u, 'signalling', sg) ;                    tmp_obj['signalling'] = sg ;
            x.new_action('update', u, 'flash', tmp_flash); tmp_obj['flash'] = tmp_flash;
            x.new_action('update', u, 'rxflash_min', tmp_minflash); tmp_obj['rxflash_min'] = tmp_minflash;
            x.new_action('update', u, 'rxflash', tmp_rxflash); tmp_obj['rxflash'] = tmp_rxflash;
            x.new_action('update', u, 'threewaycalling', ASTGUI.getFieldValue('edit_3wayCalling')); tmp_obj['threewaycalling'] = ASTGUI.getFieldValue('edit_3wayCalling');
            x.new_action('update', u, 'callwaiting', ASTGUI.getFieldValue('edit_callWaiting')); tmp_obj['callwaiting'] = ASTGUI.getFieldValue('edit_callWaiting');
            x.new_action('update', u, 'sharpissendkey', ASTGUI.getFieldValue('edit_sharpissendkey')); tmp_obj['sharpissendkey'] = ASTGUI.getFieldValue('edit_sharpissendkey');
            x.new_action('update', u, 'echocancel', ASTGUI.getFieldValue('edit_echocancel')); tmp_obj['echocancel'] = ASTGUI.getFieldValue('edit_echocancel');
            x.new_action('update', u, 'sendcalleridafter', ASTGUI.getFieldValue('edit_sendcalleridafter')); tmp_obj['sendcalleridafter'] = ASTGUI.getFieldValue('edit_sendcalleridafter');
            /* jcli end */

        } else
        {
            x.new_action('delete', u, top.sessionData.DahdiChannelString, ''); tmp_obj[top.sessionData.DahdiChannelString] = '';
            x.new_action('delete', u, 'cidsignalling', '');
            x.new_action('delete', u, 'rxgain', '');
            x.new_action('delete', u, 'txgain', '');
            x.new_action('delete', u, 'answeronpolarityswitch', '');
            x.new_action('delete', u, 'hanguponpolarityswitch', '');
            x.new_action('delete', u, 'flash', '');
            x.new_action('delete', u, 'rxflash', '');
            x.new_action('delete', u, 'threewaycalling', '');
            x.new_action('delete', u, 'callwaiting', '');
            x.new_action('delete', u, 'sharpissendkey', '');
            x.new_action('delete', u, 'echocancel', '');
            x.new_action('delete', u, 'sendcalleridafter', '');
        }

        var codecs = ASTGUI.selectbox.readAllValues('select_allow_codec').join(',') || '';

        x.new_action('delete', u, 'disallow', '');
        x.new_action('delete', u, 'allow', '');
        x.new_action('append', u, 'disallow', 'all'); tmp_obj['disallow'] = 'all';
        if (codecs)
        {
            x.new_action('append', u, 'allow', codecs); tmp_obj['allow'] = codecs;
        }
        
        var pickup = ASTGUI.selectbox.readAllValues('select_allow_pickup').join(',') || '';
        x.new_action('update', u, 'callgroup', pickup);
        x.new_action('update', u, 'pickupgroup', pickup);
        x.new_action('delete', u, 'language', '');
        if (_$('edit_language').value)
        {
            x.new_action('update', u, 'language', _$('edit_language').value);
        }
    })();

    //ybiaozhou relative info
    if (parent.sessionData.pbxinfo.users[u])
    {
        var del_techs = [];
        if (parent.sessionData.pbxinfo.users[u]['hassip']
            && !ASTGUI.getFieldValue('edit_hasSip').isAstTrue()
            && parent.sessionData.pbxinfo.users[u]['hassip'].isAstTrue())
        {
            del_techs.push('hassip');
        }
        if (parent.sessionData.pbxinfo.users[u]['hasiax']
            && !ASTGUI.getFieldValue('edit_hasIax').isAstTrue()
            && parent.sessionData.pbxinfo.users[u]['hasiax'].isAstTrue())
        {
            del_techs.push('hasiax');
        }
        if (parent.sessionData.pbxinfo.users[u]['dahdichan']
            && !ASTGUI.getFieldValue('edit_fxs'))
        {
            del_techs.push('hasdahdi');
        }

        operate_relative_info([u], {
            "techs": del_techs,
            "del_vm": !ASTGUI.getFieldValue('edit_hasvoicemail').isAstTrue()
        });

    }

    var after = function ()
    {
        parent.sessionData.pbxinfo.users[u].updateProperties(tmp_obj); // update all the edited values

        /* add by yjwu */
        var a = ASTGUI.contexts.UsrPrefix + u;
        var b = ASTGUI.getFieldValue('edit_hasvoicemail') == 'yes' ? u : 'novm';
        var c = u + ',1,Macro(exten-vm,' + b + ',' + u + ')';
        var EXN_CNF = config2json({ filename: 'extensions.conf', usf: 0 });


        //ybiaozhou add exten-> hint  begin
        var value1 = ASTGUI.getFieldValue('edit_hasSip') == 'yes' ? ("SIP/" + u) : '';
        var value2 = ASTGUI.getFieldValue('edit_hasIax') == 'yes' ? ("IAX2/" + u) : '';
        var value3 = ASTGUI.getFieldValue('edit_fxs') ? ("DAHDI/" + ASTGUI.getFieldValue('edit_fxs')) : '';
        if (value1 != '' && value2 != '')
        {
            value1 += '&';
        }

        if (value2 != '' && value3 != '')
        {
            value2 += '&';
        }

        if (value1 != '' && value3 != '' && value2 == '')
        {
            value1 += '&';
        }
        var dial_str = value1 + value2 + value3;

        var mm = new listOfSynActions('extensions.conf');

        if (EXN_CNF.hasOwnProperty(a))
        {
            mm.new_action('delcat', a, '', '');
        }
        else
        {
            mm.new_action('append', ASTGUI.contexts.ExtLocal, 'include', a);
        }

        mm.new_action('newcat', a, '', '');
        mm.new_action('append', a, 'exten', c);
        mm.new_action('append', a, 'exten', u + ',hint,${DB(AAUSER/' + u + '/DIAL)}');
        if (ASTGUI.getFieldValue('edit_hasvoicemail') == 'yes')
        {
            mm.new_action('append', a, 'exten', '${VM_PRE}' + u + ',1,Macro(vm,' + u + ',u)');        
        }

        //ybiaozhou add exten-> hint  begin end
        ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'PERMISSION', keyvalue: ASTGUI.getFieldValue('edit_user_permission')});
        ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'DIAL', keyvalue: (value1 + value2 + value3) });
        ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'AUTORECORD', keyvalue: ASTGUI.getFieldValue('edit_user_record')});
        
        var enable = ASTGUI.getFieldValue('edit_disablepin') == 'yes' ? 'NOPASSWD' : 'HASPASSWD';
        ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'pinless', keyvalue: enable });

        //ybiaozhou add email to AstDB
        if (ASTGUI.getFieldValue('edit_email'))
        {
            ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'EMAIL', keyvalue: ASTGUI.getFieldValue('edit_email') });
        }
        else
        {
            ASTGUI.ASTDB.deleteKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'EMAIL'});
        }

        if (ASTGUI.getFieldValue('edit_trunk_secret'))
        {
            ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'PROXY_PWD', keyvalue: ASTGUI.getFieldValue('edit_trunk_secret')});
        }
        else
        {
            ASTGUI.ASTDB.deleteKey( { dbname: 'AAUSER/' + EXTENSION_EDIT, key : 'PROXY_PWD' } );
        }

        var id = ASTGUI.getFieldValue('edit_OutBoundCallerid');
        var name = ASTGUI.getFieldValue('edit_fullname');
        var value = '';
        if (id != '')
        {
            value = ((name == '') ? id : name) + '<' + id + '>';
        }
        ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'OUTBOUNDCID', keyvalue: value });
        ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'CIDNAME', keyvalue:  name});


        //call forward busy/no answer/uncondition
        if (ASTGUI.getFieldValue('edit_cfbext'))
        {
            ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'CFB', keyvalue: ASTGUI.getFieldValue('edit_cfbext')});
        }
        else
        {
            ASTGUI.ASTDB.deleteKey( { dbname: 'AAUSER/' + EXTENSION_EDIT, key : 'CFB' } );
        }

        if (ASTGUI.getFieldValue('edit_cfnext'))
        {
            ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'CFN', keyvalue: ASTGUI.getFieldValue('edit_cfnext')});
        }
        else
        {
            ASTGUI.ASTDB.deleteKey( { dbname: 'AAUSER/' + EXTENSION_EDIT, key : 'CFN' } );
        }

        if (ASTGUI.getFieldValue('edit_cfuext'))
        {
            ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'CFU', keyvalue: ASTGUI.getFieldValue('edit_cfuext')});
        }
        else
        {
            ASTGUI.ASTDB.deleteKey( { dbname: 'AAUSER/' + EXTENSION_EDIT, key : 'CFU' } );
        }

        ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'RT', keyvalue: ASTGUI.getFieldValue('edit_ringtimeout')});
        ASTGUI.ASTDB.updateKey( { dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'language', keyvalue: _$('edit_language').value } );
        
        ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'SKIPVMAUTH', keyvalue: ASTGUI.getFieldValue('edit_skipvmauth').toUpperCase()});
        
        ASTGUI.ASTDB.updateKey({ dbname: 'AAUSER/' + EXTENSION_EDIT, key: 'ENABLEHOTDESK', keyvalue: ASTGUI.getFieldValue('edit_enablehotdesk').toUpperCase()});

        mm.callActions();
        //top.dialog.clearDialog();

        top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG815"), callback: function () {
            mWindow.location.reload();
        } });
    }
    x.callActions(after);
}

var save_multiple_users = function ()
{ // save_multiple_users()
    var users = getSelectedUsers(); // needs to get from parent
    var x = new listOfActions('users.conf');
    var del_techs = [];     // for remove relative tech/USER 
    var do_batch_modify=function(){
        var tmp_conf = [];
        var tmp_db = [];
        var a;

        if (_$('edit_check_multiple_permission').checked)
        {
            a = 'PERMISSION:' + ASTGUI.getFieldValue('edit_multiple_permission');
            tmp_db.push(a);
        }

        if (_$('edit_check_multiple_hasvoicemail').checked)
        {
            a = 'hasvoicemail:' + ASTGUI.getFieldValue('edit_multiple_hasvoicemail');
            tmp_conf.push(a);
        }
        
        if (_$('edit_check_multiple_ringtimeout').checked)
        {
            a = 'RT:' + ASTGUI.getFieldValue('edit_multiple_ringtimeout');
            tmp_db.push(a);
        }
        
        if (_$('edit_check_multiple_language').checked)
        {
            a = 'language:' + ASTGUI.getFieldValue('edit_multiple_language');
            tmp_db.push(a);
            tmp_conf.push(a);
        }
        
        if (_$('edit_check_multiple_dial').checked)
        {
            a = 'hassip:' + ASTGUI.getFieldValue('edit_multiple_hassip');
            if (!ASTGUI.getFieldValue('edit_multiple_hassip').isAstTrue())
            {
                del_techs.push("hassip");   //to delete relative info of  the tech of user
            }
            tmp_conf.push(a);
            a = 'hasiax:' + ASTGUI.getFieldValue('edit_multiple_hasiax');
            if (!ASTGUI.getFieldValue('edit_multiple_hasiax').isAstTrue())
            {
                del_techs.push("hasiax");   //to delete relative info of  the tech of user
            }
            tmp_conf.push(a);
        }

        if (_$('edit_check_multiple_disablepin').checked)
        {
            var enable = ASTGUI.getFieldValue('edit_multiple_disablepin') == 'yes' ? 'NOPASSWD' : 'HASPASSWD';

            a = 'pinless:' + enable;
            tmp_db.push(a);
        }

        if (_$('edit_check_multiple_allow').checked)
        {
            var codecs = ASTGUI.selectbox.readAllValues('select_allow_codec').join(',') || '';
            tmp_conf.push('allow:' + codecs);
        }
        
        if (_$('edit_check_multiple_pickup').checked)
        {
            var pickup = ASTGUI.selectbox.readAllValues('select_allow_pickup').join(',') || '';
            tmp_conf.push('callgroup:' + pickup);
            tmp_conf.push('pickupgroup:' + pickup);
        }

        if (_$('edit_check_multiple_secret').checked)
        {
            if (_$('edit_multiple_seCHoice0').checked)
            {
                a = 'secret:r';
            }
            else if (ASTGUI.getFieldValue('edit_multiple_seCHoice1') == 'on')
            {
                a = 'secret:' + encodeURIComponent(ASTGUI.getFieldValue('edit_multiple_secret'));
            } else if (ASTGUI.getFieldValue('edit_multiple_seCHoice2') == 'on')
            {
                a = 'secret';
            }
            tmp_conf.push(a);
        }

        if (_$('edit_check_multiple_iax').checked)
        {
            if (ASTGUI.getFieldValue('edit_multiple_requirecalltoken') != '')
            {
                a = 'requirecalltoken:' + ASTGUI.getFieldValue('edit_multiple_requirecalltoken');
                tmp_conf.push(a);
            }
        }

        if (_$('edit_check_multiple_qualify').checked)
        {
            a = 'qualify:'+ ASTGUI.getFieldValue('edit_multiple_qualify');
            tmp_conf.push(a);
        }

        if (_$('edit_check_multiple_qualifyfreq').checked)
        {
            a = 'qualifyfreq:'+ ASTGUI.getFieldValue('edit_multiple_qualifyfreq');
            tmp_conf.push(a);
        }

        if (_$('edit_check_multiple_maxcallnumbers').checked)
        {
            a = 'maxcallnumbers:';

            if (ASTGUI.getFieldValue('edit_multiple_maxcallnumbers'))
            {
                a = a + ASTGUI.getFieldValue('edit_multiple_maxcallnumbers');
            }
            tmp_conf.push(a);
        }

        if (_$('edit_check_multiple_nat').checked)
        {
            a = 'nat:' + ASTGUI.getFieldValue('edit_multiple_nat');
            tmp_conf.push(a);
        }

        if (_$('edit_check_multiple_canreinvite').checked)
        {
            a = 'canreinvite:' + ASTGUI.getFieldValue('edit_multiple_canreinvite');
            tmp_conf.push(a);
        }

        if (_$('edit_check_multiple_dtmfmode').checked)
        {
            a = 'dtmfmode:' + ASTGUI.getFieldValue('edit_multiple_dtmfmode');
            tmp_conf.push(a);
        }

        if (_$('edit_check_multiple_insecure').checked)
        {
            a = 'insecure:' + ASTGUI.getFieldValue('edit_multiple_insecure');
            tmp_conf.push(a);
        }

        if (_$('edit_check_multiple_srtp').checked)
        {
            a = 'encryption:' + ASTGUI.getFieldValue('edit_multiple_srtp');
            tmp_conf.push(a);
        }

        //ybiaozhou add faxdetect 
        if (_$('edit_check_multiple_faxdetect').checked)
        {
            a = 'faxdetect:' + ASTGUI.getFieldValue('edit_multiple_faxdetect');
            tmp_conf.push(a);
        }
        
        if (_$('edit_check_multiple_strategy').checked)
        {
            if (ASTGUI.getFieldValue('edit_multiple_strategy') == 0)
            {
                a = 'strategy_ipacl:0';
                tmp_conf.push(a);
                a = 'deny:0.0.0.0/255.255.255.255';
                tmp_conf.push(a);
                a = 'permit:0.0.0.0/0.0.0.0';
                tmp_conf.push(a);
            } 
            else if (ASTGUI.getFieldValue('edit_multiple_strategy') == 1)
            {
                var buf = "";
                var arr = "";
                var value = "";
                buf = window.location.host;
                arr = buf.split(":");
                value = arr[0] + "/255.255.255.0";
                a = 'strategy_ipacl:1';
                tmp_conf.push(a); 
                a = 'deny:0.0.0.0/0.0.0.0';
                tmp_conf.push(a);               
                if(ASTGUI.getFieldValue('edit_multiple_local_network1'))
                    value += ","+ ASTGUI.getFieldValue('edit_multiple_local_network1')+"/255.255.255.0";
                if(ASTGUI.getFieldValue('edit_multiple_local_network2'))
                    value += ","+ ASTGUI.getFieldValue('edit_multiple_local_network2')+"/255.255.255.0";
                if(ASTGUI.getFieldValue('edit_multiple_local_network3'))
                    value += ","+ ASTGUI.getFieldValue('edit_multiple_local_network3')+"/255.255.255.0";
                a = 'permit:' + value;
                tmp_conf.push(a);
            } 
            else if (ASTGUI.getFieldValue('edit_multiple_strategy') == 2)
            {
                a = 'strategy_ipacl:2';
                tmp_conf.push(a);
                a = 'deny:0.0.0.0/0.0.0.0';
                tmp_conf.push(a);
                a = 'permit:' +  _$('edit_multiple_specific_ip').value + "/255.255.255.255"; 
                tmp_conf.push(a);
            }
        }
    
    

        if (_$('edit_check_multiple_obcid').checked)
        {
            var tmp_cid = [];
        }

        if (_$('edit_check_multiple_vmsecret').checked)
        {
            if (_$('edit_multiple_vmCHoice0').checked)
            {
                a = 'vmsecret:r';
            }
            else if (_$('edit_multiple_vmCHoice1').checked)
            {
                var vmsecret = ASTGUI.getFieldValue('edit_multiple_vmsecret');
                if (vmsecret == null || vmsecret == "")
                {
                    vmsecret = "-";
                }
                a = 'vmsecret:' + vmsecret;
            }
            else if (_$('edit_multiple_vmCHoice2').checked)
            {
                a = 'vmsecret'
            }
            tmp_conf.push(a);
        }

        if (_$('edit_check_multiple_dial').checked)
        {
            var tmp_dial = [];
        }

        users.each(function (u)
        {
            var value;

            if (tmp_cid != undefined)
            {

                //OBCID_LIST[ASTGUI.globals.obcidUsrPrefix + u] = ASTGUI.getFieldValue('edit_multiple_obcid') ;
                var cidnumber = ASTGUI.getFieldValue('edit_multiple_obcid');
                var fullname = parent.sessionData.pbxinfo.users[u]['fullname'];
                value = '""';
                if (cidnumber != '')
                {
                    value = (fullname ? fullname : cidnumber) + '<' + cidnumber + '>';
                }

                tmp_cid.push(value);
                //tmp_other[u]='AAUSER/' + u + ' OUTBOUNDCID ' + value;
                //ASTGUI.ASTDB.updateKey( { dbname : 'AAUSER/' + u, key : 'OUTBOUNDCID',keyvalue:value } );
            }

            if (tmp_dial != undefined)
            {
                var value1 = '';
                var value2 = '';
                var value3 = '';

                if (_$('edit_check_multiple_dial').checked)
                {
                    var value1 = ASTGUI.getFieldValue('edit_multiple_hassip') == 'yes' ? ("SIP/" + u) : '';
                    var value2 = ASTGUI.getFieldValue('edit_multiple_hasiax') == 'yes' ? ("IAX2/" + u) : '';
                }

                var value3 = parent.sessionData.pbxinfo.users[u]['dahdichan'] ? ("DAHDI/" + parent.sessionData.pbxinfo.users[u]['dahdichan']) : '';
                if (value1 != '' && value2 != '')
                {
                    value1 += '&';
                }

                if (value2 != '' && value3 != '')
                {
                    value2 += '&';
                }

                if (value1 != '' && value3 != '' && value2 == '')
                {
                    value1 += '&';
                }
                value = value1 + value2 + value3;
                tmp_dial.push(value);
            }

            if (tmp_vmsec != undefined)
            {

                if (parent.sessionData.pbxinfo.users[u].hasOwnProperty('vmsecret'))
                {
                    value = parent.sessionData.pbxinfo.users[u]['vmsecret'];
                }
                else
                {
                    value = u;
                }

                if (value == '')
                {
                    value = u;
                }

                tmp_vmsec.push(value);
            }
        });

        //delete techs or user voicemail in relative part
        var uncheck_hasvm_flag = (_$('edit_check_multiple_hasvoicemail').checked && !ASTGUI.getFieldValue('edit_multiple_hasvoicemail').isAstTrue());
        if (del_techs.length > 0 || uncheck_hasvm_flag)
        {
            operate_relative_info(users, { "techs": del_techs, "del_vm": uncheck_hasvm_flag });
        }

        var post_data = { "batch-update": {} };

        post_data["batch-update"]["users"] = users;
        post_data["batch-update"]["users.conf"] = tmp_conf;
        post_data["batch-update"]["astdb"] = tmp_db;

        if (_$('edit_check_multiple_hasvoicemail').checked)
        {
            var has_vm = ASTGUI.getFieldValue('edit_multiple_hasvoicemail');
            post_data["batch-update"]["extensions.conf"] = (has_vm != 'no') ? (["hasvoicemail"]) : (["hasvoicemail:novm"]);
        }

        if (tmp_cid != undefined)
        {
            post_data["batch-update"]["OUTBOUNDCID"] = tmp_cid;
        }
        if (tmp_vmsec != undefined)
        {
            post_data["batch-update"]["vmsecret"] = tmp_vmsec;
        }
        if (tmp_dial != undefined)
        {
            post_data["batch-update"]["DIAL"] = tmp_dial;
        }

        var json = JSON.stringify(post_data["batch-update"]);

        post_data["batch-update"] = json;

        top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG814") });

        var DO_UPDATE = function ()
        {
            $P.gs.actionSubmit(document, "batchUsers", null, { 
                "dataType": "json", 
                "checkReload": false, 
                "postToBody": true, 
                "data": post_data,
                "feedback": false, 
                "onResponseProcessed": function () {
                    top.dialog.dialogMessage({ 
                        type: 'success', 
                        content: $P.lang("LANG815"), 
                        callback: function () { mWindow.location.reload(); } 
                        });
                } 
            });
        };
        setTimeout(DO_UPDATE, 100);
    }

    if (_$('edit_check_multiple_hasvoicemail').checked)
    {
        if (ASTGUI.getFieldValue('edit_multiple_hasvoicemail') == 'yes')
        {
            var has_secret = 0;
            if (_$('edit_check_multiple_vmsecret').checked)
            {
                if (_$('edit_multiple_vmCHoice1').checked || _$('edit_multiple_vmCHoice2').checked)
                {
                    has_secret = 1;
                }
            }

            if (has_secret != 1)
            {
                top.dialog.dialogConfirm({
                    confirmStr: $P.lang("LANG827"), 
                    buttons: {
                        ok: function(){do_batch_modify();},
                        cancel: function(){
                            top.dialog.container.show();
                            top.dialog.shadeDiv.show();
                        }
                    }
                });

                var tmp_vmsec = [];
            }
            else
            {
                do_batch_modify();
            }
        }
        else
        {
            do_batch_modify();
        }
    }
    else
    {
        do_batch_modify();
    }
};

var editvmenable = function(tmp)
{
    if (_$("edit_check_multiple_vmsecret").checked && _$('edit_multiple_vmCHoice1').checked)
    {
        _$("edit_multiple_vmsecret").disabled = false;
    }
    else
    {
        _$("edit_multiple_vmsecret").disabled = true;
    }
};

var editseenable = function(tmp)
{
    if (_$("edit_check_multiple_secret").checked && _$('edit_multiple_seCHoice1').checked)
    {
        _$("edit_multiple_secret").disabled = false;
    }
    else
    {
        _$("edit_multiple_secret").disabled = true;
    }
};

var password_change = function()
{
    _$('batch_secret').disabled = !_$('batch_same_secret').checked;
    _$('batch_vmsecret').disabled = !_$('batch_same_vmsecret').checked;
}
var change_show = function()
{
    var flag = 0;
    
    if (_$("edit_hasSip").checked)
        $("#div_sip").show();
    else
        $("#div_sip").hide();

    if (_$("edit_hasIax").checked)
        $("#div_iax").show();
    else
        $("#div_iax").hide();

    if (_$("edit_fxs").selectedIndex == 0){
        $("#div_fxs").hide();
    }
    else{
        $("#div_fxs").show();
        flag = 1;
    }

    if (_$("strategy_ipacl").selectedIndex == 1){
        $("#local_networks").show();
        flag = 1;
    }
    else
        $("#local_networks").hide();

    if (_$("strategy_ipacl").selectedIndex == 2){
        $("#allow_a_ip").show();
        flag = 1;
    }
    else
        $("#allow_a_ip").hide();
    
    if (_$("edit_multiple_strategy").selectedIndex == 1){
        $("#multiple_local_networks").show();
        flag = 1;
    }
    else
        $("#multiple_local_networks").hide();

    if (_$("edit_multiple_strategy").selectedIndex == 2){
        $("#multiple_allow_a_ip").show();
        flag = 1;
    }
    else
        $("#multiple_allow_a_ip").hide();

    if (_$("batch_strategy").selectedIndex == 1){
        $("#batch_local_networks").show();
        flag = 1;
    }
    else
        $("#batch_local_networks").hide();

    if (_$("batch_strategy").selectedIndex == 2){
        $("#batch_allow_a_ip").show();
        flag = 1;
    }
    else
        $("#batch_allow_a_ip").hide();
    
    if (window.frameElement)
    {
        $(window.frameElement).css("height","0px");
        $(window.frameElement).css("width","0px");
    }
    
    top.dialog.currentDialogType = "iframe";
    if (flag == 1) {
        top.dialog.repositionDialog();
        flag = 0;
    }
    else{
        top.dialog.repositionDialog("none");
    }
};

var change_enablehotdesk = function()
{
    if (_$("edit_enablehotdesk").checked)
    {
        if(EXTENSION_EDIT != null)
            ASTGUI.updateFieldToValue('edit_authid', EXTENSION_EDIT);
        
        var new_rule = { 
                       alphanumeric: true, 
                       minlength: 4,
                       customCallback: [$P.lang("LANG2127").format("user"), function()
                       {
                           return _$('edit_secret').value != '' || (!_$('edit_hasSip').checked && !_$('edit_hasIax').checked);
                       }]
                       };
        $P("#edit_secret", document).rules("remove");
        
        $P("#edit_secret", document).rules("add", new_rule);
        
    }
    else
    {
        var new_rule = {
                       keyboradNoSpacesemicolon: true,
                       minlength: 4,
                       customCallback: [$P.lang("LANG2127").format("user"), function()
                       {
                           return _$('edit_secret').value != '' || (!_$('edit_hasSip').checked && !_$('edit_hasIax').checked);
                       }]
                       };
        $P("#edit_secret", document).rules("remove");
        
        $P("#edit_secret", document).rules("add", new_rule);
    }
};

var reset_form_codecs = function (allow_codecs, listOfCodecs, id) {

    if (typeof allow_codecs == 'string' && allow_codecs === 'default' && id === 'codec')
    {
        allow_codecs = ['ulaw', 'alaw', 'gsm', 'g726', 'g722', 'g729', 'h264'];
    }


    allow_codecs.each(function (item)
    {
        if (listOfCodecs.hasOwnProperty(item))
        {
            ASTGUI.selectbox.append('select_allow_' + id, listOfCodecs[item], item);
        }
    });

    for (var item in listOfCodecs)
    {
        if (!listOfCodecs.hasOwnProperty(item))
        {
            continue;
        }

        if (allow_codecs.contains(item))
        {
            continue;
        }
        else
        {
            ASTGUI.selectbox.append('select_available_' + id, listOfCodecs[item], item);
        }
    }

};


var get_sip_peers = function () 
{
    var responseText = top.ASTGUI.cliCommand('sip show peers');
    var commandResult = ASTGUI.parseCLIResponse(responseText);
    var peersObj = {};
    var ulist = top.pbx.users.list();

   
    if (commandResult.trim() === '')
    { 
        return {};
    }
    
    var lines = commandResult.split('\n');
    lines.each( function (line) {
        //Name/username             Host              Expires  Dyn Forcerport ACL Port     Status
        //#define FORMAT  "%-25.25s %-16.16s %4ld/%-4d %-3.3s %-10.10s %-3.3s %-8d %-10s %s\n"
        var name = line.slice(0, 25).beforeChar('/').trim();
        var host = line.slice(26, 26 + 16).trim();
        var port = line.slice(72, 72 + 8).trim();

        // skip: name is not a extension user, maybe it's a trunk
        if (!ulist.contains(name))
        {
            return;
        }

        // skip: no ip address
        if (host === '(Unspecified)')
        {
            return;
        }

        // add the peer info to peersObj 
        peersObj[name] = {
            "name": name,
            "host": host,
            "port": port
        };

        return;
    });

    return peersObj;

};

var get_users_list = function ()
{
    var list = new ASTGUI.customObject;
    var listArr = [];
    var USEROBJLIST =  parent.sessionData.pbxinfo.users;
    var userobj;
    var user = {};
    var value = "";
    //var res = ASTGUI.ASTDB.getAllKeys({ dbname: 'SIP' });
    var peersObj = get_sip_peers();

    parent.pbx.users.list().each(function(u){
        user = {};
        userobj = USEROBJLIST[u];
        user.fullname = userobj.fullname;

        /* get the technology */
        value = "";
        if (userobj.hassip == "yes")
        {
            value = "SIP"
        }

        if (userobj.hasiax == "yes")
        {
            if (value != "" )
            {
                value = value + "/";
            }
            value = value + "IAX";
        }

        if (userobj.dahdichan)
        {
            if (value != "" )
            {
                value = value + "/";
            }
            value = value + "FXS" + (Number(userobj.dahdichan) - Number(top.sessionData.FXS_PORTS_DETECTED[0]) + 1);
        }

        user.technology = value;

        if (peersObj.hasOwnProperty(u))
        {
            user.ipport = peersObj[u].host + ':' + peersObj[u].port;
            user.status = "Idle";
        }
        else
        {
            user.ipport = "";
            user.status = "Unavailable";
        }
        user.id = u;
        listArr.push(user);
        list[u] = new ASTGUI.customObject;
        list[u] = ASTGUI.toCustomObject(user);
    });
    table_list = list;
    var userBy = top.sessionData.userBy;
    var userSort = top.sessionData.userSort;
    if (userSort && userBy) {
        listArr = listArr.sort(ASTGUI.bySort(userBy, userSort));
    }
    else {
        listArr = listArr.sort(ASTGUI.bySort('id', "down"));
    }
    return listArr;
}

var ap_reboot = function (obj)
{
    var user = obj.id;
    var get_zeroconfig = function(res)
    {
        var buf = res.split("\r\n");
        if (!buf || !buf[0] || !buf[0].split("=") || buf[0].split("=")[1] != "1")
        {
            top.dialog.dialogConfirm({
                confirmStr: $P.lang("LANG828"),
                buttons: {
                    ok:  function (){
                        top.module.jumpMenu('zc_devices.html');
                        },
                    cancel: function (){top.dialog.clearDialog();}
                }
            });
        }
        else
        {
            function after(res)
            {
                top.dialog.clearDialog();
                var tmp = res.split("\r\n");

                if (tmp[1] == "REBOOT OK !")
                {
                    top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG829")});
                }
                else
                {
                    var num = tmp[1].lChop("ZCERROR_");
                    top.dialog.dialogMessage({ type: 'warning', content: $P.lang(zeroconfigErr[num])});
                } 
            };

            top.dialog.dialogConfirm({
                confirmStr: $P.lang("LANG834"),
                buttons: {
                    ok: function ()
                    {
                        //top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG829")});
                        $.ajax({ 
                            type: "GET", 
                            url: "/database.zccgi", 
                            data: "DoCgi=Reboot&ip=" + table_list[user].ipport + ";" + user + ";" + parent.sessionData.pbxinfo.users[user].secret, 
                            success: after
                        });
                    },
                    cancel: function ()
                    {
                        top.dialog.clearDialog();
                    }
                }
            });
        }
    }

    $.ajax({
        type: "GET",
        url: "/webcgi",
        data: "action=getparam&zero_config",
        success: get_zeroconfig
    });
}
