/*
 * Asterisk-GUI	- an Asterisk configuration interface
 *
 * voicemail.html functions
 *
 * Copyright (C) 2006-2008, Digium, Inc.
 *
 * Pari Nannapaneni <pari@digium.com>
 *
 * See http://www.asterisk.org for more information about
 * the Asterisk project. Please do not directly contact
 * any of the maintainers of this project for assistance;
 * the project provides a web site, mailing lists and IRC
 * channels for your use.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 */
 
/*
 * Description: UCM6100 WebGUI
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 * Modifications:
 * Set Max Messages Per user as 100
 * Support multiple languages of voicemail
 * 
 */
$P = top.$;

var TMP_VMEXTEN_TODELETE = '';
var TODELETE = '';
var OLD_DVD = '1,VoiceMail(${EXTEN:1}@default';
//var DVD = ',1,VoiceMail(${EXTEN:1}@default,s)' ; // direct voicemail dial


window.onload = function ()
{
    $P.lang(document, true);
    top.document.title = $P.lang("LANG584").format(top.model_info.model_name, $P.lang("LANG651"));
    $("title").attr("locale", "LANG651");
	if ($("#form").tooltip) {
		$("#form").tooltip();
	}
    $P("#form", document).validate({
        rules:{
            "maxgreet":{
                required:true,
                digits: true,
                range: [60, 600]  
            },
            "maxmsg":{
                required:true,
                digits: true,
                range: [10, 1000]  
            }
        }
    });
    var c = config2json({ filename: 'voicemail.conf', usf: 1 });
    if (!c.hasOwnProperty('general')) { return; }

    _$('maxgreet').value = (c.general.hasOwnProperty('maxgreet')) ? c.general.maxgreet : '';
    _$('operator').checked = (c.general.hasOwnProperty('operator') && c.general.operator == 'yes') ? true : false;
    _$('maxmsg').value = (c.general.hasOwnProperty('maxmsg')) ? c.general.maxmsg : '';
    var maxsecs = (c.general.hasOwnProperty('maxsecs')) ? c.general.maxsecs : '';
    ASTGUI.selectbox.selectOption_Add(_$('maxsecs'), maxsecs);
    var minsecs = (c.general.hasOwnProperty('minsecs')) ? c.general.minsecs : '';
    ASTGUI.selectbox.selectOption_Add(_$('minsecs'), minsecs);

    _$('saycid').checked = (c.general.hasOwnProperty('saycid') && c.general.saycid == 'yes') ? true : false;
    _$('sayduration').checked = (c.general.hasOwnProperty('sayduration') && c.general.sayduration == 'yes') ? true : false;
    _$('envelope').checked = (c.general.hasOwnProperty('envelope') && c.general.envelope == 'no') ? false : true;
    _$('review').checked = (c.general.hasOwnProperty('review') && c.general.review == 'yes') ? true : false;
    top.Custom.init(document);
}


var update = function ()
{
    if($P("#form", document).valid())
    {
        var x = new listOfActions();
        x.filename('voicemail.conf');
        x.new_action('update', 'general', 'maxgreet', _$('maxgreet').value);
        var tmp_operator = (_$('operator').checked) ? 'yes' : 'no';
        x.new_action('update', 'general', 'operator', tmp_operator);
        x.new_action('update', 'general', 'maxmsg', _$('maxmsg').value);
        x.new_action('update', 'general', 'maxsecs', _$('maxsecs').value);
        x.new_action('update', 'general', 'minsecs', _$('minsecs').value);

        var tmp_saycid = (_$('saycid').checked) ? 'yes' : 'no';
        x.new_action('update', 'general', 'saycid', tmp_saycid);
        var tmp_sayduration = (_$('sayduration').checked) ? 'yes' : 'no';
        x.new_action('update', 'general', 'sayduration', tmp_sayduration);
        if (tmp_sayduration.isAstTrue())
        {
            x.new_action('update', 'general', 'saydurationm', '0');
        }
        var tmp_envelope = (_$('envelope').checked) ? 'yes' : 'no';
        x.new_action('update', 'general', 'envelope', tmp_envelope);
        var tmp_review = (_$('review').checked) ? 'yes' : 'no';
        x.new_action('update', 'general', 'review', tmp_review);

        x.callActions(function ()
        {
            /* add by yjwu */
            top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG844"), callback: function () { window.location.reload(); } });
        });
    }
};
