/*
 * Asterisk-GUI	- an Asterisk configuration interface
 *
 * welcome2.html functions
 *
 * Copyright (C) 2006-2008, Digium, Inc.
 *
 * Ryan Brindley <rbrindley@digium.com
 *
 * See http://www.asterisk.org for more information about
 * the Asterisk project. Please do not directly contact
 * any of the maintainers of this project for assistance;
 * the project provides a web site, mailing lists and IRC
 * channels for your use.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 */
/*
 * Description: UCM6100 WebGUI
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 * Modifications:
 * Added support for multi-language
 * 
 */
$P = top.$;
var REGISTRY_OUTPUT = {};
var manager_events = {};
var manager_timers = {};
var extension_loads = { all: true, analog: false, features: false, iax: false, sip: false };
var mgr = {};
var loadTrunks = function() {
	EX_CF = config2json({filename:'extensions.conf', usf:0 });

	$('#trunks_list tr:not(:first)').remove();
	var TBL = _$('trunks_list');
	var addCell = ASTGUI.domActions.tr_addCell; // temporarily store the function
/* IAX and SIP Trunks */
	var t = parent.ASTGUI.cliCommand('iax2 show registry') ;
	REGISTRY_OUTPUT.iax2 = ASTGUI.parseCLIResponse(t) ;
	t = parent.ASTGUI.cliCommand('sip show registry') ;
	REGISTRY_OUTPUT.sip = ASTGUI.parseCLIResponse(t) ;
	var d = parent.pbx.trunks.list({sip: true, iax: true, analog: true});
    var type_conversion = {
        "sip": 'LANG108', //'SIP',
        "analog": 'LANG105', //'Analog',
        "iax": 'LANG107'  //'IAX'
    };
	d.each( function(item){
		var ttype = parent.pbx.trunks.getType(item);
		var newRow = TBL.insertRow(-1);
		newRow.className = ((TBL.rows.length)%2==1)?'odd':'even';


		var reg = ASTGUI.getTrunkStatus(REGISTRY_OUTPUT, item, ttype) ;
		addCell( newRow , { html: reg } );

		addCell( newRow , { html: parent.sessionData.pbxinfo.trunks[ttype][item]['trunkname'] } );
		addCell( newRow , { html: $P.lang(type_conversion[ttype]) || ttype, locale: type_conversion[ttype] } );
		if ( ttype == 'analog' )
		{
			addCell( newRow , { html: '' } );
			addCell( newRow , { html:'Ports ' + parent.sessionData.pbxinfo.trunks[ttype][item]['dahdichan'] } );
		} else {
			addCell( newRow , { html: parent.sessionData.pbxinfo.trunks[ttype][item]['username'] || '' } );
			addCell( newRow , { html: parent.sessionData.pbxinfo.trunks[ttype][item]['host'] } );
		}
	} );
    /* Providers */
    if (parent.sessionData.pbxinfo.trunks != undefined) {
        var d = parent.sessionData.pbxinfo.trunks.providers ;
        for(var e in d){ 
            if(d.hasOwnProperty(e)){
                var ttype = parent.pbx.trunks.getType(e);
                var newRow = TBL.insertRow(-1) ;
                newRow.className = ((TBL.rows.length)%2==1)?'odd':'even';
                var reg = ASTGUI.getTrunkStatus(REGISTRY_OUTPUT, e, ttype) ;
                addCell( newRow , { html: reg } );
                addCell( newRow , { html: d[e]['trunkname'] } );
                addCell( newRow , { html: ttype } );
                addCell( newRow , { html: d[e]['username'] || '' } );
                addCell( newRow , { html: d[e]['host'] } );
        }}    
    }

    /* End Providers */
    /* Digital Trunks */
    if (parent.sessionData.pbxinfo['trunks'] != undefined) {
        var c = parent.sessionData.pbxinfo['trunks']['pri'] ;
        for(var d in c){if(c.hasOwnProperty(d)){
            var newRow = TBL.insertRow(-1);
            newRow.className = ((TBL.rows.length)%2==1)?'odd':'even';
            addCell( newRow , { html:'' });
            addCell( newRow , { html: c[d]['trunkname'] });
            addCell( newRow , { html: 'Digital (' + c[d]['signalling'] + ')' }); // 
            var tmp_channels = c[d]['dahdichan'] || c[d]['zapchan'] || ' ' ;
            addCell( newRow , { html: 'Ports: ' + tmp_channels });
            addCell( newRow , { html:''} );
        }}
        var c = parent.sessionData.pbxinfo['trunks']['bri'] ;
        for(var d in c){if(c.hasOwnProperty(d)){
            var newRow = TBL.insertRow(-1);
            newRow.className = ((TBL.rows.length)%2==1)?'odd':'even';
            addCell( newRow , { html:'' });
            addCell( newRow , { html: c[d]['trunkname'] });
            addCell( newRow , { html: 'BRI' });
            addCell( newRow , { html: 'Ports: ' + c[d]['ports'] });
            addCell( newRow , { html:''} );
        }}
    }
    /* End Digital Trunks */
};
var addContentType = function(type, obj){
    if (obj) {
        var objLists = obj.getOwnProperties();
        objLists.each(function (index) {
            obj[index].contentType = type;
        }); 
        return obj;
    }
}
/* This is ugly because doing it the pretty way is unacceptably slow. */
var total, totalPage, userArr, extensionsLists, featuresLists, userEnd, 
    featuresEnd, ringgroupsEnd, voicemenusEnd, vmgroupsEnd;
var showNum = 15;
var isEnd = true;
var pbxinfo, users, ringgroups, voicemenus, vmgroups;
var exten_tbody = $("#extensions_list > tbody");
if (parent.sessionData && parent.sessionData.pbxinfo) {
    pbxinfo = parent.sessionData.pbxinfo;
    users = pbxinfo.users;
    ringgroups = pbxinfo.ringgroups;
    voicemenus = pbxinfo.voicemenus;
    vmgroups = pbxinfo.vmgroups;    
}
var contexts = ASTGUI.contexts;
users = addContentType("users", users);
ringgroups = addContentType("ringgroups", ringgroups);
voicemenus = addContentType("voicemenus", voicemenus);
vmgroups = addContentType("vmgroups", vmgroups);
var featuresObj = new ASTGUI.customObject;
featuresObj["appVmmain"] = { context: contexts.AppVmmain, label: 'LANG1253', contentType: 'Features' };
featuresObj["appDialvm"] = { context: contexts.AppDialvm, label: 'LANG1232', contentType: 'Features' };
featuresObj["appPickup"] = { context: contexts.AppPickup, label: 'LANG1218', contentType: 'Features' };
featuresObj["appPaging"] = { context: contexts.AppPaging, label: 'LANG1248', contentType: 'Features' };
featuresObj["appIntercom"] = { context: contexts.AppIntercom, label: 'LANG1246', contentType: 'Features' };
featuresObj["appAgentPause"] = { context: contexts.AppAgentPause, label: 'LANG1204', contentType: 'Features' };
featuresObj["appAgentUnpause"] = { context: contexts.AppAgentUnpause, label: 'LANG1206', contentType: 'Features' };
featuresObj['fcode_cfb_on' ] = { context: ASTGUI.contexts.AppCallForwardBusyOn, label: 'LANG1220', contentType: 'Features'};
featuresObj['fcode_cfb_off'] = { context:  ASTGUI.contexts.AppCallForwardBusyOff, label: 'LANG1222', contentType: 'Features'};
featuresObj['fcode_cfn_on' ] = { context: ASTGUI.contexts.AppCallForwardNoAnswerOn, label: 'LANG1224', contentType: 'Features'};
featuresObj['fcode_cfn_off'] = { context:  ASTGUI.contexts.AppCallForwardNoAnswerOff, label: 'LANG1226', contentType: 'Features'};
featuresObj['fcode_cfu_on' ] = { context: ASTGUI.contexts.AppCallForwardUnconditionOn, label: 'LANG1228', contentType: 'Features'};
featuresObj['fcode_cfu_off'] = { context:  ASTGUI.contexts.AppCallForwardUnconditionOff, label: 'LANG1230', contentType: 'Features'};
featuresObj['fcode_dnd_on' ] = { context: ASTGUI.contexts.AppDoNotDisturbOn, label: 'LANG1238', contentType: 'Features'};
featuresObj['fcode_dnd_off'] = { context:  ASTGUI.contexts.AppDoNotDisturbOff, label: 'LANG1240', contentType: 'Features'};
featuresObj['fcode_blacklist_add'] = { context:  ASTGUI.contexts.AppBlacklistAddWrap, label: 'LANG2282', contentType: 'Features'};
featuresObj['fcode_blacklist_remove'] = { context:  ASTGUI.contexts.AppBlacklistRemoveWrap, label: 'LANG2281', contentType: 'Features'};



var getExtensionsList = function() {
    if (users) {
        var usersLists = users.getOwnProperties();
        usersLists = usersLists.sortExtension();
        userEnd = usersLists.length;
    }
    if (featuresObj) {
        var ulFeatures = featuresObj.getOwnProperties();
        extensionsLists = usersLists.concat(ulFeatures);
        featuresEnd = extensionsLists.length;
    }
    if(ringgroups){
        var ulRinggroups = ringgroups.getOwnProperties();
        extensionsLists = extensionsLists.concat(ulRinggroups);
        featuresLists = ulFeatures.concat(ulRinggroups);
        ringgroupsEnd = extensionsLists.length;
    }
    if (voicemenus) {
        var ulVoiceMenu = voicemenus.getOwnProperties();
        extensionsLists = extensionsLists.concat(ulVoiceMenu);
        featuresLists =  featuresLists.concat(ulVoiceMenu);
        voicemenusEnd = extensionsLists.length;
    }
    if (vmgroups) {
        var ulVmgroups = vmgroups.getOwnProperties();
        extensionsLists = extensionsLists.concat(ulVmgroups);
        featuresLists = featuresLists.concat(ulVmgroups);
        vmgroupsEnd = extensionsLists.length;
    }
};
var loadExtensions = function (type, page)
{
    //var usersLists, ulFeatures, ulRinggroups, ulVoiceMenu, ulVmgroups; 
    /* List all User Extensions */
    var ulUser;
    var pageObj = jumpPage(type, page);
    if (type == "all") {
        ulUser = extensionsLists.slice(pageObj.pageList,pageObj.listsLen);
        if (!isEnd) {
           getExtensionsList(); //reget featuresEnd, ringgroupsEnd, voicemenusEnd and vmgroupsEnd param
           isEnd = true; 
        }
    }
    else if (type == "features") {
        ulUser = featuresLists.slice(pageObj.pageList,pageObj.listsLen);
        if (isEnd) {
            featuresEnd = featuresEnd - userEnd;
            ringgroupsEnd = ringgroupsEnd - userEnd;
            voicemenusEnd = voicemenusEnd - userEnd;
            vmgroupsEnd = vmgroupsEnd - userEnd;
            isEnd = false;
        }
    }
    ulUser.each(function (user) {
        // list each user in table
        if (pageObj.pageList < userEnd && users[user] && users[user].contentType == "users") {
            listUsers(user);
        }
        else if(pageObj.pageList < featuresEnd && featuresObj[user] && featuresObj[user].contentType == "Features"){
            listFeatureCode(user);
        }
        else if(pageObj.pageList < ringgroupsEnd && ringgroups[user] && ringgroups[user].contentType == "ringgroups"){
            listRingGroup(user);
        }
        else if(pageObj.pageList < voicemenusEnd && voicemenus[user] && voicemenus[user].contentType == "voicemenus"){
            listVoiceMenu(user);
        }
        else if(pageObj.pageList < vmgroupsEnd && vmgroups[user] && vmgroups[user].contentType == "vmgroups"){
            listVmgroups(user);
        }
        pageObj.pageList++; 
    });
    updateUserStatusIcon(ulUser);
    var uidx = -1;
    var id = setInterval(function (){
        updateUserStatus(ulUser[uidx++]);
        if (uidx >= ulUser.length){
            clearInterval(id);
        }
    }, 300);
    $("#extensions_list tbody tr:odd").removeClass("even").addClass("odd"); 	//removing classes to
    $("#extensions_list tbody tr:even").removeClass("odd").addClass("even"); //accuont for old js code
};
var listUsers = function(index) {
    var ud = users[index];
    var tmp_usertype_a = [];
    /* check to see if the extension has iax and sip */
    if (ud.getProperty('hassip').isAstTrue() && ud.getProperty('hasiax').isAstTrue()) {
        tmp_usertype_a.push('SIP/IAX User');
    } 
    else if (ud.getProperty('hasiax').isAstTrue()) {
        tmp_usertype_a.push('&nbsp;IAX User');
    } 
    else if (ud.getProperty('hassip').isAstTrue()) {
        tmp_usertype_a.push('&nbsp;SIP User');
    }
    /* check seperately if it has analog */
    if (ud.getProperty(top.sessionData.DahdiChannelString) !== '') {
        tmp_usertype_a.push('Analog User (FXS ' + ( ud[top.sessionData.DahdiChannelString] - top.sessionData.FXS_PORTS_DETECTED[0] + 1) + ')');
    }
    /*When display "No Dialplan assigned" when it doestn't contain any context, by vanevan*/
    //if( !ud.getProperty('context') || ! parent.sessionData.pbxinfo.callingPlans[ud.getProperty('context')] ){
    if (!ud.getProperty('context')) {
        var tmp_userstring = index + '<font color=red>*No DialPlan assigned</font>';
    } 
    else{
        var tmp_userstring = index;
    }
    var new_row = "<tr>\n";
    //new_row += "<td><img src=\"images/iframeRefresh.png\" border=\"0\" id=\"exten_status_" + index + "\"></td>\n";
    new_row += "<td><span class=\".refreshIcon\" id=\"exten_status_" + index + "\"></span></td>\n";
    new_row += "<td>" + tmp_userstring + "</td>\n";
    new_row += "<td>" + ud.getProperty('fullname') + "</td>\n";
    new_row += "<td class=\"exten_status\" id=\"exten_mailbox_" + index + "\" title=\"" + $P.lang('LANG2393') + "\" localeTitle=\"LANG2393\"></td>\n";
    new_row += "<td>" + tmp_usertype_a.join(',&nbsp;') + "</td>\n";
    $("#extensions_list > tbody").append(new_row + "</tr>");
}
// List feature codes
var listFeatureCode = function (index)
{
    if (pbxinfo['localextensions'] != undefined) {
        var extension;
        if (pbxinfo['localextensions'].hasOwnProperty(featuresObj[index].context)) {
            extension = pbxinfo['localextensions'][featuresObj[index].context];
        }
        var new_row = $('<tr></tr>').addClass('feature');
        $("<td></td>").html('').appendTo(new_row);
        $("<td></td>").html(extension || '--').appendTo(new_row);
        $("<td></td>").html('<b locale='+featuresObj[index].label+'>' + $P.lang(featuresObj[index].label) + '</b>').appendTo(new_row);
        $("<td></td>").html('').appendTo(new_row);
        $("<td></td>").html(featuresObj[index].contentType).appendTo(new_row);
        $("#extensions_list > tbody").append(new_row);
    }
};
// List all RingGroup Extensions
var listRingGroup = function(index){
    var new_row = $('<tr></tr>').addClass('feature');
    $("<td></td>").html('').appendTo(new_row);
    $("<td></td>").html(ringgroups[index]['extension'] || '--').appendTo(new_row);
    $("<td></td>").html(ringgroups[index]['NAME'] || ringgroups[index]['extension']).appendTo(new_row);
    $("<td class=\"exten_status\" id=\"exten_mailbox_" + ringgroups[index]['extension'] + "\" title=\"" + $P.lang('LANG2393') + "\" localTitle=\"LANG2393\"></td>").html('').appendTo(new_row);
    $("<td></td>").html($P.lang("LANG600")).attr("locale", "LANG600").appendTo(new_row);
    $("#extensions_list > tbody").append(new_row);
    var tmp_mails = ASTGUI.mailboxCount(ringgroups[index]['extension']);
    var buf = '<font color=#a6a6a6> Messages : </font>';
    if (tmp_mails.count_urg > 0) {
        buf += '<B><font color=#fdb900>' + tmp_mails.count_urg + '</font></B>/';
    }
    else{
        buf += tmp_mails.count_urg + '/';
    }

    if (tmp_mails.count_new > 0) {
        buf += '<B><font>' + tmp_mails.count_new + '</font></B>/';
    }
    else{
        buf += tmp_mails.count_new + '/';
    }

    if (tmp_mails.count_old > 0) {
        buf += '<B><font>' + tmp_mails.count_old + '</font></B>';
    } 
    else{
        buf += tmp_mails.count_old;
    }
    document.getElementById("exten_mailbox_" + ringgroups[index]['extension']).innerHTML = buf;       
}
// List all VoiceMenu Extensions
var listVoiceMenu = function(index){
    var new_row = $('<tr></tr>').addClass('feature');
    $("<td></td>").html('').appendTo(new_row);
    $("<td></td>").html(ASTGUI.parseContextLine.getExten(voicemenus[index].getProperty('alias_exten')) || '--').appendTo(new_row);
    $("<td></td>").html(voicemenus[index]['comment'] || index).appendTo(new_row);
    $("<td></td>").html('').appendTo(new_row);
    $("<td></td>").html($P.lang('LANG134')).attr("locale", "LANG134").appendTo(new_row);
    $("#extensions_list > tbody").append(new_row);
}
// VoiceMail Groups
var listVmgroups = function(index){
    var new_row = $('<tr></tr>').addClass('feature');
    $("<td></td>").html('').appendTo(new_row);
    $("<td></td>").html(index).appendTo(new_row);
    $("<td></td>").html(vmgroups[index].getProperty('label')).appendTo(new_row);
    $("<td></td>").html('').appendTo(new_row);
    $("<td></td>").html($P.lang("LANG89")).attr("locale", "LANG89").appendTo(new_row);
    $("#extensions_list > tbody").append(new_row);
}
var jumpPage = function(type, page){
    var nextPage = page + 1;
    var prevPage = page - 1;
    var optionsDiv = $(".pageOptions");
    var firstBtn =  optionsDiv.children().eq(0);
    var prevBtn =  optionsDiv.children().eq(1);
    var nextBtn =  optionsDiv.children().eq(2);
    var lastBtn =  optionsDiv.children().eq(3); 
    optionsDiv.attr("type", type);
    $("#extensions_list > tbody > :not(.list_titles)").remove();
    if (page == 1) {
        if (type == "all") {
            total = extensionsLists.length;
        }
        else if(type == "analog" || type == "iax" || type == "sip"){
            total = userArr.length
        }
        else if(type == "features"){
            total = featuresLists.length;
        }
        if (total == 0) {            
            $("#extensions_list > tfoot").hide();
        }
        else{
            $("#extensions_list > tfoot").show();
        }
        totalPage = Math.floor(total / showNum);
        if (totalPage != total / showNum) {
            totalPage = Math.floor(total / showNum) + 1;
        }
        firstBtn.addClass("disabled").attr("disabled", "disabled");
        prevBtn.addClass("disabled").attr("disabled", "disabled");
        nextBtn.removeClass("disabled").removeAttr("disabled", "disabled");
        lastBtn.removeClass("disabled").removeAttr("disabled", "disabled");
        if ( totalPage == 1 )
        {
            firstBtn.addClass("disabled").attr("disabled", "disabled");
            prevBtn.addClass("disabled").attr("disabled", "disabled");
            nextBtn.addClass("disabled").attr("disabled", "disabled");
            lastBtn.addClass("disabled").attr("disabled", "disabled");
        }
    }
    else if (page == totalPage) {
        firstBtn.removeClass("disabled").removeAttr("disabled", "disabled");
        prevBtn.removeClass("disabled").removeAttr("disabled", "disabled");
        nextBtn.addClass("disabled").attr("disabled", "disabled");
        lastBtn.addClass("disabled").attr("disabled", "disabled");
    }
    else{
        firstBtn.removeClass("disabled").removeAttr("disabled", "disabled");
        prevBtn.removeClass("disabled").removeAttr("disabled", "disabled");
        nextBtn.removeClass("disabled").removeAttr("disabled", "disabled");
        lastBtn.removeClass("disabled").removeAttr("disabled", "disabled");  
    }
    firstBtn.val(1);
    prevBtn.val(prevPage);
    nextBtn.val(nextPage);
    lastBtn.val(totalPage);
    $(".btn-paging").unbind("click");
    $(".jump").unbind("keydown");
    $(".btn-paging").bind("click", function(ev){
        var page = parseInt($(this).val());
        if (isNaN(page)) {
            page = parseInt($(".jump").val());
        }
        jumpToPage(page);                   
        ev.stopPropagation();
        return false;
    });
    var jumpToPage = function (page) {
        $('.jump').val('');
        if (page < 1 || page > totalPage || isNaN(page)) {
            $(".jump").blur();
            top.dialog.dialogMessage({
                type: 'warning',
                content: $P.lang("LANG929"),
                callback: function(){
                    $(".jump").focus();
                }
            })
            return;
        }
        $("#extensions_list .header_sort_down").removeClass("header_sort_down");
        $("#extensions_list .header_sort_up").removeClass("header_sort_up");
        if (type == "all" || type == "features") {
            loadExtensions(type, page);
        }
        else if (type == "analog" || type == "iax" || type == "sip") {
            loadUsers(type, page);
        } 
    }
    $(".jump").bind({
        mousedown: function(ev){
            if(ev.button==2){
                $(this).val($(this).val().replace(/\D|^0/g,''));
                ev.stopPropagation();
                return false;
            }
        },
        keydown: function(ev){
            if (ev.keyCode == 13)
            {
                var page = parseInt($(".jump").val());
                jumpToPage(page);
                ev.stopPropagation();
                return false;
            }
        },
        keyup: function(ev){      //keyup event
            $(this).val($(this).val().replace(/\D|^0/g,''));
            ev.stopPropagation();
            return false;
        },
        paste: function(ev){
            $(this).val($(this).val().replace(/\D|^0/g,''));
            ev.stopPropagation();
            return false;
        }   
    });
    $(".total").html(total);
    $(".current").html(page + "/" + totalPage);
    var pageList = (page - 1) * showNum;
    var listsLen = showNum + pageList;
    var pageObj = {pageList: pageList, listsLen: listsLen}; 
    return pageObj;
};

var updateUserStatusIcon = function (extenList) {
    var allUsers = top.pbx.users.list();
    //userList contains user extension only (remove feature code, etc. )
    var userList = $.makeArray( $(extenList).filter(allUsers) );
    var statusObj = ASTGUI.globals.extensionStateMap;

    if (userList.length !== 0)
    {
        var data = {
            action: "getbatchextenstate",
            extens: userList.join(",")
        }

        $.ajax({
            type: "GET",
            url: "/webcgi",
            async: true,
            data: data,
            success: function (data) {
                var users = eval(data);
                users.body.each(function (item) {
                    if (item) {
                        var exten = item.Exten;
                        var extenState = item.Status;
                        if (allUsers.contains(exten)) {
                            if (statusObj && statusObj[extenState]) {
                                $('#exten_status_' + exten)
                                    .removeClass()
                                    .addClass(statusObj[extenState])
                                    .attr({
                                        localeTitle: statusObj[extenState],
                                        title: $P.lang(statusObj[extenState])
                                    });
                            }
                        }
                    }
                });
            }
        });

    }

}

var updateUserStatus = function (user)
{ // list each user in table
    if (document.getElementById("exten_status_" + user))
    {
        //document.getElementById("exten_status_" + user).parentNode.innerHTML = ASTGUI.getUser_DeviceStatus_Image(user);
        var tmp_mails = ASTGUI.mailboxCount(user);
        var buf = '<font color=#a6a6a6 locale="LANG574">'+$P.lang("LANG574")+'</font> ';

        if (tmp_mails.count_urg > 0){
            buf += '<B><font color=#fdb900>' + tmp_mails.count_urg + '</font></B>/';
        }
        else{
            buf += tmp_mails.count_urg + '/';
        }

        if (tmp_mails.count_new > 0){
            buf += '<B><font>' + tmp_mails.count_new + '</font></B>/';
        }
        else{
            buf += tmp_mails.count_new + '/';
        }

        if (tmp_mails.count_old > 0)
        {
            buf += '<B><font>' + tmp_mails.count_old + '</font></B>';
        } 
        else{
            buf += tmp_mails.count_old;
        }
        document.getElementById("exten_mailbox_" + user).innerHTML = buf;
    }
};
// load analog iax sip 
var loadUsers = function(type, page){
    if (users) {
        var usersLists = users.getOwnProperties();
        usersLists = usersLists.sortExtension();
        /* check seperately if it has analog */
        if (page == 1) {
            userArr = new Array;
            usersLists.each(function (user) { 
                var ud = pbxinfo.users[user];
                var tmp_usertype_a = ud.extendsionType = new Array;
                /* check to see if the extension has iax and sip */
                if (type == "iax" && ud.getProperty('hasiax').isAstTrue()) {
                    if (ud.getProperty('hassip').isAstTrue() && ud.getProperty('hasiax').isAstTrue()) {
                        tmp_usertype_a.push('SIP/IAX User');
                    }
                    else{
                        tmp_usertype_a.push('&nbsp;IAX User');
                    }
                    userArr.push(user);
                } 
                if (type == "sip" && ud.getProperty('hassip').isAstTrue()) {
                    if (ud.getProperty('hassip').isAstTrue() && ud.getProperty('hasiax').isAstTrue()) {
                        tmp_usertype_a.push('SIP/IAX User');
                    }
                    else{
                        tmp_usertype_a.push('&nbsp;SIP User');
                    }
                    userArr.push(user);
                }
                /* check seperately if it has analog */
                if (type == "analog" && ud.getProperty(top.sessionData.DahdiChannelString) !== '') {
                    tmp_usertype_a.push('Analog User (FXS ' + ( ud[top.sessionData.DahdiChannelString] - top.sessionData.FXS_PORTS_DETECTED[0] + 1) + ')');
                    userArr.push(user);
                }
            });
        }
        var pageObj = jumpPage(type, page);
        var ulUser = userArr.slice(pageObj.pageList,pageObj.listsLen);
        ulUser.each(function (user) { 
            var ud = pbxinfo.users[user];
            var tmp_usertype_a = ud.extendsionType;
            if (!ud.getProperty('context')) {
                var tmp_userstring = user + '<font color=red locale="LANG575">'+$P.lang("LANG575")+'</font>';
            } 
            else{
                var tmp_userstring = user;
            }
            var new_row = "<tr>\n";
            //new_row += "<td><img src=\"images/iframeRefresh.png\" border=\"0\" id=\"exten_status_" + user + "\"></td>\n";
            new_row += "<td><span class=\".refreshIcon\" id=\"exten_status_" + user + "\"></span></td>\n";
            new_row += "<td>" + tmp_userstring + "</td>\n";
            new_row += "<td>" + ud.getProperty('fullname') + "</td>\n";
            new_row += "<td class=\"exten_status\" id=\"exten_mailbox_" + user + "\"></td>\n";
            new_row += "<td>" + tmp_usertype_a.join(',&nbsp;') + "</td>\n";
            $("#extensions_list > tbody").append(new_row + "</tr>");
        });
    }
    updateUserStatusIcon(ulUser);
    var uidx = -1;
    var id = setInterval(function (){
        updateUserStatus(ulUser[uidx++]);
        if (uidx >= ulUser.length){
            clearInterval(id);
        }
    }, 300);
    $("#extensions_list tbody tr:odd").removeClass("even").addClass("odd");     //removing classes to
    $("#extensions_list tbody tr:even").removeClass("odd").addClass("even"); //accuont for old js code
};

var loadQueues = function() {
	var queue_template = $('#queue_left_container > div.template');
	var queue_conts = {}; //queue containers array
	queue_conts[0] = $('#queue_left_container');
	queue_conts[1] = $('#queue_right_container');
	var cont_index = 0;

	$('.queue:not(.template)').remove();

	var queue_status = ASTGUI.cliCommand('queue show');
	queue_status = parent.ASTGUI.parseCLIResponse(queue_status);

	if (queue_status.contains('No queues.')) {
		return;
	}

	queue_status = queue_status.split('\n\n');
    var queueobj = new Object;
    var queueArr = new Array;
    var queue_statusNew = new Array;
    queue_status.each( function(q) { 
        q = q.trim();
        if (q.length == 0) {
            return;
        }
        lines = q.split('\n');
        var line_index = 0;
        var line = lines[line_index].split(' ');
        var q_name = line[0]; //6501
        queueArr.push(q_name);
        queueobj[q_name] = q;
    });
    queueArr = queueArr.sortExtension();
    for (var j = 0; j < queueArr.length; j++) {
        queue_statusNew.push(queueobj[queueArr[j]]);
    };
	queue_statusNew.each( function(q) { 
		if (q.length == 0) {
			return;
		}

		var queue = queue_template.clone();
		var agent_cnt = 0;
		var call_cnt = 0;
		lines = q.split('\n');
		var line_index = 0;

		//the following will always be the first line.
		//6501         has 0 calls (max unlimited) in 'ringall' strategy (0s holdtime), W:0, C:0, A:0, SL:0.0% within 0s
		var line = lines[line_index].split(' ');
		line_index++;
		var q_name = line[0]; //6501

		for (var i=0; i<line.length; i++) {
			if (line[i].contains('strategy')) {
				var strategy = line[i-1].replace(/'/g,'');
			} else if (line[i].contains('W:')) {
			} else if (line[i].contains('C:')) {
				var calls_completed = line[i].match('\\d\\d*').toString();
			} else if (line[i].contains('A:')) {
				var calls_abandoned = line[i].match('\\d\\d*').toString();
			} else if (line[i].contains('SL:')) {
				var service_level = line[i].concat(' ',line[i+1],' ',line[i+2]);
			}
		}

		if( !lines[line_index] ) lines[line_index] = '';
		//line #2 (index=1) will either be 'Members:' or 'No Members'
		if (lines[line_index].contains('Members:')) {
			line_index++;
			var agents = queue.contents().find('.agents');
			var agent_template = $('#agent_template');

			//traverse through all the members til the Callers line appears
			//Callers line will either be 'Callers:' or 'No Callers'
			while (!lines[line_index].contains('Callers')) {
				var agent = agent_template.clone();

                //ybiaozhou add dynamic agent case  begin
				//SIP/6000 (Busy) has taken no calls yet
                //Local/6020@from-internal/n (dynamic) (Not in use) has taken no calls yet No Callers

				line = lines[line_index].trim();
				//var a_exten = line.split(' ')[0].split('/')[1];   //display technology/
				var a_exten = line.split(' ')[0];

                //display FXS 1 instead of DAHDI/17
                if ( a_exten.beginsWith('DAHDI/') )
                {
                    var port = a_exten.split('/')[1] || '';
                    var idx = parent.sessionData.FXS_PORTS_DETECTED.indexOf(port) + 1;
                    a_exten = 'FXS ' + idx;
                }

                //	var a_status = line.match('[\\s\\w][\\s\\w]*(?=\\))').toString();
                var tmp_status = line.match(/[\s\w]+(?=\))/g) || [];
                var a_status = tmp_status[0] || '';
                if ( a_status == 'dynamic')
                {
                    a_status = tmp_status[1];
                    a_exten = a_exten.contains('@') ? a_exten.beforeChar('@') : a_exten;
                    a_exten = a_exten + '(*)';  //for representing dynamic
                }
                //ybiaozhou add dynamic agent case  end

				switch(a_status.toLowerCase()) {
					case 'ringing':
					case 'ring in use':
						var a_status_img = 'images/agent_ringing.png';
						agent_cnt++;
						break;
					case 'busy':
					case 'in use':
						var a_status_img = 'images/agent_busy.png';
						agent_cnt++;
						break;
					case 'available':
					case 'not in use':
						var a_status_img = 'images/agent_loggedin.png';
						agent_cnt++;
						break;
					default:
						var a_status_img = 'images/agent_loggedout.png';
						break;
				}

				agent.children('span.extension').html(a_exten);
				agent.children('img.status_icon').attr('src',a_status_img);

				agent.removeClass('template');
				agent.removeAttr('id');
				agent.addClass('agent_'+a_exten);
				agents.append(agent);

				line_index++;
			}
		} else if (lines[line_index].contains('No Members')) {
			queue.contents().find('.agents').html($P.lang("LANG2317").format($P.lang("LANG143"))).attr("locale", "LANG2317 LANG143");	
			line_index++;
		}

		//next line will either be 'Callers:' or 'No Callers'
		if (lines[line_index].contains('Callers:')) {
			line_index++;
			var calls = queue.contents().find('.calls > table > tbody');
			var call_template = $('<tr></tr>').addClass('call');

			//The remaining lines of the queue should be calls
			while ( lines[line_index] ) {
				call_cnt++;
				var call = call_template.clone();

				//      1. IAX2/6000-453 (wait: 0:03, prio: 0)
				line = lines[line_index].trim();
				var sections = line.split(' ');

				//'1.'
				var order = sections[0];
				
                var cid = '';
				////find '6000' in 'IAX2/6000-453'
				//var cid = sections[1].match('\\d\\d*(?=-\\d*)').toString();
                ////while DAHDI/9 override display from 9 to FXS 1
                //if ( sections[1].beginsWith('DAHDI/') )
                //{
                //    var idx = parent.sessionData.FXS_PORTS_DETECTED.indexOf(cid) + 1;
                //    cid = 'FXS ' + idx;
                //}

                var match = line.match(/CallerId\[([^\]]*)\]/);
                if (match)
                {
                    cid = match[1];
                }

                match = line.match(/CallerName\[([^\]]*)\]/);
                if (match)
                {
                    if (match[1] !== '<unknown>')
                    {
                        cid += ' ' + match[1];
                    }
                }
                

				for (var i=2; i<sections.length; i++) {
					if (sections[i].contains('wait')) {
						//'0:03'
						var waittime = sections[i+1].replace(/,/,'');

						var wt_tmp = waittime.split(':');
						var secs = (parseInt(wt_tmp[0], 10) * 60) + parseInt(wt_tmp[1], 10);
						if (secs > 120) {
							var call_class = 'old';
						} else if (secs > 30) {
							var call_class = 'average';
						} else {
							var call_class = 'new';
						}
						i++; //no need to check for the next section as we know its '0:03'
						continue;
					} else if (sections[i].contains('prio')) {
						//'0'
						var priority = sections[i+1].replace(/\)/,'');
						i++; //no need to check for the next section as we know its '0'
						continue;
					}
				}

				$('<td></td>').html(order).appendTo(call);
				$('<td></td>').html(cid).appendTo(call);
				$('<td></td>').html(waittime).addClass('count_html_up').appendTo(call);

				call.addClass(call_class);
				call.attr('id',''+q_name.toString()+'_call_'+cid.toString());
				calls.append(call);
				line_index++;
			}
		} else if (lines[line_index].contains('No Callers')) {
			queue.contents().find('.calls > table.list > tbody').html('<tr><td locale="LANG2317 LANG142">'+$P.lang("LANG2317").format($P.lang("LANG142"))+'</td></tr>');
			line_index++;
		}

		queue.contents().find('.name').html(q_name);
		queue.contents().find('.strategy').html(strategy);
		queue.contents().find('.users_agents').html(call_cnt + " calls, " + agent_cnt + " agents");
		queue.contents().find('.service_level').html(service_level);
		queue.contents().find('.calls_complete').html(calls_completed);
		queue.contents().find('.calls_abandoned').html(calls_abandoned);
		queue.removeClass('template');
		queue.attr('id','queue_'+q_name);
		queue_conts[cont_index].append(queue);
		cont_index = cont_index == 1 ? 0 : 1;
	});
};


var getConferenceUsers = function (confid) {
    var param = {
        "action": "getconferenceinfo",
        "conf-room": confid
    };

    $.ajax({
        type: "GET",
        url: ASTGUI.paths.rawman + '?action=getconferenceinfo&conf-room=' + confid,
       // async: false,
        dataType: "json",
        success: function (data, textStatus, jqXHR) {
            if (data.response && data.response === 'success')
            {
                var user_list = data.body.user_list;
                var len = user_list.length;
                for (i = 0; i < len; i++)
                {
                    var user = {};
                    user.cid = user_list[i].callerid_num;
                    user.duration = html2secs(user_list[i].activity_time);
                    //conf.users.push(user);
                    addMeetmeMember(confid, user.cid, user.duration);
                }
            }   
        }
    });
};

var loadConferenceRooms = function() {
	var conf_template = $('#sys_status_meetme > .body > div.template');
	var conf_body = $('#sys_status_meetme > .body');
    conf_body.empty();
    conf_body.append(conf_template);
	var active_conferences = {};

	var meetme_confs = ASTGUI.cliCommand('meetme list concise');
    //6301!2!0!00:07:34!0!0 -- obsolete
    //6300!1!0!Tue Nov 27 02:17:11 2012!00:00:46!0!0
	meetme_confs = parent.ASTGUI.parseCLIResponse(meetme_confs);
	var meetme_confs = meetme_confs.trim().split('\n');

	for (var i=0; i < meetme_confs.length; i++) {
        var meetme_conf =  meetme_confs[i].trim();
		if (meetme_conf.length == 0) {
			continue;
		}

        if (!meetme_conf.contains('!'))
        {
            continue;
        }
		meetme_conf = meetme_conf.split('!');
        var conf = {};
        conf.id = meetme_conf[0];
        conf.count = meetme_conf[1];
        conf.duration = html2secs(meetme_conf[4]);
        conf.users = new Array();
        active_conferences[conf.id] = conf;

    }

	var active_count = 0;
	var m = parent.sessionData.pbxinfo.conferences;
	for( l in m ) 
    { 
		if( !m.hasOwnProperty(l) || l =='admin') {
			continue;
		}

		var tmp = conf_template.clone();
		tmp.attr('id', 'conf_' + l.toString());
		tmp.appendTo(conf_body);
		var users_template = conf_template.contents().find('.members tr.template');

		tmp.removeClass("template");

		tmp.contents().find(".name").html(l);
		if ( active_conferences.hasOwnProperty(l) )
        {
			active_count++;
			//tmp.contents().find(".status").html(Number(active_conferences[l].count) + ' Users');
			tmp.contents().find(".status").html($P.lang('LANG2407').format( Number(active_conferences[l].count) ))
                .attr('locale', "LANG2407 '" + Number(active_conferences[l].count) + "'");
			tmp.contents().find(".time").addClass('count_html_up').html(secs2html(active_conferences[l].duration));
            getConferenceUsers(l);
		}
        else
        {
			tmp.contents().find(".status").html($P.lang("LANG141")).attr("locale", "LANG141");
			tmp.contents().find(".time").html("00:00");
			tmp.contents().find(".members > .list > tbody").empty().html("<tr><td colspan='4' locale='LANG2317 LANG1013'>"+$P.lang("LANG2317").format($P.lang("LANG1013"))+"</td></tr>");
			tmp.find('.minimaxi').html('[ + ]');
			tmp.find('.body').hide();
		}
	}
};

var loadInterfaceStatues = function() {
   var request = $.ajax({
   type: "GET",
   dataType: "json",
   async: true,
   url: "../webcgi?action=getSystemStatus&interface-sdcard=&interface-usbdisk=&"+
   "interface-network=&interface-dahdi=&interface-dahdi-status="
    });
    
    request.done(function(data)
    {
        if (data.body['interface-sdcard'] == "true") 
        {
            $('#sdcard_status').attr({
                "class": "sdcard_connected",
                "localeTitle": "LANG997",
                "title": $P.lang("LANG997")
            });
        } 
        else
        {
            $('#sdcard_status').attr({
                "class": "sdcard_disconnected",
                "localeTitle": "LANG998",
                "title": $P.lang("LANG998") 
            });
        }

        if (data.body['interface-usbdisk'] == "true") 
        {
            $('#usb_status').attr({
                "class": "usb_connected",
                "localeTitle": "LANG999",
                "title": $P.lang("LANG999")
                
            });
        } 
        else
        {
            $('#usb_status').attr({
                "class": "usb_disconnected",
                "localeTitle": "LANG1000", 
                "title": $P.lang("LANG1000")   
            });
        }

        if (data.body['interface-network'] != undefined) 
        {
            if ( data.body['interface-network'].LAN1 != undefined ) 
            {
                if ( data.body['interface-network'].LAN1 == "linked" ) 
                {
                    $('#lan1_status').attr({
                        "class": "net_connected",
                        "localeTitle": "LANG1003", 
                        "title": $P.lang("LANG1003")  
                    });
                } 
                else
                {
                    $('#lan1_status').attr({
                        "class": "net_disconnected",
                        "localeTitle": "LANG1004",
                        "title": $P.lang("LANG1004")   
                    });
                }
            }
            else
            {
                var children = $('#lan1').children();
    		 for(i=0; i<children.length;i++ )
    		 {
    		     $(children[i]).hide();
    		 }
                    $('#lan1').hide();
            }
            
            if ( data.body['interface-network'].LAN2 != undefined ) 
            {
                if ( data.body['interface-network'].LAN2 == "linked" ) 
                {
                    $('#lan2_status').attr({
                        "class": "net_connected",
                        "localeTitle": "LANG1003", 
                        "title": $P.lang("LANG1003")  
                    });
                } 
                else
                {
                    $('#lan2_status').attr({
                        "class": "net_disconnected",
                        "localeTitle": "LANG1004",
                        "title": $P.lang("LANG1004")   
                    });
                }
            }
            else
            {
                var children = $('#lan2').children();
    		 for(i=0; i<children.length;i++ )
    		 {
    		     $(children[i]).hide();
    		 }
                    $('#lan2').hide();
            }
            
            if ( data.body['interface-network'].WAN != undefined ) 
            {
                if ( data.body['interface-network'].WAN == "linked" ) 
                {
                    $('#wan_status').attr({
                        "class": "net_connected",
                        "localeTitle": "LANG1001", 
                        "title": $P.lang("LANG1001")  
                    });
                } 
                else
                {
                    $('#wan_status').attr({
                        "class": "net_disconnected",
                        "localeTitle": "LANG1002",
                        "title": $P.lang("LANG1002")   
                    });
                }
            } 
            else
            {
                var children = $('#wan').children();
                for(i=0; i<children.length;i++ )
    	     {
    	         $(children[i]).hide();
    	     }   
            }
        
            if ( data.body['interface-network'].LAN != undefined ) 
            {
                if ( data.body['interface-network'].LAN == "linked" ) 
                {
                    $('#lan_status').attr({
                        "class": "net_connected",
                        "localeTitle": "LANG1003", 
                        "title": $P.lang("LANG1003")  
                    });
                } 
                else
                {
                    $('#lan_status').attr({
                        "class": "net_disconnected",
                        "localeTitle": "LANG1004",
                        "title": $P.lang("LANG1004")   
                    });
                }
            } 
            else
            {
                var children = $('#lan').children();
    	     for(i=0; i<children.length;i++ )
    	     {
    	         $(children[i]).hide();
    	     }
                $('#lan').hide();
                $('#wan').hide();  /*Hide WAN too*/
            }
            
        }	
        
        if ( data.body['interface-dahdi'] != undefined ) 
        {
           /*Added FXS*//*Added FXO*/
           parseAndAddedPorts(data.body['interface-dahdi']);
        } 
        else
        {
           $('#fxo_status').remove();
           $('#fxs_status').remove();
        }
        
        if ( data.body['interface-dahdi-status'] != undefined ) 
        {
            /*parse port statues*/
            parsePortsStatues(data.body['interface-dahdi-status']);
        } 	
        $(".interface_ul").show();
    });
};

var parseAndAddedPorts = function(data) 
{
    var arr=data.split(',');
    var fxo_total=0;
    var fxs_total=0;
    
    var fxo_div = document.getElementById('fxo_status');
	 var ochildren = fxo_div.childNodes;
	 for(i=0; i<ochildren.length; )
	 {
	     fxo_div.removeChild(ochildren[i]);
	 }
    
    var fxs_div = document.getElementById('fxs_status');
	 var schildren = fxs_div.childNodes;
	 for(i=0; i<schildren.length; )
	 {
	     fxs_div.removeChild(schildren[i]);
	 }
    
    for ( i=0; i < arr.length; i++ )
    {
        if ( arr[i].indexOf("FXO") != -1 )
        {
            fxo_total++;
        }
        else if ( arr[i].indexOf("FXS") != -1 )
        {
            fxs_total++;
        }
    }
    
    if ( arr.length <= 6 )
    {
        /*GXE5120, 5121*/
        for ( i=0; i < arr.length; i++ )
        {
            if ( arr[i].indexOf("FXO") != -1 )
            {
                $('#fxo_status').append('<div class=updiv localeTitle="LANG996" title='+$P.lang("LANG996")+' id=port_'+ arr[i].match(/\d+$/) +'><span class=upindex>'+ arr[i].match(/\d+$/) +'</span></div>');
            }
            else if ( arr[i].indexOf("FXS") != -1 )
            {
                $('#fxs_status').append('<div class=updiv localeTitle="LANG996" title='+$P.lang("LANG996")+' id=port_'+ arr[i].match(/\d+$/) +'><span class=upindex>'+ (parseInt(arr[i].match(/\d+$/))-fxo_total).toString() +'</span></div>');
            }
        }
        var sub_width = 36;
        var sub_height = 29;
        document.getElementById('fxs_status').style.height=sub_height.toString()+"px";
        document.getElementById('fxs_status').style.width=(sub_width*fxs_total).toString()+"px";
        document.getElementById('fxo').style.height=sub_height.toString()+"px";
        $("#fxo > span").eq(0).css("top", "-10px");
        document.getElementById('fxo_status').style.height=document.getElementById('fxo').style.height;
        document.getElementById('fxo_status').style.width=(sub_width*fxo_total).toString()+"px";
        document.getElementById('interfaces_list').style.height="130px";
    }
    else
    {
        /*Others*/
        for ( i=0; i < arr.length; i++ )
        {
            if ( arr[i].indexOf("FXO") != -1 )
            {
                var index = arr[i].match(/\d+$/);
                if (index%2!=0)
                {
                    $('#fxo_status').append('<div class=updiv localeTitle="LANG996" title='+$P.lang("LANG996")+' id=port_'+ arr[i].match(/\d+$/) +'><span class=upindex>'+ arr[i].match(/\d+$/) +'</span></div>');
                }
            }
            else if ( arr[i].indexOf("FXS") != -1 )
            {
                $('#fxs_status').append('<div class=updiv localeTitle="LANG996" title='+$P.lang("LANG996")+' id=port_'+ arr[i].match(/\d+$/) +'><span class=upindex>'+ (parseInt(arr[i].match(/\d+$/))-fxo_total).toString() +'</span></div>');
            }
        }
        
        for ( i=0; i < arr.length; i++ )
        {
            if ( arr[i].indexOf("FXO") != -1 )
            {
                var index = arr[i].match(/\d+$/);
                if (index%2==0)
                {
                    $('#fxo_status').append('<div class=downdiv localeTitle="LANG996" title='+$P.lang("LANG996")+' id=port_'+ arr[i].match(/\d+$/) +'><span class=downindex>'+ arr[i].match(/\d+$/) +'</span></div>');
                }
            }
        }
        
        var sub_width = 36;
        var sub_height = 29;
        document.getElementById('fxs_status').style.height=sub_height.toString()+"px";
        document.getElementById('fxs_status').style.width=(sub_width*fxs_total).toString()+"px";
        document.getElementById('fxo').style.height=(2*sub_height).toString()+"px";
        $("#fxo > span").eq(0).css("top", "-20px");
        document.getElementById('fxo_status').style.height=document.getElementById('fxo').style.height;
        document.getElementById('fxo_status').style.width=(sub_width*fxo_total/2).toString()+"px";
        document.getElementById('interfaces_list').style.height="160px";
    }
    
}

var parsePortsStatues = function(data) 
{
    var arr=data.split('\n');
    var reversal = "";
    var need_r=false;
    if ( arr.length <=7 )
    {
        /*5102 or 5104*/
        need_r=false;
    }
    else
    {
        need_r=true;
    }
    
    for ( i=0; i < arr.length; i++ )
    {
        var sub_arr = arr[i].match(/\w+/g);
        if ( sub_arr == undefined || sub_arr.length < 4 )
        {
            continue;
        }
        var type = sub_arr[0];
        var port = sub_arr[1];
        var status = sub_arr[2];
        var connected = sub_arr[3];

        if ( type == "FXO" )
        {
            if ( need_r==true && (parseInt(port)%2) == 0 )
            {
                reversal = "_r";
            }
            else
            {
                reversal = "";
            }
            
            if ( connected != "1" )
            {
                /*Disconnected*/
                $('#port_'+port).attr({
                    "style": "background:url(../config/images/FXO_disconnected"+reversal+".png) center center no-repeat;",
                    "localeTitle": "LANG996",
                    "title": $P.lang("LANG996")
                });
            }
            else if ( status == "Unconfigured" )
            {
                /*Connected but unconfigure*/
                $('#port_'+port).attr({
                    "style": "background:url(../config/images/FXO_unconfigured"+reversal+".png) center center no-repeat;",
                    "localeTitle": "LANG1005",
                    "title": $P.lang("LANG1005")
                });
            }
            else if ( status == "Idle" )
            {
                /*Connected and Idle*/
                $('#port_'+port).attr({
                    "style": "background:url(../config/images/FXO_connected"+reversal+".png) center center no-repeat;",
                    "localeTitle": "LANG1006",
                    "title": $P.lang("LANG1006")
                });
            }
            else
            {
                /*Connected and in-used*/
                $('#port_'+port).attr({
                    "style": "background:url(../config/images/FXO_busy"+reversal+".png) center center no-repeat;",
                    "localeTitle": "LANG112",
                    "title": $P.lang("LANG112")
                });
            }
        }
        else if ( type == "FXS" )
        {
            if ( connected != "1" )
            {
                /*port is broken*/
                $('#port_'+port).attr({
                    "style": "background:url(../config/images/FXO_disconnected.png) center center no-repeat;",
                    "localeTitle": "LANG1007",
                    "title":$P.lang("LANG1007")
                });
            }
            else if ( status == "Unconfigured" )
            {
                /*Connected but unconfigure*/
                $('#port_'+port).attr({
                    "style": "background:url(../config/images/FXO_unconfigured.png) center center no-repeat;",
                    "localeTitle": "LANG1008",
                    "title": $P.lang("LANG1008")
                });
            }
            else if ( status == "Idle" )
            {
                /*Connected and Idle*/
                $('#port_'+port).attr({
                    "style": "background: url(../config/images/FXO_connected.png) center center no-repeat;",
                    "localeTitle": "LANG1006",
                    "title": $P.lang("LANG1006")
                });
            }
            else
            {
                /*Connected and in-used*/
                $('#port_'+port).attr({
                    "style": "background: url(../config/images/FXO_busy.png) center center no-repeat;",
                    "localeTitle": "LANG112",
                    "title": $P.lang("LANG112")
                });
            }
        }
    }    
}

var loadParkingLot = function() {
	var plot_tbody = $("#parking_lot_list > tbody");
	plot_tbody.empty();

	$.get( ASTGUI.paths.rawman, { action: 'ParkedCalls' }, function(op){
		var chunks = ASTGUI.miscFunctions.getChunksFromManagerOutput(op, 1);

		chunks.each( function( chunk ){
			if( !chunk.hasOwnProperty('Event') || !chunk.hasOwnProperty('Exten') ) {
				return;
			}
			var new_row = $('<tr></tr>').attr('id','plot_'+chunk.Exten.toString())
	
    
	//ybiaozhou chunk.CallerID changed to CallerIDNum ,CallerID field is not exists in the chunk.
    //$("<td></td>").html(chunk.CallerID).appendTo(new_row);
	        $("<td></td>").html(chunk.CallerIDNum).appendTo(new_row);
			$("<td></td>").html(chunk.Channel).appendTo(new_row);
			$("<td></td>").html(chunk.Exten).appendTo(new_row);
			$("<td></td>").html(chunk.Timeout).addClass('count_down').appendTo(new_row);

			new_row.appendTo(plot_tbody);
		});

		if( $("#parking_lot_list > tbody > tr").length == 0 ) {
			pushRow(plot_tbody, [
				$("<td></td>").attr({'colspan': '4', 'locale': 'LANG2317 LANG1012'})
                              .html($P.lang("LANG2317").format($P.lang("LANG1012")))
			]);
		}
        else
        {
            $('#parking_lot_list').trigger('update');
        }

	});
};

manager_events.watch = function() {
    /*do use waitevent action, by vanevan*/
	//$.get( ASTGUI.paths.rawman, {action:'waitevent'}, function(op){ manager_events.parseOutput(op); });
};

manager_events.parseOutput = function(op) {
	var events = op.toLowerCase();
	events = events.split('\r\n\r\n');

	try {
	for (var i=0; i<events.length; i++) {
		var event = events[i];
		if (event.contains('response: success')) {
			continue;
		} else if (event.contains('event: waiteventcomplete')) {
			continue;
		} else if (event.length == 0) {
			continue;
		}
		/* this is used for manager_events.parseEvent() which was
		 * decided to only be called in the cases that needed to
		 * have the event parsed. This is for efficiency reasons.
		 */
		var event_lines = event.split('\r\n');

		switch (event_lines[0].trim()) {
		case 'event: agentcallbacklogin':
			var eventObj = this.parseEvent(event_lines);
			this.updateAgent("callbacklogin", eventObj.agent, eventObj.loginchan);
			break;
		case 'event: agentcallbacklogoff':
			var eventObj = this.parseEvent(event_lines);
			this.updateAgent("callbacklogoff", eventObj.agent, eventObj.loginchan);
			break;
		case 'event: extensionstatus':
			var eventObj = this.parseEvent(event_lines);
			this.updateExtension(eventObj.exten.trim(), eventObj.context, eventObj['_status']);
			break;
		case 'event: hangup':
			var eventObj = this.parseEvent(event_lines);
			/* exten = 'Channel: Zap/2-1' or 'Channel: SIP/101-3f3f' */
			var exten = eventObj.channel.split('/')[1].split('-')[0];
			this.updateExtension(exten.trim(),'','hangup');
			break;
		case 'event: join':
			var eventObj = this.parseEvent(event_lines);
			/* exten = 'Channel: Zap/2-1' or 'Channel: SIP/101-3f3f' */
			var exten = eventObj.channel.split('/')[1].split('-')[0];
			this.addQueueCall(eventObj.queue, exten, eventObj.callerid, eventObj.position);
			break;
		case 'event: leave':
			var eventObj = this.parseEvent(event_lines);
			/* event_lines[2]= 'Channel: Zap/2-1' or 'Channel: SIP/101-3f3f' */
			var exten = eventObj.channel.split('/')[1].split('-')[0];
			this.removeQueueCall(eventObj.queue, exten);
			break;
		case 'event: meetmejoin':
			var eventObj = this.parseEvent(event_lines);
			/* event_lines[2]= 'Channel: Zap/2-1' or 'Channel: SIP/101-3f3f' */
			var chan = eventObj.channel.split('/')[1].split('-')[0];
			var usernum = event_lines[5].split(' ')[1];
			this.meetmeJoin(eventObj.meetme, eventObj.usernum, chan, 0);
			break;
		case 'event: meetmeleave':
			var eventObj = this.parseEvent(event_lines);
			/* event_lines[2]= 'Channel: Zap/2-1' or 'Channel: SIP/101-3f3f' */
			var chan = eventObj.channel.split('/')[1].split('-')[0];
			this.meetmeLeave(eventObj.meetme, eventObj.usernum, chan);
			break;
		case 'event: meetmetalking':
			var eventObj = this.parseEvent(event_lines);
			/* event_lines[2]= 'Channel: Zap/2-1' or 'Channel: SIP/101-3f3f' */
			var chan = eventObj.channel.split('/')[1].split('-')[0];
			state = eventObj['_status'].toString() == 'on' ? true : false;
			this.meetmeTalking(eventObj.meetme, chan, state);
			break;
		case 'event: newchannel':
			var eventObj = this.parseEvent(event_lines);
			/* event_lines[2]= 'Channel: Zap/2-1' or 'Channel: SIP/101-3f3f' */
			var exten = eventObj.channel.split('/')[1].split('-')[0];
			this.updateExtension(exten.trim(), '', eventObj[mgr.newchannel.channelstate]);
			break;
		case 'event: newstate':
			var eventObj = this.parseEvent(event_lines);
			/* event_lines[2]= 'Channel: Zap/2-1' or 'Channel: SIP/101-3f3f' */
			var exten = eventObj.channel.split('/')[1].split('-')[0];
			this.updateExtension(exten.trim(), '', eventObj[mgr.newstate.channelstate]);
			break;
		case 'event: parkedcall':
			var eventObj = this.parseEvent(event_lines);
			this.parkedCall(eventObj.exten, eventObj.channel, eventObj.from, eventObj,timeout, eventObj.callerid);
			break;
		case 'event: parkedcallgiveup':
		case 'event: parkedcalltimeout':
		case 'event: unparkedcall':
			var eventObj = this.parseEvent(event_lines);
			this.unparkedCall(eventObj.exten);
			break;
		case 'event: queuememberstatus':
			var eventObj = this.parseEvent(event_lines);
			var agent = eventObj.membername.split('/')[1];	//MemberName: 6000
			this.updateAgent('status_'+eventObj['_status'].toString(), agent, eventObj.queue);
			break;
		case 'event: agentcalled':
		case 'event: agentcomplete':
		case 'event: agentconnect':
		case 'event: agentdump':
		case 'event: agentlogin':
		case 'event: agentlogoff':
		case 'event: queuememberpaused':
		case 'event: dial':
		case 'event: musiconhold':
		case 'event: link':
		case 'event: messagewaiting':
		case 'event: newcallerid':
		case 'event: newexten':
		case 'event: rename':
		case 'event: setcdruserfield':
		case 'event: unlink':
		case 'event: alarm':
		case 'event: alarmclear':
		case 'event: dndstate':
		case 'event: logchannel':
		case 'event: peerstatus':
		case 'event: registry':
		case 'event: reload':
		case 'event: shutdown':
		case 'event: userevent':
			break;
		default:
			//console.log(event[3]);
			break;
		}
	}
	} catch (err) {
		top.log.error('Error Parsing waitevent response : manager_events.parseOutput() ');
		throw(err);
	}
	this.watch();
};

manager_events.updateAgent = function(event, agent, loginchan) {
	/* The agent can belong to multiple queues, below will gather all of its locations*/
	var agent_locs = $('#sys_status_queues .agent_'+agent.toString());

	switch(event) {
	case 'callbacklogin':
		agent_locs.children('.status_icon').attr('src','images/agent_loggedin.png');
		break;
	case 'callbacklogoff':
		agent_locs.children('.status_icon').attr('src','images/agent_loggedout.png');
		break;
	case 'status_0': /* Unknown */
		agent_locs.children('.status_icon').attr('src','images/agent_loggedout.png');
		break;
	case 'status_1': /* Not In Use */
		agent_locs.children('.status_icon').attr('src','images/agent_loggedin.png');
		break;
	case 'status_2': /* In Use */
	case 'status_3': /* Busy */
		agent_locs.children('.status_icon').attr('src','images/agent_busy.png');
		break;
	case 'status_4': /* Invalid */
		agent_locs.children('.status_icon').attr('src','images/agent_loggedout.png');
		break;
	case 'status_5': /* Not Available (Disconnected) */
		agent_locs.children('.status_icon').attr('src','images/agent_loggedout.png');
		break;
	case 'status_6': /* Ringing */
		agent_locs.children('.status_icon').attr('src','images/agent_ringing.png');
		break;
	case 'status_7': /* Ring In Use */
		agent_locs.children('.status_icon').attr('src','images/agent_ringing.png');
		break;
	case 'status_8': /* On Hold */
		agent_locs.children('.status_icon').attr('src','images/agent_busy.png');
		break;
	default:
		alert('updateAgent: '+event.toString());
		break;
	}

	agent_locs.parents('.queue').find('.users_agents').each( function() {
		var agents = $(this).parents('.queue').find(".status_icon[src!='images/agent_loggedout.png']").length - 1 /* template */;
		this.innerHTML = this.innerHTML.replace(/[0-9][0-9]*(?= agents)/,agents);
	});
};

manager_events.addQueueCall = function (queue, exten, cid, position) {
	var calls_tbody = $('#queue_'+queue.toString()+' .calls > .list > tbody');
	var new_row = $('<tr></tr>').attr('id',''+queue.toString()+'_call_'+exten.toString()).addClass('call').addClass('new');

	if (position == 1) {
		calls_tbody.empty();
	}

	$("<td></td>").html(position).appendTo(new_row);
	$("<td></td>").html(cid).appendTo(new_row);
	$("<td></td>").html('0:00').addClass('count_html_up').appendTo(new_row);

	calls_tbody.append(new_row);

	var calls = calls_tbody.children('tr').length;
	var innerHTML = $('#queue_'+queue.toString()+' .users_agents').html();
	$('#queue_'+queue.toString()+' .users_agents').html(innerHTML.replace(/[0-9][0-9]*(?= calls,)/,calls));
};

manager_events.removeQueueCall = function (queue, exten) {
	var calls_tbody = $('#queue_'+queue.toString()+' .calls > .list > tbody');
	var calls;
	var call_cnt = 1;

	$('#'+queue.toString()+'_call_'+exten.toString()).remove();

	calls_tbody.children('tr').each( function() {
		$(this).children('td:first').html(call_cnt+'. ');
		call_cnt++;
	}); 

	if ( (calls = calls_tbody.children('tr').length) == 0) {
		calls_tbody.append(
			$('<tr></tr>').append(
				$('<td></td>').attr({'colspan': '3', 'locale': 'LANG2317 LANG142'})
                              .html($P.lang("LANG2317").format($P.lang("LANG142")))
			)
		);
	}

	var innerHTML = $('#queue_'+queue.toString()+' .users_agents').html();
	$('#queue_'+queue.toString()+' .users_agents').html(innerHTML.replace(/[0-9][0-9]*(?= calls,)/,calls));
};

manager_events.updateExtension = function(exten, context, state) {
	var exten_status_img = $('#exten_status_'+exten.toString()+' img');
	if (typeof state == 'undefined') {
		state = "Unknown";
	}
	switch(state.toString()) {
	case '-1':	/* Invalid */
		var state = 'Invalid';
		exten_status_img.attr('src','images/status_gray.png');
		break;
	case '0':	/* Not In Use */
		var state = 'Not In Use';
		exten_status_img.attr('src','images/status_green.png');
		break;
	case '1':	/* In Use */
		var state = 'In Use';
		exten_status_img.attr('src','images/status_orange.png');
		break;
	case '2':	/* Busy */
	case 'busy':	/* Busy */
		var state = 'Busy';
		exten_status_img.attr('src','images/status_orange.png');
		break;
	case '4':	/* Unavailable */
		var state = 'Unavailable';
		exten_status_img.attr('src','images/status_gray.png');
		break;
	case '8':	/* Ringing */
	case 'ringing':	/* Ringing */
		var state = 'Ringing';
		exten_status_img.attr('src','images/status_blue.png');
		break;
	case '9':	/* Ringing In Use */
		var state = 'Ringing In Use';
		exten_status_img.attr('src','images/status_blue.png');
		break;
	case '16':	/* On Hold */
		var state = 'On Hold';
		exten_status_img.attr('src','images/status_orange.png');
		break;
	case 'dialing':	/* Dialing */
		//var state = 'Dialing';
		//exten_status_img.attr('src','images/status_orange.png');
		break;
	case 'down':	/* Down */
		var state = 'Available';
		exten_status_img.attr('src','images/status_green.png');
		break;
	case 'hangup':
		var state = 'Hangup';
		exten_status_img.attr('src','images/status_green.png');
		break;
	case 'ring':	/* Line is ringing */
		var state = 'Ring';
		exten_status_img.attr('src','images/status_orange.png');
		break;
	case 'rsrvd':	/* Reserved */
		var state = 'Reserved';
		exten_status_img.attr('src','images/status_orange.png');
		break;
	case 'up':	/* Up */
		var state = 'Up';
		exten_status_img.attr('src','images/status_orange.png');
		break;
	default:
		top.log.debug("updateExtension :: We have encountered an unknown extension state of " + state.toString());
		var state = 'Unknown';
		exten_status_img.attr('src','images/status_gray.png');
		break;
	}

	exten_status_img.parent().siblings('.exten_status').html(state);
	$('#extensions_list').trigger('update');
};

manager_events.parkedCall = function(exten, chan, from, timeout, cid) {
	var plot_tbody = $('#parking_lot_list > tbody');

	if (plot_tbody.children('tr').length == 1 && plot_tbody.contents('tr > td:first').html().contains($P.lang("LANG2317").format($P.lang("LANG1012")))) {
		/* If plot_tbody only has 1 row and it contains 'No Parked Calls' then empty tbody */
		plot_tbody.empty();
	}

	var new_row = $('<tr></tr>').attr('id','plot_'+exten.toString());

	$('<td></td>').html(cid).appendTo(new_row);
	$('<td></td>').html(chan).appendTo(new_row);
	$('<td></td>').html(exten).appendTo(new_row);
	$('<td></td>').html(timeout).addClass('count_down').appendTo(new_row);

	plot_tbody.append(new_row);
};

manager_events.unparkedCall = function(exten) {
	var plot_tbody = $('#parking_lot_list > tbody');

	$('#plot_'+exten.toString()).remove();

	if (plot_tbody.children('tr').length == 0) {
		plot_tbody.append(
			$('<tr></tr>').append(
				$('<td></td>').attr({'colspan': '4', 'locale': 'LANG2317 LANG1012'})
                              .html($P.lang("LANG2317").format($P.lang("LANG1012")))
			)
		);
	}
};

manager_events.meetmeJoin = function (meetme, user_num, chan) {
	var conf = $('#conf_'+meetme.toString()+' .members > .list > tbody');
	if (conf.find('tr:first > td:first').html() == $P.lang("LANG2317").format($P.lang("LANG1013"))) {
		conf.empty();
		conf = $('#conf_'+meetme.toString());
		conf.find('.status').html('1 User');
		conf.find('.time').addClass('count_html_up').html('00:00');
		conf.find('.body').show();
		conf.find('.minimaxi').html('[ - ]');
	} else {
		conf = $('#conf_'+meetme.toString());
		var status = conf.contents().find('.status').html();
		status = status.split(' ')[0];
		status = parseInt(status, 10)+1;
		conf.find('.status').html(status+' Users');
	}

	addMeetmeMember(meetme, chan, 0);
};

manager_events.meetmeLeave = function (meetme, user_num, chan) {
	$('#'+meetme.toString()+'_'+chan.toString()).remove();
	
	var conf = $('#conf_'+meetme.toString()+' .members > .list > tbody');
	if (conf.children('tr').length == 0 ) {
		conf = $('#conf_'+meetme.toString());
		conf.find(".status").html($P.lang("LANG141")).attr("locale", "LANG141");
		conf.find(".time").removeClass('count_html_up').html("00:00");
		conf.find(".members > .list > tbody").empty().html("<tr><td colspan='4' locale='LANG2317 LANG1013'>"+$P.lang("LANG2317").format($P.lang("LANG1013"))+"</td></tr>");
		conf.find('.body').hide();
		conf.find('.minimaxi').html('[ + ]');
	} else {
		conf = $('#conf_'+meetme.toString());
		var status = conf.contents().find('.status').html();
		status = status.split(' ')[0];
		status = parseInt(status, 10)-1;
		conf.find('.status').html(status+' Users');
	}
};

manager_events.meetmeTalking = function(meetme, exten, is_talking) {
	var user_stat;
	if ( user_stat = $('#'+meetme.toString()+'_'+exten.toString()+' .mem_status') ) {
		user_stat.html( is_talking ? 'Talking' : 'Active' );
	}
};

manager_events.parseEvent = function(event_lines) {
	var eventObj = new Object();
	
	for (var i=0; i<event_lines.length; i++) {
		var line = event_lines[i];
		line = line.split(': ');
		/* 'status' is a reserved term in javascript....dangit */
		line[0] = (line[0] === 'status') ? '_status' : line[0];
		eventObj[line[0]] = line[1];
	}

	return eventObj;
};

//abstracted out because its called in manager_events.meetmeJoin & loadConferences
var addMeetmeMember = function(meetme, user_num, duration) {
	//set duration's default value
	duration = typeof(duration) != 'undefined' ? duration : 0;

	var conf = $('#conf_'+meetme.toString()+' .members > .list > tbody');

	var new_row = $('#sys_status_meetme > .body > div.template .members tr.template').clone();
	new_row.children('.extension').html(user_num);
	new_row.children('.duration').addClass('count_html_up').html(secs2html(duration));
	//new_row.children('.mem_status').html('Active');

	new_row.removeClass('template');
	new_row.attr('id',meetme.toString()+'_'+user_num);
	conf.append(new_row);
};

var countHtml = function() {
	$('.count_html_up').each( function(i) {
		var old_time = this.innerHTML;
		var old_time_secs = html2secs(old_time.toString());

		var new_time = 1+old_time_secs;
		var new_time_html = secs2html(new_time);

		this.innerHTML = new_time_html;
	});

	$('.count_html_down').each( function(i) {
		var old_time = this.innerHTML;
		old_time = html2secs(old_time.toString());

		var new_time = parseInt(old_time, 10)-1;
        new_time = (new_time < 0) ? new_time : 0;
		new_time = secs2html(new_time);

		this.innerHTML = new_time;
	});

	setTimeout(arguments.callee,1000);
};

var countSecs = function() {
	$('.count_up').each( function(i) {
		this.innerHTML = parseInt(this.innerHTML, 10)+1;
	});

	$('.count_down').each( function(i) {
        var new_time = parseInt(this.innerHTML, 10)-1;
		this.innerHTML = (new_time > 0) ? new_time : 0;
	});

	setTimeout(arguments.callee,1000);
};

var html2secs = function(html) {
	html = html.trim().split(':');

	if (html.length == 3) {
		return (parseInt(html[0], 10) * 60*60) + (parseInt(html[1], 10) * 60) + parseInt(html[2], 10);
	} else if (html[0].toString() != '0' && html[0].toString() != '00') {
		return ((parseInt(html[0], 10)*60)+parseInt(html[1], 10));
	} else {
		return parseInt(html[1], 10);
	}
};

var secs2html = function(secs) {
	var tmp = secs;
	var mins = Math.floor(secs/60);
	var hrs = Math.floor(mins/60);
	mins = mins % 60;
	secs = secs % 60;
	if (hrs != 0) {
		return ''+hrs.toString()+':'+mins.toString()+':'+secs.addZero();
	} else {
		return ''+mins.toString()+':'+secs.addZero();
	}
};

var pushRow = function(tbody, cells) {
	var new_row = $("<tr></tr>");
	for (var i=0; i < cells.length; i++) {
		cells[i].appendTo(new_row);
	}
	new_row.appendTo(tbody);
};
