/*
 * Description: UCM6100 WebGUI
 * Copyright (C) 2013 Grandstream Networks, Inc.
 *
 * This project extends Asterisk GUI project and contains Grandstream Network's
 * implementation which uses Asterisk GUI.
 *
 * Asterisk and Asterisk GUI are registered trademarks of Digium, Inc. 
 * Please see http://www.asterisk.org for more information about the Asterisk 
 * project.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 * Modifications:
 * Added support for Zeroconfig
 * Added for devices manager
 * 
 */
$P = parent.$;
var mWindow = window;
var isNewDEVICE;
var devicelist = new Array();
var modelinfo = new Array();
var assigned_accts = new Object();
var unassigned_accts = new Array();
var selectedRecord = -1;
var selectExt_prefix = "select-ext_";
var check_mac = function()
{
    var res = true;
    if ( isNewDEVICE )
    {
          var list = mWindow.$('.device_mac');
          for (i = 0; i <list.length; i++)
          {
              var tmp = list.eq(i).html();

              if (tmp.toUpperCase() == _$('new_mac').value.toUpperCase())
              {
                  res = false ;
                  break;
              }
          }
    }
    return res;
}

var showProvWindow =  function(item, mac)
{
    function after(res)
    {
        top.dialog.clearDialog();
        var tmp = res.split("\r\n");

        if (tmp[1] == "SUCCESS")
        {
            top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG829")});
        }
        else
        {
            var num = tmp[1].lChop("ZCERROR_");
            top.dialog.dialogMessage({ type: 'warning', content: "Wrong!"});
        } 
    };

    top.dialog.dialogConfirm({
        confirmStr: $P.lang("LANG834"),
        buttons: {
            ok: function ()
            {
                //top.dialog.dialogMessage({ type: 'loading', content: $P.lang("LANG829")});
                $.ajax({ 
                    type: "GET", 
                    url: "/database.zccgi", 
                    data: "DoCgi=DownloadCfg&mac=" + mac, 
                    success: after
                });
            },
            cancel: function ()
            {
                top.dialog.clearDialog();
            }
        }
    });
}

window.onload = function ()
{
    $P.lang(document, true);
    var mode = gup("mode");
    var item = gup("item");
    if (mode)
    {
        mWindow = top.window.frames["mainscreen"]; // this will be the main window 
        initialize_formFields();
        
        if (mode === "add")
        {
            prepareAddItemForm();
            $("#editForm").show();
        }
        else if (mode === "edit")
        {
            prepareEditItemForm(mWindow.selectedRecord);
            $("#editForm").show();
        }
        init_validator();
        top.Custom.init(document);
        return false;
    }
    else
    {
        load_model_info();
        local_devices();
        load_assigned_accounts();        
    }
};
var init_validator = function () {
	if ($("#form").tooltip) {
		$("#form").tooltip();
	}
    $P("#form", document).validate({
        rules:{ 
            "new_mac": {
                required: true,
                mac: true,
                customCallback: [ $P.lang("LANG2134"), check_mac]
            },
            "edit_ip": {
                ipDns: ["ip"]  
            }
        },
        submitHandler: function() {
            SAVE_DEVICE_FORM();
        }
    });
}
var local_devices = function ()
{
    $.ajax({
        type: "GET",
        url: "/database.zccgi",
        data: "DoCgi=DeviceLoad",
        success: set_devicelist
    });
};

var load_model_info = function ()
{
     $.ajax({
        type: "GET",
        url: "/database.zccgi",
        data: "DoCgi=ModelLoad",
        success: set_modelinfo
     });
}

var load_assigned_accounts = function ()
{
    $.ajax({
        type: "GET",
        url: "/database.zccgi",
        data: "DoCgi=MemberLoad",
        success: set_assignedacct
     });
}

var initialize_formFields = function ()
{ // initialize_formFields();
    /*
    var current_acct = "";
    if( mWindow.selectedRecord > -1 )
        current_acct = mWindow.devicelist[mWindow.selectedRecord].split('&')[2];
    */
    
    var us = parent.pbx.users.list();    
    mWindow.unassigned_accts = undefined;
    mWindow.unassigned_accts = [];
  
    us = jQuery.grep(us, function(user) {
        return ( parent.sessionData.pbxinfo.users[user]['hassip'] || parent.sessionData.pbxinfo.users[user]['hasiax'] );
    }); 
    
    mWindow.unassigned_accts = jQuery.grep(us, function(user) {
        var matched = false;
        $.each(mWindow.assigned_accts, function(index, value) {
            for( var j = 0; j < value.length; j++ )
            {
                if(value[j].extension == user)
                {
                    matched = true;
                    return false;
                }
            }
        });
        
        return !matched;
    });
    
    //console.log(mWindow.unassigned_accts);
    /*
    ASTGUI.selectbox.append('edit_account', $P.lang('LANG133'), '');
    us.each(function (user)
    {
        if (parent.sessionData.pbxinfo.users[user]['hassip'] || parent.sessionData.pbxinfo.users[user]['hasiax'])
        {
            if(mWindow.assigned_accts.indexOf(user) == -1 || user == current_acct )
                ASTGUI.selectbox.append('edit_account', user, user);
        }
    });    
    */
      
       
};


//convert ip address format to integer
var ipDot2Num = function (dot) 
{
    var d = dot.split('.');
    return ((((((+d[0])*256)+(+d[1]))*256)+(+d[2]))*256)+(+d[3]);
};


function set_devicelist(res)
{
    if (res)
        devicelist = res.split("\r\n");
    else
        devicelist = [];

    var filter = gup("filter");

    filter = (filter ? filter : "all");
    _$('filter').value = filter;
    load_devices_table(filter);

    sortTable({
        "tableId": 'table_deviceslist'
    }).bindTitles( 
        {   // No.
            idx: 1,
            sortFunc: function (prev, cur) {
                var numPrev = parseInt(prev[0].beforeStr(' .'));
                var numCur = parseInt(cur[0].beforeStr(' .'));
                return numPrev - numCur;
            }
        },
        { idx: 2, isDis: true}, 
        {   // IP
            idx: 3,
            sortFunc: function (prev, cur) {
                var numPrev = ipDot2Num(prev[0]);
                var numCur = ipDot2Num(cur[0]);
                return numPrev - numCur;
            }
        }, 
        { idx: 5 }, { idx: 6 }, { idx: 7 }, 
        { idx: 8 }, { idx: 9 } 
    );
}

function set_modelinfo(res)
{
    var res_arr = [];
    
    if(res)
        res_arr = res.split("\r\n");
    $.each(res_arr, function(index, value) {
        var modelinfo_arr = value.split('&');
        if(modelinfo_arr.length == 2 && modelinfo_arr[0].length > 0 && modelinfo_arr[1].length > 0)  //model and acct number;
        {
            modelinfo[modelinfo_arr[0]] = parseInt(modelinfo_arr[1]);
        }
    });   
}

function set_assignedacct(res)
{
    var res_arr = [];
    if(res)
        res_arr = res.split("\r\n");
    //(res_arr.length > 0)
    assigned_accts = undefined;
    assigned_accts = new Object();
    
    $.each(res_arr, function(index, value) {
        var acctinfo_arr = value.split('&');        
        if(acctinfo_arr.length > 3)     
        {
            var mac = acctinfo_arr[0];
            var ip = acctinfo_arr[1];
            var ext = acctinfo_arr[2];
            var idx = acctinfo_arr[3];
            if(!assigned_accts.hasOwnProperty(mac+ip))
            {
                assigned_accts[mac+ip] = [];                
            }
            assigned_accts[mac+ip].push({ index: parseInt(idx), extension: ext});        
                
            
        }
    });
    
}

function get_ext_strings(mac, ip)
{
    if(typeof assigned_accts[mac+ip] == "undefined")
        return "";
        
    var ext_strings = "";
    if(assigned_accts[mac+ip].length == 1)
    {
        ext_strings = $P.lang("LANG1422") + " " + assigned_accts[mac+ip][0].index + "-" + assigned_accts[mac+ip][0].extension;
    }
    else
    {
        for(var i = 0; i < assigned_accts[mac+ip].length; i++ )
        {
            if(assigned_accts[mac+ip][i].index && assigned_accts[mac+ip][i].extension)
            {
                ext_strings = ext_strings + "<option>" + $P.lang("LANG1422") + " " + assigned_accts[mac+ip][i].index + "-" + 
                              assigned_accts[mac+ip][i].extension + "</option>";
            }
        }
        ext_strings = "<div class='acct_ext_list'><select size='1'>" + ext_strings + "</select></div>";
    }
    return ext_strings;
}

function set_filter(value)
{
    ASTGUI.domActions.clear_table(_$('table_deviceslist'));
    load_devices_table(value);
}

function load_devices_table(filter)
{
    var TBL = _$('table_deviceslist');
    var addCell = ASTGUI.domActions.tr_addCell; // temporarily store the function

    if (devicelist.length < 3)
    {
        ASTGUI.domActions.clear_table(TBL);
        var newRow = TBL.insertRow(-1);
        newRow.className = 'even';
        addCell(newRow, { html: $P.lang("LANG129").format($P.lang("LANG1287")), locale: "LANG129 LANG1287"});
        return;
    }
    (function ()
    { // add first row
        var CA = document.createElement('input'); CA.type = 'checkbox'; CA.id = 'CHECKALL';
        ASTGUI.events.add(CA, 'click', function ()
        {
            if (_$('CHECKALL').checked)
            {
                ASTGUI.domActions.CheckAll('selected_extensions');
                $(".selected_extensions").prev().css("backgroundPosition", "0px -50px");
            } else
            {
                ASTGUI.domActions.unCheckAll('selected_extensions');
                $(".selected_extensions").prev().css("backgroundPosition", "0px 0px");
            }
        });
        $(".selected_extensions").live("click", function(ev){
            if ($(".selected_extensions").filter(":checked").length != $(".selected_extensions").length) {
                $("#CHECKALL").removeAttr("checked");
                $("#CHECKALL").prev().css("backgroundPosition", "0px 0px");
            }
            else {
                $("#CHECKALL").attr("checked", "checked");
                $("#CHECKALL").prev().css("backgroundPosition", "0px -50px");
            }
            ev.stopPropagation();
        });
        var newRow = TBL.insertRow(-1);
        newRow.className = "frow";

        var newcell = newRow.insertCell(newRow.cells.length);
        newcell.width = '15px';
        newcell.appendChild(CA);

        addCell(newRow, { html: 'No.' });
        addCell(newRow, { html:  "<span locale='LANG1293'>"+$P.lang('LANG1293')+"</span>"});
        addCell(newRow, { html:  "<span locale='LANG1291'>"+$P.lang('LANG1291')+"</span>"});
        addCell(newRow, { html: "<span locale='LANG85'>"+$P.lang('LANG85')+"</span>", onclickFunction: function () { 
            top.dialog.dialogConfirm({
            confirmStr: $P.lang("LANG843").format($P.lang("LANG85")),
            buttons: {
                ok: function ()
                {
                    top.module.jumpMenu('users.html');
                },
                cancel: function ()
                {
                    top.dialog.clearDialog();
                }
            }
        });} });
        addCell(newRow, { html: "<span locale='LANG1298'>"+$P.lang('LANG1298')+"</span>"});
        addCell(newRow, { html: "<span locale='LANG1299'>"+$P.lang('LANG1299')+"</span>"});
        addCell(newRow, { html: "<span locale='LANG1295'>"+$P.lang('LANG1295')+"</span>"});
        addCell(newRow, { html: "<span locale='LANG1300'>"+$P.lang('LANG1300')+"</span>"});
        addCell(newRow, { html: "<span locale='LANG1301'>"+$P.lang('LANG1301')+"</span>"});
        addCell(newRow, { html: "<span locale='LANG74'>"+$P.lang('LANG74')+"</span>"});
    })();

    for (i = 1; i < devicelist.length - 1; i++)
    {
        if (filter == 'res')
        {
            if (devicelist[i].split("&")[6] == 1)
            {
                device_list(devicelist[i], i);
            }
        } else
        {
            device_list(devicelist[i], i);
        }
    }

    function device_list(buf, i)
    {

        var device = buf.split("&");
        if (!device[0])
        {
            return false;
        }

        var tmp = [];
        tmp[0] = "<button class='options edit' onclick=showEditForm(" + i +",'" + device[0] + "') localetitle=\"LANG738\" title=" + $P.lang("LANG738") + "></button>" + "<button class='options reboot' onclick=showProvWindow(" + i +",'" + device[0] + "') localetitle=\"LANG737\" title=" + $P.lang("LANG737") + "></button>" + 
                 "<button class='options del' onclick=\"DELETE_DEVICE('" + i + "','" + device[0] + "','" + device[1] + "')\" localetitle=\"LANG739\" title=" + $P.lang("LANG739") + "></button>";

        var newRow = TBL.insertRow(-1);
        
        var acct_ext_list = get_ext_strings(device[0], device[1]);               

        if (device[6] == 1)
        {
            newRow.className = 'ad';
        } else
        {
            newRow.className = ((TBL.rows.length) % 2 == 1) ? 'odd' : 'even';
        }
        
        addCell(newRow, { html: "<input type=checkbox  class='selected_extensions' value='" + i + "'>" });
        addCell(newRow, { html: i+' .' });
        addCell(newRow, { html: "<div class='device_mac'>" + device[0].toUpperCase() +"</div>"});
        addCell(newRow, { html: device[1] ? device[1] : '--' });
         
        addCell(newRow, { html: acct_ext_list});
        //addCell(newRow, { html: device[2] ? device[2] : '--' });
        addCell(newRow, { html: device[3] ? decodeURIComponent(device[3]).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;'): '--' , width:'100px;'});
        addCell(newRow, { html: device[7] ? device[7] : '--' });
        addCell(newRow, { html:   device[4] ? decodeURIComponent(device[4]).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;') :'--', width:'100px;' });
        var str = (device[5] > 0 && device[5] != 3) ? "LANG1302" : "LANG1303";
        addCell(newRow, { html: $P.lang(str) , locale: str });
        str = (device[5] == 6 || device[5] == 7) ? "LANG136" : "LANG137";
        addCell(newRow, { html:  $P.lang(str), locale: str});
        addCell(newRow, { html: tmp[0] });
/*        
        if(device[2].length > 0)
            assigned_accts.push(device[2]);
*/
    }
    
    
    
    top.Custom.init(document);
    
}

var RESET_DEVICE_FORM_FIELDS = function (a)
{ // RESET_DEVICE_FORM_FIELDS();
    var acct_num = 1;
    var editExtTable = document.createElement("table");    
    $("#edit_ext").append(editExtTable);
    
    if (isNewDEVICE == false)
    {
        var DEVICE_EDIT = a.split('&');
        var mac = DEVICE_EDIT[0];
        var ip = DEVICE_EDIT[1];
        var model_name = decodeURIComponent(DEVICE_EDIT[4]); 
        var enable_hotdesking = parseInt(DEVICE_EDIT[8]);
        //var acct_num = 1;        
        
        console.log("model name" + model_name);
        if( typeof mWindow.modelinfo[model_name] != "undefined" )
        {
            acct_num = mWindow.modelinfo[model_name];
        } 
        console.log("account num" + acct_num );
        
        ASTGUI.updateFieldToValue('new_mac', DEVICE_EDIT[0].toUpperCase());
        ASTGUI.updateFieldToValue('edit_ip', DEVICE_EDIT[1]);
        //ASTGUI.updateFieldToValue('edit_account', DEVICE_EDIT[2]);
        ASTGUI.updateFieldToValue('edit_version', decodeURIComponent(DEVICE_EDIT[3]));
        ASTGUI.updateFieldToValue('edit_model', decodeURIComponent(DEVICE_EDIT[4]));
        //ASTGUI.updateFieldToValue('edit_index', DEVICE_EDIT[8]);
                
        _$("new_mac").disabled = true;
        _$("edit_version").disabled = true;
        _$("edit_model").disabled = true;
        
        if (_$('new_mac').value == '000000000000')
        {            
            _$("edit_ip").disabled = true;
        }       
        
        for( var i = 1; i <= acct_num; i++ )
        {            
            var editExtTr = document.createElement("tr");
            var editExtTd = document.createElement("td");
            var editIndexTd = document.createElement("td");
            var labelIndex = document.createElement("span");
            var selectExt = document.createElement("select");
            selectExt.id = mWindow.selectExt_prefix + i;
            selectExt.size = '1';
            labelIndex.innerHTML = $P.lang('LANG1422') + " " + i + ":";
            labelIndex.className = "label";
            editIndexTd.appendChild(labelIndex);
            editExtTd.appendChild(selectExt);
            editExtTr.appendChild(editIndexTd);
            editExtTr.appendChild(editExtTd);
            editExtTable.appendChild(editExtTr);
            
            if(mWindow.assigned_accts.hasOwnProperty(mac+ip))
            {
                $.each(mWindow.assigned_accts[mac+ip], function(index, value) {
                    if(value.index == i)
                    {
                        ASTGUI.selectbox.append(mWindow.selectExt_prefix + i, value.extension, value.extension);
                        return false;
                    }
                    
                });
            }
            ASTGUI.selectbox.append(mWindow.selectExt_prefix + i, $P.lang('LANG133'), '');
            $.each(mWindow.unassigned_accts, function(index, value) {
                ASTGUI.selectbox.append(mWindow.selectExt_prefix + i, value, value);    
            });
            
        }   
        
        if(enable_hotdesking == 1)
        {
            _$("hotdesking").checked = true;
            disableAccountSelect();            
        }
        else
        {
            _$("hotdesking").checked = false;
            disableAccountSelect();
        } 
        //$("#edit_ext").append(editExtTable);
        
        
        /*
        for( var i = 1; i <= acct_num; i++ )
        {
            ASTGUI.selectbox.append('edit_index', 'Account ' + i, i);
        }
        */
        
        
        /*
        ASTGUI.updateFieldToValue('new_mac', DEVICE_EDIT[0].toUpperCase());
        ASTGUI.updateFieldToValue('edit_ip', DEVICE_EDIT[1]);
        //ASTGUI.updateFieldToValue('edit_account', DEVICE_EDIT[2]);
        ASTGUI.updateFieldToValue('edit_version', decodeURIComponent(DEVICE_EDIT[3]));
        ASTGUI.updateFieldToValue('edit_model', decodeURIComponent(DEVICE_EDIT[4]));
        //ASTGUI.updateFieldToValue('edit_index', DEVICE_EDIT[8]);
        
        _$("new_mac").disabled = true;
        _$("edit_version").disabled = true;
        _$("edit_model").disabled = true;
        
        if (_$('new_mac').value == '000000000000')
        {            
            _$("edit_ip").disabled = true;
        }
        */

    } else
    {
        //ASTGUI.selectbox.append('edit_index', 'Account ' + 1, 1);
        ASTGUI.updateFieldToValue('new_mac', '');
        ASTGUI.updateFieldToValue('edit_ip', '');
        //ASTGUI.updateFieldToValue('edit_account', '');
        ASTGUI.updateFieldToValue('edit_version', '');
        ASTGUI.updateFieldToValue('edit_model', '');
        //ASTGUI.updateFieldToValue('edit_index', '');
        $("#new_mac").removeAttr("readonly");
        $("#edit_ip").removeAttr("readonly");  
        
        for( var i = 1; i <= acct_num; i++ )
        {            
            var editExtTr = document.createElement("tr");
            var editExtTd = document.createElement("td");
            var editIndexTd = document.createElement("td");
            var labelIndex = document.createElement("span");
            var selectExt = document.createElement("select");
            selectExt.id = mWindow.selectExt_prefix + i;
            selectExt.size = '1';
            labelIndex.innerHTML = $P.lang('LANG1422') + " " + i + ":";
            labelIndex.className = "label";
            editIndexTd.appendChild(labelIndex);
            editExtTd.appendChild(selectExt);
            editExtTr.appendChild(editIndexTd);
            editExtTr.appendChild(editExtTd);
            editExtTable.appendChild(editExtTr);
                        
            ASTGUI.selectbox.append(mWindow.selectExt_prefix + i, $P.lang('LANG133'), '');
            $.each(mWindow.unassigned_accts, function(index, value) {
                ASTGUI.selectbox.append(mWindow.selectExt_prefix + i, value, value);    
            });
            
        }              
        
    }
    
    
    
};

var prepareAddItemForm = function ()
{ // prepareAddItemForm();

    isNewDEVICE = true;
    MAC_EDIT = '';
    zapchan_Before = '';

    RESET_DEVICE_FORM_FIELDS();
};

var prepareEditItemForm = function (a)
{ // prepareEditItemForm();
    isNewDEVICE = false;
    RESET_DEVICE_FORM_FIELDS(mWindow.devicelist[a]);

};

var getSelectedDevices = function ()
{ // getSelectedDevices();
    return mWindow.ASTGUI.domActions.get_checked('selected_extensions');
};

function res_delete(res)
{
    var buf = res.split("\r\n");

    if (buf[1] == "Delete OK!")
    {
        top.dialog.dialogMessage({
            type: 'success',
            content: $P.lang("LANG844"),
            callback: function () { mWindow.location.reload(); }
        });
    }
    else if(buf[1] == "Clear OK!")
    {
        top.dialog.dialogMessage({
            type: 'success',
            content: $P.lang("LANG844"),
            callback: function () { mWindow.location.reload(); }
        });
    }
    else
    {
        // [AH] Note: not sure what will return from buf[1], it should be error...
        //ASTGUI.feedback( { msg:buf[1], showfor:2, color:'#FF0000'} );
        top.dialog.dialogMessage({ type: 'error', content: buf[1] });
    }
}

var DELETE_DEVICE = function (i,a, b)
{ // DELETE_DEVICE();
    top.dialog.dialogConfirm({
        confirmStr: $P.lang("LANG818").format(i + ' . ' + a),
        buttons: {
            ok: function ()
            {
                var buf = "DoCgi=DeviceDelete&num=1&mac0=" + a + "&ip0=" + b;
                $.ajax({ type: "GET", url: "/database.zccgi", data: buf, success: res_delete });
            }
        }
    });
};

var DELETE_SELECTED_DEVICES = function ()
{ // DELETE_SELECTED_DEVICES();
    var sel_devices = getSelectedDevices();
    if (!sel_devices.length)
    {
        top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG848") });
        return;
    }

    top.dialog.dialogConfirm({
        confirmStr: $P.lang("LANG818").format(sel_devices.join(", ")),
        buttons: {
            ok: function ()
            {
                var buf = "DoCgi=DeviceDelete&num=" + sel_devices.length;
                var j;
                for (i = 0; i < sel_devices.length; i++)
                {
                    j = sel_devices[i];
                    buf += "&mac" + i + "=" + devicelist[j].split("&")[0] + "&ip" + i + "=" + devicelist[j].split("&")[1];

                }

                $.ajax({ type: "GET", url: "/database.zccgi", data: buf, success: res_delete });
            }
        }
    });
};

function res_reboot(res)
{
    // TODO: [AH] What msg will this be?
    var buf = res.split("\r\n");
    /*
    if (buf[1].match("Zero config is not running!"))
    {
         top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG845"),  callback: function () { mWindow.location.reload(); } });
    }
    else
    {
        top.dialog.dialogMessage({ type: 'success', content:  $P.lang("LANG846"), callback: function () { mWindow.location.reload(); } });
    }
    */
    
    if (buf[1].match("SUCCESS"))
    {
        top.dialog.dialogMessage({ type: 'success', content:  $P.lang("LANG846"), callback: function () { mWindow.location.reload(); } });
    }
    else
    {
         top.dialog.dialogMessage({ type: 'warning', content: $P.lang("LANG845"),  callback: function () { mWindow.location.reload(); } });
    }
}

function res_deviceupdate(res)
{
    var res = res.split("\r\n");
    if (res[1] == "Update OK!")
    {
        var mac = ASTGUI.getFieldValue('new_mac');
        if (res[2] == "sendnotify" && ASTGUI.getFieldValue('edit_ip') != '')
        {
            top.dialog.dialogConfirm({
                confirmStr: $P.lang("LANG847").format(mac),
                buttons: {
                    ok:  function (){$.ajax({ type: "GET", url: "/database.zccgi", data: "DoCgi=DownloadCfg&mac=" + mac, success: res_reboot });},
                    cancel:  function (){mWindow.location.reload();}
                }
            });
        }
        else
        {
            top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG844"), callback: function(){mWindow.location.reload();} });
        }
    }
    else
    {
        top.dialog.dialogMessage({ type: 'warning', content: res });
    }
}

var SAVE_DEVICE_FORM = function ()
{ // SAVE_DEVICE_FORM();
    var method;
    if (isNewDEVICE)
    {
        EXTENSION_EDIT = _$("new_mac").value;
        method = "&method=insert";
        isNewDEVICE = false;
    }
    else
    {
        method = "&method=update";
    }
    
    var acct_string = "";
    var acct_num = 0;
    var acct_arr = [];
    $("#edit_ext").find("select").each(function(index, el) {
        acct_num++;
        var el_id = $(el).attr('id');
        var el_id_arr = el_id.split('_');
        var value = $(el).val();
        if(value == "")
            value = "*";
        acct_arr[parseInt(el_id_arr[1])-1] = value;
        
        //acct_string = acct_string + "&" + $(el).attr('id') + "=" + $(el).val();
        //console.log(acct_string);        
    }); 
    
    if(_$('hotdesking').checked)
    {
        var mac = ASTGUI.getFieldValue('new_mac').toUpperCase();
        for(var i = 1; i < acct_num; i++ )
        {
            acct_string = acct_string + "*,";
            
        }
        acct_string = acct_string + "*";
        top.dialog.dialogConfirm({
            confirmStr: $P.lang("LANG2630").format(mac),
            buttons: {
                ok:  function () {
                     $.ajax({ 
                              type: "GET", 
                              url: "/database.zccgi", 
                              data: "DoCgi=DeviceUpdate" + method + "&mac=" + ASTGUI.getFieldValue('new_mac').toUpperCase() +
                                    "&ip=" + ASTGUI.getFieldValue('edit_ip') + 
                                    "&acctnum=" + acct_num + 
                                    "&account=" + acct_string + 
                                    "&version=" +  encodeURIComponent(ASTGUI.getFieldValue('edit_version')) + 
                                    "&model=" +  encodeURIComponent(ASTGUI.getFieldValue('edit_model')) +
                                    "&index=1", 
                              success: res_deviceupdate,     
                                  
                              
                              error: function (jqXHR, textStatus, errorThrown) { top.dialog.dialogMessage({ type: 'error', content: errorThrown }); }
                            });
                     },
                            
                cancel:  function (){mWindow.location.reload();}
            }
        });
        return;
    }   
    
    
    
    if(acct_arr.length > 0)
        acct_string = acct_arr.join();

    var buf = "DoCgi=DeviceUpdate" + method + 
              "&mac=" + ASTGUI.getFieldValue('new_mac').toUpperCase() +
              "&ip=" + ASTGUI.getFieldValue('edit_ip') + 
              "&acctnum=" + acct_num + 
              "&account=" + acct_string +
              "&version=" +  encodeURIComponent(ASTGUI.getFieldValue('edit_version')) + 
              "&model=" +  encodeURIComponent(ASTGUI.getFieldValue('edit_model')) + 
              "&index=0"; // + "&index=" + ASTGUI.getFieldValue('edit_index');

    $.ajax({
        type: "get",
        url: "/database.zccgi",
        data: buf,
        success: res_deviceupdate,
        /*
        function(res)
        {
            var res = res.split("\r\n");
            if (res[1] == "Update OK!")
            {
                var mac = ASTGUI.getFieldValue('new_mac');
                if (res[2] == "sendnotify" && ASTGUI.getFieldValue('edit_ip') != '')
                {
                    top.dialog.dialogConfirm({
                        confirmStr: $P.lang("LANG847").format(mac),
                        buttons: {
                            ok:  function (){$.ajax({ type: "GET", url: "/database.zccgi", data: "DoCgi=DownloadCfg&mac=" + mac, success: res_reboot });},
                            cancel:  function (){mWindow.location.reload();}
                        }
                    });
                }
                else
                {
                    top.dialog.dialogMessage({ type: 'success', content: $P.lang("LANG844"), callback: function(){mWindow.location.reload();} });
                }
            }
            else
            {
                top.dialog.dialogMessage({ type: 'warning', content: res });
            }
        },
        */
        error: function (jqXHR, textStatus, errorThrown) { top.dialog.dialogMessage({ type: 'error', content: errorThrown }); }
    });
};


var RESET_PROVISION = function()
{
    top.dialog.dialogConfirm({
        confirmStr: $P.lang("LANG2627"),
        buttons: {
            ok: function ()
            {
                var buf = "DoCgi=DeviceClear&field=account";
                $.ajax({ type: "GET", url: "/database.zccgi", data: buf, success: res_delete });
            }
        }
    });
}

var disableAccountSelect = function()
{
    var checked = _$("hotdesking").checked;
    if(checked)
    {
        $("#edit_ext").find("select").each(function(index, el) {
            $(el).attr("disabled", true);
        });
    }
    else
    {
        $("#edit_ext").find("select").each(function(index, el) {
            $(el).removeAttr("disabled");
        });
    }
    
}

