<?php

$resMsg = array
(
    "SUCCESS" => "Success!\r\n",
    "ERROR" => "Error Message: Error!\r\n",
    "NOT_READY" => "Error Message: Not yet implemented!\r\n",
    "INVALID_FILE_TYPE" => "Error Message: Invalid file type!\r\n",
    "INVALID_FILE_FORMAT" => "Error Message: Invalid file format!\r\n",
    "INVALID_PARAMETER" => "Error Message: Invalid parameter!\r\n",
    "NO_TARGET" => "Error Message: No target found!\r\n",
    "FILE_NOT_FOUND" => "Error Message: File not found!\r\n",
    "LIST_FAIL" => "Error Message: Can't get directory information!\r\n"
);

$dirList = array("dictate", "fax", "meetme", "monitor", "outgoing", "system", "tmp", "voicemail");



function getAllRecordFiles($root_dir) {
    global $resMsg;
    global $dirList;
    //$root_dir = "./udata/"
    $real_dir = "";
	$result = "";
	foreach($dirList as $dir) {
	    $file = $root_dir.$dir;
	    if(is_dir($file))
	    {
		    $real_dir = $file;
	    }
	    else if(is_link($file))
	    {
		    $target = readlink($file);
		    if($target == false)		        
		        continue;	    
		    else if(is_dir($target))
			    $real_dir = $target;
			else 
			    continue;
	    }	    
	
	    if(strlen($real_dir) > 0)
	    {
		    $array = scandir($real_dir);
		    if($array == false)
		        continue;
		    for( $i = 0; $i < sizeof($array); $i++ )
		    {
		        if(strstr($array[$i], ".wav") == FALSE)
		            continue;
		        $result = $result.$array[$i].",";
		    }
        }
    }
    echo $result;
}

function findFile($filename, $dir) {
    global $resMsg;
    $file = $dir."/".$filename;
	$result = "";
	$real_file = "";
	if(strlen($file) == 0)
	{
		echo $resMsg["INVALID_PARAMETER"];
		return;
	}
	
	if(is_dir($file))
	{
	    echo $resMsg["INVALID_FILE_TYPE"];
	    return;
	}
	else if(is_link($file))
	{
		$target = readlink($file);
		if($target == false)
		{
			echo $resMsg["NO_TARGET"];
		    return;
		}
		else if(is_dir($target))
		{
		    echo $resMsg["INVALID_FILE_TYPE"];
		    return;
	    }
	    else if(is_file($target))
	        $real_file = $target;
	    else
	    {
	        echo $resMsg["FILE_NOT_FOUND"];
		    return;
	    }
	}
	else if(is_file($file))
	{
		$real_file = $file;
	}
	else
	{
	    echo $resMsg["FILE_NOT_FOUND"];
		return;
	}
	
	if(strlen($real_file) > 0)
	    echo $resMsg["SUCCESS"];
	else    
	    echo $resMsg["ERROR"];
	
}

function findFileFromDir($filename, $root_dir) {
    global $resMsg;
    global $dirList;    
	$result = "";
	$real_file = "";
	$type = "";
	foreach($dirList as $dir) {
	    $file = $root_dir.$dir."/".$filename;
	    if(is_dir($file))
	        continue;    
	    else if(is_link($file))
	    {
		    $target = readlink($file);
		    if($target == false)
		        continue;
		    else if(is_dir($target))
		        continue;
	        else if(is_file($target))
	        {
	            $real_file = $target;
	            $type = $dir;
	            break;
	        }
	        else
	            continue;
	    }
	    else if(is_file($file))
	    {
		    $real_file = $file;
		    $type = $dir;
		    break;
	    }
	    else
	    {
	        continue;
	    }
	}
	
    if(strlen($real_file) > 0 && strlen($type) > 0)
        echo $resMsg["SUCCESS"].",".$type;
    else    
        echo $resMsg["ERROR"];
    
	
}

if($_GET["type"] == "cdr" && array_key_exists("file", $_GET))
{
    findFile($_GET["file"], "./config");
}
else if($_GET["type"] == "cdr" && array_key_exists("voicefile", $_GET))
{
    findFileFromDir($_GET["voicefile"], "./udata/");
}
else if ($_GET["type"] == "cdr") //&& array_key_exists("id",$_GET))
{
	getAllRecordFiles("./udata/");
}

?>
